#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

#####
# linkage.cgi
#
# RF 981106 to manage linkages
#####

$script_version="Version 4 - 20000914";

#####
# Version 5 TG 20000918
#    Changed ReadParse2 to ReadParse
# Version 4 TG 20000914
#    Changed subroutine parameters of library functions that were
#    changed to meet development standards
# Version 3 TG 20000913
#    Changed subroutine parameters of library functions that were
#    changed to meet development standards
# Version 2 TG 20000912
#    Changed subroutine parameters of library functions that were
#    changed to meet development standards
# Version 1 TG 20000823
#    Retrofit to meet development standards
# Version 0.9.24 TG 20000817
#    Added generate_triggers
# Version 0.9.23 TG 20000811
#    Added previous_error flag under objid check
# Version 0.9.22 TG 20000803
#    Fixed alttitle bug with modifying
# Version 0.9.21 TG 20000801
#    Fixed SQL statements, added pagestyle to linkage screen for main product
#    getPageStyleText subroutine
# Version 0.9.20 TG 20000725
#    Cleared obj1_pre on refresh of home
# Version 0.9.19 TG 20000719
#    Removed relpath from get_fields_and_title call to fix variant titles
#    in linkage and title page
# Version 0,9.18 IB 20000717
#    $om_render_language->$om_render_lang
# Version 0.9.17 TG 20000707
#    Changed search error message to be consistent with
#    other managers, documented and cleaned up debug
# Version 0.9.16 TG 20000706
#    Fixed allowing ' in alttitle
# Version 0.9.15 TG 20000705
#    Only allow editing of links for particular language
# Version 0.9.14 TG 20000630
#    Fixed linkage to be able to change alttitle and weight
# Version 0.9.13 TG 20000629
#    Fixed title for variant products on main page, fixed linkage validation
#    to verify that it isn't already linked.  Allow to clear alttitle and weight
# Version 0.9.12 TG 20000628
#    Fixed check_login to go to login screen if not logged in
# Version 0.9.11 IB 20000608
#    language and interface from table 'sessions'
# Version 0.9.10 TG 20000606
#    Fixed sorting of weights - removed sortlinks, as the routine to use is in formtools
#    Added alttitle, and celldepth support, just validate if celldepth is an integer
#       KNOWN BUGS:
#             If you put invalid input in the new links, especially in the weight field,
#             the error message shows up in other rows.  This is because of sortlinks which
#             is based on the weight.  The sortlinks routine should ONLY sort the linked links,
#             not any new, unvalidated entries!
# Version 0.9.9 TG 20000531
#    removed variant support and put into variant.pm library
#    replaced calls directly to get the title with library call get_fields_and_title
## Version 0.9.8 IB 20000531
 #    added custom-lib.pm
# Version 0.9.7 TG 20000531
#    fixed validate objid for the linked object
#    fixed cell linkage problems
#    fixed linkage entries to include status
#    fixed levents to add the series
#    added variant support for linkage
#    put debug in with debug flag
# Version 0.9.2 GF 20000524
#    check_login commented out
# Version 0.9.1 IB 20000502
#    introduced $script variable
# Version 0.7.21 IB 20000420
#    set->SET
# Version 0.7.20 IB 20000411
#    eliminated ERLOK (probably misspelled ERLOG)
# Version 0.7.19 JC 20000410
#    multilingual messages
# Version 0.7.18 IB 20000402
#    new directory structure
# Version 0.7.17 IB 20000330
#    changed connect statement
# Version 0.7.16 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.15 20000327
#    corrected $relpath
# Version 0.7.14 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.13 20000302
#    updated copyright
# Version 0.7.12 20000228
#    changed store to site
# Version 0.7.11 20000124 KMS
#    addes storename NVI to Merchandise Manger template routine.
# Version 0.7.10 991202 IB\GF
#    fixed problem regarding CELLSTYLE sel
# Version 0.7.9 991201 IB
#    fixed global names
# Version 0.7.8 991126 IB
#    fixed script version number
# Version 0.7.7 991121 IB
#    corrected bits to bits/site/sel
# Version 0.7.6 991112 IB
#    corrected the determining of a relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.5 991109 IB
#    removing of HACKS, and correcting of relpath
# Version 0.7.4 991107 IB
#    removed redundant statement
# Version 0.7.3 991103 IB
#    general cleanup
# Version 0.7.1 990713 GF
#    revised for system 6 structure
#
#####
##############################################################################
=pod

=head1 linkage.cgi

inventory.cgi - Merchandise Manager script

=head1 SYNOPSIS

http://YOURDOMAIN/cgi-bin/om/admin/linkage.cgi

=head1 DESCRIPTION

This script is responsible for displaying and submitting information for
linking objects to other object pages

=head1 NOTES & BUGS

=cut
###############################################################################
use strict;

&main();

##############################################################################
=pod

=head2 main

main - &main();

=over 4

=item DESCRIPTION

The main driver is responsible for determining the flow of the linkage
script.  It displays all pages dependant on the mode that is passed
in by the FORM.  The templates are loaded dependant of the mode and the mode
is changed to prepare for submission after it is loaded.  Handles search,
add/modify links.

=item INPUT

NONE

=item OUTPUT

The FORM is populated and the display is posted according the the choices made
by the user.

=item NOTES

The main processing of the FORM data is done in os_allcommerce/lib/linkage.pm

=back

=cut
###############################################################################
sub main {
    my ($q, $numRows, @pulldowns, $v, $l, $spine);
    my ($select_hash, $i, $x, $ip, $ix, $checkVarObjid);
    my (@temp, $target, $pagetemplate);
    my ($site, $dbh, @links, %NVP, %FORM);
    
    
    ($site, $dbh, %FORM) = &initscript();
    
    ## start the replacements hash
    #
    %NVP=();
    $NVP{'sitename'}=$site->{'sitename'};
    
    if ($FORM{'obj1'} && $FORM{'obj1'} ne "__obj1_pre__" ) {
    $FORM{'obj1_pre'}=$FORM{'obj1'};}
    else {
        $FORM{'obj1_pre'}="";
    }
    
    $NVP{'obj1_pre'}=$FORM{'obj1_pre'};
    
    ## filled in with time
    #$nicedt=nicedatetime();
    
    if (! $FORM{'mode'}) {
        $FORM{'mode'}="home";
    }
    
    ## login control
    #
#    $FORM{'sid_ok'} = check_login($site->{'script'},$FORM{'mode'},$FORM{'sid'});
    $FORM{'sid_ok'} = check_login($site, $dbh);
    &debug("Form mode is $FORM{'mode'}",3,$site->{'debug_level'}, $site->{'debug_log'});
    
    if ( $FORM{'sid_ok'} ) {
        if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
            ## hard error, redirected to login page
            print "Location: /cgi-bin/om/admin/login.cgi\n\n";
            
            } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
            ## soft error, send to default mode
            $FORM{'mode'}="home";
            $NVP{'__PAGE_ERROR_MSG__'}=$FORM{'sid_ok'};
            
            } else {
            # welcome to the page
        }
        
        ## script outputs to html
        #
        print "Content-type: text/html\n\n";
    }
    
    &debug("form mode is now $FORM{'mode'}",3,$site->{'debug_level'}, $site->{'debug_log'});
    
    if ($FORM{'mode'} eq "submitlink" ) {
        &loadObjidToNVP( $FORM{'obj1'},$dbh,$site,\%NVP );
        ## load linkage information from form
        #
        $FORM{'loadfrom'}="form";
        @links=&loadlinkages( $FORM{'loadfrom'}, $FORM{'obj1'}, $site, \%FORM, $dbh );
        @links = &modifyLinkages(\%FORM, $site, $dbh, @links);
        if ($FORM{'regenerate_inp'} == 1) {
            &debug("Going into generate triggers for $FORM{'obj1'}",3,$site->{'debug_level'}, $site->{'debug_log'});
	    &generate_specific($FORM{'obj1'}, $site, $dbh);
        }
    } #/submitlink
    
    if ($FORM{'mode'} eq "editlink" ) {
        
        $x = ValidateOBJID($FORM{'obj1'}, $site, $dbh);
        
        if ( ! $x ) {                         # object exists!
            
            ## load primary sku's data to NVP
            &loadObjidToNVP( $FORM{'obj1'}, $dbh,$site, \%NVP );
            
            ## now load linkage information
            #
            $FORM{'loadfrom'}="db" if (! $FORM{'loadfrom'} );
            
            @links=&loadlinkages( $FORM{'loadfrom'}, $FORM{'obj1'}, $site, \%FORM, $dbh );
            
            for ( $i=0; $i<=$#links; $i++ ) {
                @temp=sort keys %{$links[$i]};
                while (@temp) {
                    $x=shift @temp;
                }
            }
            
            } else {                              # sku was bad
            $FORM{'mode'}="home";
            $FORM{'obj1_err'}=$site->{'script_msg'}{$x};
        }
    } #/editlink
    
    ## last moment mode changes
    #
    if ( $FORM{'mode'} eq "submitlink" ) {
        $FORM{'mode'}="editlink";
    }
    
    ## populate deterministic NVP elements
    #
    &populate_nvp($site, \%NVP, \%FORM);
    
    
    #################################################################
    ## display routine for form modes
    #
    if ($FORM{'mode'} eq "editlink" ) {
        &setupEditLink($site, $dbh, \%NVP, \%FORM, @links);
        } else  {                                          # default to show search
        
        ## locate and load the primary page template
        #
        $target="os_allcommerce-"."linkage-home";
        
        $NVP{'obj1_pre'}="";   # clear search field on home
        
        $pagetemplate=loadtemplate($target,"/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/admin");
        # populate template
        $pagetemplate = permutebit( $pagetemplate, \%NVP );
        $pagetemplate = permuteclean( $pagetemplate);
        $pagetemplate=~ s/__sid__/$site->{'sid'}/g;
        
        
        # spew template
        print $pagetemplate;
        print "\n";
    }
    
    ## terminal cleanup
    #
    
    $x = $dbh->disconnect if ( $dbh );
}

##############################################################################
=pod

=head2 setupEditLink

setupEditLink - &setupEditLink($site, $dbh, \%NVP, \%FORM, @links);

=over 4

=item DESCRIPTION

Sets up and displays the edit link page from the information in @links

=item INPUT

$site - A hashref containing information required throughout about the current site and session

$dbh - Current open database handle

$NVP - A temporary hashref to hold information to update the next FORM to be displayed

$FORM - Hashref to the current page that is displayed.

@links - Array of hashrefs, each being an existing link, or a new link

=item OUTPUT

Changes the form to editlink mode and prints the edit link template

=item NOTES

=back

=cut
###############################################################################
sub setupEditLink {
    my ($site) = shift;
    my ($dbh) = shift;
    my ($NVP) = shift;
    my ($FORM) = shift;
    my (@links) = @_;
    
    my ($vcodeq, $numVrows, @res, $h2, $k2, @temp, $target, $pagetemplate);
    my ($regenerate_template, @rs_CELLSTYLE, @rs_CELLDEPTH, $res, @rownames);
    my ($thisrow, $rowval, $rowtemplate, $errortrap, $k, $i, $product_select);
    
    $target="os_allcommerce-".$site->{'script'}."-".$$FORM{'mode'};
    $pagetemplate =
    loadtemplate($target,$site->{'skeletonpath'});
    $regenerate_template = loadtemplate("row_regenerate", $site->{'skeletonpath'});
    if ($site->{'generate_default'} == 1) {
        $regenerate_template =~ s/__regenerate_inp__/ CHECKED/gms;
    }
    $pagetemplate =~ s/__row_regenerate__/$regenerate_template/gms;
    $pagetemplate =~ s/__COLSPAN__/COLSPAN=2/gms;
    
    open FH, "<$site->{'selskeletonpath'}/sel_cellstyle.sel";
    @rs_CELLSTYLE = <FH>;
    
    #    @links = sortlinks(@links);

    $product_select->{'FIELDS'}->{'pagestyle'} = "pagestyle";
    $res = &get_fields_and_title($product_select,$$FORM{'obj1'},$dbh, undef, $site);
    if ($res) {
        $$NVP{'title'} = $res->{'title'};
        $$NVP{'pagestyle'} = &getPageStyleText($res->{'pagestyle'}, $site);
    } #
    &debug("OBJID Is $$FORM{'obj1'}, $$NVP{'title'}, $$NVP{'pagestyle'}",3,$site->{'debug_level'}, $site->{'debug_log'});
    @rownames=( "row_linkageed_a","row_linkagenew_a" );    # manual stub
    
    ## expand row entries
    #
    while (@rownames) {
        
        $thisrow=shift @rownames;
        
        $target=$thisrow;   # compute from $rownames[$i]
        $rowval="";
        
        $rowtemplate=loadtemplate( $target, "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/admin" );
        ## run through each linkage...
        #
        $errortrap="";
        for ( $i=0; $i<=$#links; $i++ ) {
            if ($links[$i]->{'obj2_err'}) { $errortrap ="yes";}
            
            ## skip links not relevant to this row group
            
            next if ( ( $thisrow =~ /new_/ )
            and ( $links[$i]->{'objid'} !~ /newrow/ ) );
            
            next if ( ( $thisrow !~ /new_/ )
            and ( $links[$i]->{'objid'} =~ /newrow/ ) );
            ## append to processed template to growing rowval
            #     move linkage row data forward first
            
            $links[$i] = &agelink($links[$i]);
            $links[$i] = &linksafehtml( $links[$i] );
            
            ## construct pulldowns as hashref entries
            #
            $links[$i]->{'CELLSTYLE_SELECT'} =
            gen_select( $links[$i]->{'cellstyle_inp'},5,@rs_CELLSTYLE );
            @temp = sort keys %{$links[$i]};
            
            while (@temp) {
                
                $k = shift @temp;
                
            } # done dumping linkage to logfile
            #
            
            $rowval.=permutebit( $rowtemplate, $links[$i]);
            
            &debug("PREVIOUS ERROR IS $links[$i]->{'previous_error'}",3,$site->{'debug_level'}, $site->{'debug_log'});
            
            $rowval =~ s/__previous_error__/$links[$i]->{'previous_error'}/;
            
        }
        ## now substitute back into page template
        #
        $thisrow="__".$thisrow."__";
        $pagetemplate =~ s/$thisrow/$rowval/gs ;
    }
    
    ## override anything inherited for these vars:
    #
    $$NVP{'mode'}="submitlink";
    $pagetemplate = permutebit( $pagetemplate, $NVP );
    $pagetemplate = permuteclean( $pagetemplate);
    $pagetemplate=~ s/__sid__/$site->{'sid'}/g;
    $pagetemplate=~ s/__obj1_pre__/$$FORM{'obj1'}/g;
    print $pagetemplate;
    print "\n";
}

######################### INITIALIZATION SUBROUTINES #######################

##############################################################################
=pod

=head2 initscript

initscript - (%FORM, $site, $dbh) = &initscript();

=over 4

=item DESCRIPTION

Determine the relative path, and set up the script's environment and variables

=item INPUT

none

=item OUTPUT

$site - A hashref containing information required throughout about the current
site and session

$dbh - current active database handle

%FORM  - A ReadParse version of the FORM to start with

=item NOTES

=back

=cut
###############################################################################
sub initscript {
    my ($s, @temp, @rpath, $rundir, $siteshortname, $u, $scriptname, $relpath);
    my (%FORM, $k, $dbh, $site);
    
    ## determine path from store (site) root and store db name...
    #
    #  note - this script runs at server root or in cgi-bin/om/admin,
    #    generally. Test these conditions first.
    #  $0 - may not contain a full path, bootstrap with "pwd"
    #
    if ( $0 !~ /^\// ) {  # $0 is not an absolute path
        $s=`pwd`;          # hope pwd on path...
        chomp $s;
        $s.="/$0";
        } else {              # $0 IS an absolute path
        $s=$0;
    } # done determining if $0 is relative or absolute
    @temp=split /\//, $s;
    
    @rpath=@temp;
    
    $scriptname = pop @rpath;
    $scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff
    
    $rundir= join "/", @rpath;
    chdir( $rundir );
    
    $relpath="";
    $siteshortname="";
    ## short circuit if $s does not contain cgi-bin
    if ( $s !~ /cgi-bin/ ) {
        $siteshortname = pop @rpath;
        $relpath=".";
        @temp=();
    } # done testing for degenerate case
    
    while ( @temp ) {
        $u = pop @temp;
        
        ## skip references to the present directory
        next if ( $u eq '.' );
        next if ( length($u)==0 );        # skip null directory levels
        
        $relpath.="/.." if ( $relpath);
        $relpath.="." if ( ! $relpath );
        
        if ( $u eq "cgi-bin" ) {
            $siteshortname = $temp[$#temp];
            @temp=();
        } # note - cgi-bin is off the site root, so the next up is site root
        
    } # done constructing relative path to store root
    
    $relpath .= "/../$siteshortname";
    ($site, $dbh, %FORM) = &initsite($scriptname, $relpath);
    #    foreach $k (keys %FORM) {
    #        &debug("$k is $FORM{$k}",3, $site->{'debug_level'}, $site->{'debug_log'});
    #    }
    
    return ($site, $dbh, %FORM);
}

##############################################################################
=pod

=head2 initsite

initsite - ($site, $dbh, %FORM) = &initsite($scriptname, $relpath);

=over 4

=item DESCRIPTION

The init site loads in all required library modules and creates the variables
that are required throughout the script.

=item INPUT

$scriptname - The name of the script (linkage.cgi)

$relpath - The relative path to files that must be required

=item OUTPUT

$site - A hashref containing information required throughout about the current
site and session

$dbh - current active database handle

%FORM  - A ReadParse version of the FORM to start with

=item NOTES

To add parameters that need to be passed around to a lot of locations, add them
to the $site hashref.

To change the debug of the script, change $site->{'debug_level'} to one of the
following values:

0 - no debug

1 - errors only

2 - all SQL statements, warnings & errors

3 - all of the above

To change the location of the debug log, change the value of $site->{'debug_log'}.
Be sure to start it will >> to allow appending to the file.  To set the Generate
Page? button to be selected by default, change the $site->{'generate_default'} to
1.  To have it non-selected by default, change the $site->{'generate_default'}
to 0.

=back
=cut
###############################################################################
sub initsite {
    my ($scriptname) = shift;
    my ($relpath) = shift;
    
    my ($find, $q, $interface, $sts, $h, $x, @temp, $n, $k);
    my ($session_lang, $script, $FORM, $site, $dbh);
    my ($select_hash, $q2);
    
    use DBI;
    require "$relpath/lib/variant.pm";
    require "$relpath/lib/cgi-lib.pm";
    require "$relpath/lib/blowfisher.pm";
    require "$relpath/lib/conversions.pm";
    require "$relpath/lib/filetools.pm";
    require "$relpath/lib/formtools.pm";
    require "$relpath/lib/login.pm";
    require "$relpath/lib/validate.pm";
    require "$relpath/lib/objects.pm";
    require "$relpath/conf/site.pm";
    require "$relpath/lib/localization.pm";
    require "$relpath/lib/generate.pm";
    require "$relpath/lib/permission_layer.pm";
    require "$relpath/lib/db_layer.pm";
    require "$relpath/lib/linkage.pm";
    
    # must be the last require statement
    require "$relpath/lib/custom-lib.pm";
    
    ## establish site-specific parameters
    #
    $site=setsite();
    
    ## get form data, if any was submitted
    #
    $FORM = &ReadParse();
    $$FORM{'sid'} = &decrypt_sid($$FORM{'sid'}, $site);
    $site->{'sid'}=$$FORM{'sid'};
    
    $find=$$FORM{'skuskel'};
    if (!$find) {$find=$$FORM{'keyword'};}
    
    ## connect to database
    # system 6 database state, products, and customer tables are collapsed
    #
    $q = "$site->{'db_site_config'}";
    $dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});
    
    $site->{'om_render_lang'} = "";
    $interface = "";
    
    if ($$FORM{'sid'}) {
	$select_hash = {};
	$select_hash->{'TABLE'}->{'NAME'} = "sessions";
	$select_hash->{'TABLE'}->{'FIELDS'}->{'language'} = "language";
	$select_hash->{'TABLE'}->{'FIELDS'}->{'interface'} = "interface";
	$select_hash->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("sid", $$FORM{'sid'}, "and");
	$q = &build_select($select_hash, $site, $dbh);
        $sts = $dbh->prepare( $q );
        $sts->execute;
        $h=$sts->fetchrow_hashref('NAME_lc');
        $site->{'om_render_lang'}=$h->{'language'};
        $session_lang = $h->{'language'};
        $interface=$h->{'interface'};
    }
    
    $site->{'om_render_lang'}=$site->{'om_locale_lang_def'} if ( ! $site->{'om_render_lang'} );
    $site->{'om_render_lang'}="eng" if ( ! $site->{'om_render_lang'} );
    $session_lang="eng" if ( ! $session_lang );
    $interface="html" if ( ! $interface );
    
    ## load messages
    $script=( split /\./, $scriptname )[0];
    #   &initClassAndType();
    
    ## done with pull-from-file bits, rest of global settings...
    #
    $x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
    @temp=split /\//, $x;
    @temp=("cgi-bin","test","linkage.cgi") if (! $ENV{'REQUEST_URI'} );
    
    $script=( split /\./, $scriptname )[0];
    $n= $#temp - 1;
    
    # Configure all parameters to pass around in $site hash
    $site->{'selskeletonpath'} = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/html/sel";
    $site->{'skeletonpath'} = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/admin";
    $site->{'scriptpath'} = join "/", ( @temp[0..$n] );
    $site->{'script'} = ( split /\./, $scriptname )[0];
    $site->{'scriptname'} = $scriptname;
    $site->{'relpath'} = $relpath;
    $site->{'debug_level'} = 3;
    $site->{'debug_log'} = ">>/tmp/linkage";
    $site->{'sid'} = $site->{'sid'};
    ($site->{'OBJCLASSES'}, $site->{'OBJTYPES'}) = &getClassesAndTypes();
    $site->{'STATUS_TXT'} =  &loadseltomem("sel_status", $site->{'selskeletonpath'});
    $site->{'session_lang'} = $session_lang;
    $site->{'scriptinfo'} = "$site->{'scriptpath'}/$site->{'scriptname'}";
    $site->{'script_msg'} = &message($site);
    ## blankrows are the number of new linkage rows to
    #     display at bottom of a linkage editing page
    $site->{'blankrows'} = 3;
    
    # Flag, set to 0 to have default for Generate page? as no, and
    # set to 1 to have default as yes
    $site->{'generate_default'} = 0;
    
    &debug("Debuggin linkage.cgi...",3, $site->{'debug_level'}, ">/tmp/linkage");
    
    return ($site, $dbh, %{$FORM});
}

##############################################################################
=pod

=head2 message

message - $site->{'script_msg'} = &message($site);

=over 4

=item DESCRIPTION

To support multiple languages, all error messages need to be stripped out of
the script and translated to different languages.  This routine loads in the
messages for the $site->{'om_render_lang'} that is currently active.

=item INPUT

$site - A hashref containing information required throughout about the current
site and session

=item OUTPUT

A reference to the %script_msg hash of messages that need to be used in the
script

=item NOTES

=back

=cut
###############################################################################
sub message {
    my ($site) = shift;
    
    my (@temp);
    my (%script_msg);
    
    # check the language that is being used and open appropriate
    # message language file or get messages below
    if ($site->{'om_render_lang'} eq "eng" ) {
        $script_msg{1}="evaluates as";
        $script_msg{INVALID_OBJ}="Nothing found!  Please try another search";
        $script_msg{NO_OBJ}="You must specify an object to link to!";
        $script_msg{NO_ALT_FOR_VARIANT}="You cannot enter an alternate title for a variant product";
        $script_msg{NO_PAGESTYLE}="not defined for this Object ID";
        $script_msg{ALREADY_LINKED}="is already linked!";
        $script_msg{ERROR} = "Error -";
        $script_msg{OBJECT} = "Object";
        } else {
        open( EM, "<$site->{'relpath'}/bits/$site->{'om_render_lang'}/system/$site->{'script'}.messages");
        while(<EM>) {
            chomp;
            next if /^\#/;
            next if (! $_);
            @temp=split /\t/;
            $script_msg{$temp[0]}=$temp[1];
        }
        close(EM);
    }
    return \%script_msg;
}

1;
