#!/usr/bin/perl 
############################################################################
#    Copyright (C) 1999-2000 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

#####
# login.cgi
# user login/logout validation script
#
#
# written on 981022 RF 
#####

####
# Version 2 TG 20000918
#    Changed ReadParse2 to ReadParse
# Version 1 NC 20000915
#    use strict and add pod      
# Version 0.7.26 JC 20000913
#    oracle port
# Version 0.7.25 JC 20000807
#    added case sensitive login/passwd check
# Version 0.7.24 JC 20000717
#    removed multilingual select for next version 
#    $om_render_language->$om_render_lang
# Version 0.7.23 JC 20000706
#    added multilingual select
# Version 0.7.22 IB 20000608
#    language and interface from table 'sessions'
# Version 0.7.21 IB 20000531
#    added custom-lib.pm
# Version 0.7.20 GF 20000522
#    retrofit of templates for allcommerce
#    added objclass and objtype
#    repaired query for session update
# Version 0.7.18 IB 20000409
#    determine the language
# Version 0.7.17 JC 20000407
#    added message subroutine
# Version 0.7.16 IB 20000402
#    new directory structure
# Version 0.7.15 JC 20000330
#    changed connect statement
# Version 0.7.14 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.13 IB 20000327
#    corrected $relpath
# Version 0.7.12 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.11 IB 20000302
#    updated copyright
# Version 0.7.10 IB 20000228
#    changed store to site
# Version 0.7.9 20000117 GF
#    replace calls to newsid with setsessionid   
#    remove error logging
# Version 0.7.8 991210 GF
#    added in om_version detection
# Version 0.7.7 991126 IB
#    fixed script version number
# Version 0.7.6 991124 IB
#    corrected database call
# Version 0.7.5 991121 IB
#    corrected bits/sel to bits/site/sel
# Version 0.7.4 991112 IB
#    corrected the determining of a relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.3 991108 IB
#    removing of HACKS, and correcting of relpath
# Version 0.7.2 991103 IB
#    general cleanup
# Version 7 990617 GF
#    fixed to work with system 6 file system 
####

use strict;

&main();


##############################################################################
=pod

=head2 main

main - &main();

=over 4

=item DESCRIPTION

This function is responsible for logining users. It will check if the user id and paaswrad are valid and match, and give error message if any error occours during the login process.  

=item INPUT

NONE

=item OUTPUT

NONE

=item NOTES

The main processing of the report is done in os_allcommerce/cgi-bin/om/admin/login.pl

=back

=cut
###############################################################################
sub main {

    my ($site, $dbh, %FORM) = &initscript();

    my ($language_select) = &get_language_pulldown($site);
    my ($system_select) = &get_system_pulldown($site);

    ## filled in with time/context variable info
    #
    my $nicedt=nicedatetime();
    my $timenow=time();

    ## construct some shorthands
    #
    my $script_html = join "-", ($site->{'siteshortname'},$site->{'script'},"");
    my $skeltarg = $script_html;
       $skeltarg="os_allcommerce-login-";

    ## initial population of %NVP
    #
    my %NVP=();
    $NVP{'datetime'}=$nicedt;
    $NVP{'script'}="$site->{'scriptpath'}/$site->{'scriptname'}";
    $NVP{'scriptpath'}="$site->{'scriptpath'}";
    $NVP{'script_version'}=$site->{'script_version'};
    $NVP{'cookie'}=$ENV{'HTTP_COOKIE'};
    $NVP{'sitename'}=$site->{'sitename'};
    $NVP{'om_version'}=$site->{'om_version'};
    $NVP{'language_select'}=$language_select;
    $NVP{'system_select'}=$system_select;

    $FORM{'mode'}="login" if (! $FORM{'mode'} );


    ## check to see that there is a cookie or session ID
    #
    if (! $FORM{'sid'} ) {
       my $sid=setsessionid($site, $dbh, %FORM);
    }

    ## this script always dumps to html 
    #
    #print "Content-type: text/html\n\n";


    # validate session 
    # if not, new

    if ( $FORM{'mode'} != /^(submitlogin|login)/ ) {
        $FORM{'sid_ok'}=check_login($site->{'script'},$FORM{'mode'},$FORM{'sid'});

    } else {
        $FORM{'sid_ok'}="yes";
    }

    my ($q, $sti, $num, $lng);
    my ($objid,$uname,$passwd,$mdate);

    if ( $FORM{'mode'} eq "submitlogin" ) {         # preprocessing data
                                                    # login attempt, 
                                                    # check submitted information
       ## see if this user is in contacts
       #
       $q = "SELECT objid,uname,passwd,mdate from contacts where ";
       $q.= "passwd='$FORM{'passwd_inp'}' and ";
       $q.= " uname='$FORM{'uid_inp'}' and objclass='128-A' ";
       $q.= " and objtype='39004-A' and status='15000-A' ";
       $sti = $dbh->prepare( $q );
       $sti->execute;

       ## case sensitive
       #
		 if (!$FORM{'sid'})  { 
			 $NVP{'PAGE_ERROR_MSG'}=$site->{'script_msg'}{3}; 
			 $FORM{'mode'} = "login";
		 }
       elsif ( ($objid,$uname,$passwd,$mdate)=$sti->fetchrow ) {
          if ( ( $uname eq $FORM{'uid_inp'} ) && ( $passwd eq $FORM{'passwd_inp'} ) ) {
             ## case sentive check ok 
          } 
       } 
		 else {                                     # not a valid login

          $NVP{'uid_err'}=$site->{'script_msg'}{1};
          $NVP{'uid_pre'}=$FORM{'uid_inp'};
          $NVP{'PAGE_ERROR_MSG'}=$site->{'script_msg'}{2};
          $FORM{'mode'} = "login";
       }
		 #if there's no pulldown, set it to allcommerce login as default
		 unless ($FORM{'sys'}) { $FORM{'sys'} = "all"; }


       if ( !$NVP{'PAGE_ERROR_MSG'} && $FORM{'sys'} eq "all") {                             #  Successful login!

          ## get language from select
          #
          $lng=$FORM{'lang'};

          ## now update sessions
          #
          $q = "UPDATE sessions SET custid='$objid',mdate='$timenow',language='$lng' where";
          $q.= " sid='$FORM{'sid'}'";
       	 $sti = $dbh->prepare( $q );
       	 $sti->execute;
       #   $sti = $dbh->do( $q );

          ## now update the last login data
          #
          $q = "UPDATE contacts SET mdate='$timenow' where ";
          $q.= "passwd=('$FORM{'passwd_inp'}') and ";
          $q.= " uname='$FORM{'uid_inp'}' and objclass='128-A' and ";
          $q.= " objtype='39004-A'";
       	 $sti = $dbh->prepare( $q );
          $sti->execute;
       #   $sti = $dbh->do( $q );

          $FORM{'mode'} = "main";

       } 
		 elsif ($FORM{'sys'} eq "wms") {
		 	
          ## get language from select
          #
          $lng=$FORM{'lang'};

          ## now update sessions
          #
          $q = "UPDATE sessions SET custid='$objid',mdate='$timenow',language='$lng' where";
          $q.= " sid='$FORM{'sid'}'";
       	 $sti = $dbh->prepare( $q );
       	 $sti->execute;
       #   $sti = $dbh->do( $q );

          ## now update the last login data
          #
          $q = "UPDATE contacts SET mdate='$timenow' where ";
          $q.= "passwd=('$FORM{'passwd_inp'}') and ";
          $q.= " uname='$FORM{'uid_inp'}' and objclass='128-A' and ";
          $q.= " objtype='39004-A'";
       	 $sti = $dbh->prepare( $q );
          $sti->execute;

			print "Location: http://$site->{'siteurl'}/html/eng/wms/\n\n";
		}

    }


    ################################
    ## Mode Display Handling
    #

    my ($target, $l, $select_hash);

    if (($FORM{'sid_ok'} =~ /^ERROR/i ) or ($FORM{'mode'} eq "login") or (!$FORM{'mode'})) {
         ## bad session id, display login box again
         #
        $target=$skeltarg."login";
        $l=loadtemplate( $target, $site->{'skeletonpath'} );
        $l=permutebit( $l, \%NVP );
        $l=permuteclean( $l );
        print "Content-type: text/html\n\n";
        print "$l";

    } else {
        ## we know the person is logged in. Present "where to?" screen
        #  as a default, otherwise act according to the mode FORM value
        #
        if ( $FORM{'mode'} eq "logout" ) {
             ## show length of time logged in
             #

             ## prime variables
             #

             ## display "You logged out" page     
             #
             $target=$skeltarg."logout";
	     &rm_user_cache($site);

             $l=loadtemplate($target, $site->{'skeletonpath'});
             $l=permutebit( $l, \%NVP );
             $l=permuteclean( $l );
             print "Content-type: text/html\n\n";
             print "$l";
             # /logout mode

        } elsif ( $FORM{'mode'} eq "changepass" ) {

        } elsif ( $FORM{'mode'} eq "adminuser" ) {

        } elsif ( $FORM{'mode'} eq "main" ) {
	    $site = &get_user_info($FORM{'sid'}, $site, $dbh);

	    &load_user_permissions($site->{'custid'}, $site, $dbh);
                $target=$skeltarg."main";
                $l=loadtemplate( $target, $site->{'skeletonpath'} );
                $l=permutebit( $l, \%NVP );
                $l=permuteclean( $l );
                print "Content-type: text/html\n\n";
                print "$l";

        } else {
            # default mode

      }

    } # /display mode actions

    $dbh->disconnect if ( $dbh );
}

sub get_user_info {
    my ($sid) = shift;
    my ($site) = shift;
    my ($dbh) = shift;

    my ($select_hash, $q, $sts, $h);
    $select_hash = {};
    $select_hash->{'TABLE'}->{'NAME'} = "sessions";
    $select_hash->{'TABLE'}->{'FIELDS'}->{'custid'} = "custid";
    $select_hash->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("sid", $sid, "and");
    $q = &build_select($select_hash, $site, $dbh);
    $sts = $dbh->prepare( $q );
    $sts->execute;
    $h=$sts->fetchrow_hashref('NAME_lc');
    $site->{'custid'} = $h->{'custid'};

    if ($site->{'custid'} ne "") {
	$select_hash = {};
	$select_hash->{'TABLE'}->{'NAME'} = "contacts";
	$select_hash->{'TABLE'}->{'FIELDS'}->{'uname'} = "uname";
	$select_hash->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("objid",  $site->{'custid'}, "and");
	$q = &build_select($select_hash, $site, $dbh, 1);
        $sts = $dbh->prepare( $q );
        $sts->execute;
        $h=$sts->fetchrow_hashref('NAME_lc');
	$site->{'uname'} = $h->{'uname'};
    }

    return ($site);
}
##############################################################################
=pod

=head2 message

message - $site->{'script_msg'} = &message($site);


=over 4

=item DESCRIPTION

To support multiple languages, all error messages need to be stripped out of
the script and translated to different languages.  This routine loads in the
messages for the $site->{'om_render_lang'} that is currently active.

=item INPUT

$site - A hashref containing information required throughout about the current
        site and session

=item OUTPUT

A reference to the %script_msg hash of messages that need to be used in the
script

=item NOTES

=back

=cut
###############################################################################

sub message {
    # check the language that is being used and open appropriate
    # message language file or get messages below
    my %script_msg=();
    my ($site) = shift;

    if ($site->{'om_render_lang'} eq "eng" ) {
       $script_msg{1}="This username is not valid with this password";
       $script_msg{2}="Bad Login Attempt! User Name/Password combo invalid!";
       $script_msg{3}="You NEED cookies to use admin!";
    } else {
       open( EM, "<$site->{'relpath'}/bits/$site->{'om_render_lang'}/system/login.messages");
       while(<EM>) {
            chomp;
            next if /^\#/;
            next if (! $_);
            my @temp=split /\t/;
            $script_msg{$temp[0]}=$temp[1];
       }
       close(EM);
    }

    return \%script_msg;
}

######################### INITIALIZATION SUBROUTINES #######################

##############################################################################
=pod

=head2 initscript

initscript - (%FORM, $site, $dbh) = &initscript();

=over 4

=item DESCRIPTION

Determine the relative path, and set up the script's environment and variables

=item INPUT

none

=item OUTPUT

$site - A hashref containing information required throughout about the current
        site and session

$dbh - current active database handle

%FORM  - A ReadParse version of the FORM to start with

=item NOTES

=back

=cut
###############################################################################
sub initscript {
    my ($s, @temp, @rpath, $rundir, $siteshortname, $u, $scriptname, $relpath);
    my (%FORM, $k, $dbh, $site);

    ## determine path from store (site) root and store db name...
    #
    #  note - this script runs at server root or in cgi-bin/om/admin,
    #    generally. Test these conditions first.
    #  $0 - may not contain a full path, bootstrap with "pwd"
    #
    if ( $0 !~ /^\// ) {  # $0 is not an absolute path
        $s=`pwd`;          # hope pwd on path...
        chomp $s;
        $s.="/$0";
        } else {              # $0 IS an absolute path
        $s=$0;
    } # done determining if $0 is relative or absolute
    @temp=split /\//, $s;

    @rpath=@temp;

    $scriptname = pop @rpath;
    $scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

    $rundir= join "/", @rpath;
    chdir( $rundir );

    $relpath="";
    $siteshortname="";
    ## short circuit if $s does not contain cgi-bin
    if ( $s !~ /cgi-bin/ ) {
        $siteshortname = pop @rpath;
        $relpath=".";
        @temp=();
    } # done testing for degenerate case


    while ( @temp ) {
        $u = pop @temp;

        ## skip references to the present directory
        next if ( $u eq '.' );
        next if ( length($u)==0 );        # skip null directory levels

        $relpath.="/.." if ( $relpath);
        $relpath.="." if ( ! $relpath );

        if ( $u eq "cgi-bin" ) {
            $siteshortname = $temp[$#temp];
            @temp=();
        } # note - cgi-bin is off the site root, so the next up is site root

    } # done constructing relative path to store root

    $relpath .= "/../$siteshortname";
    ($site, $dbh, %FORM) = &initsite($scriptname, $relpath);
#    foreach $k (keys %FORM) {
#        &debug("$k is $FORM{$k}","login", $site->{'debug_level'}, $site->{'debug_log'});
#    }

    return ($site, $dbh, %FORM);
}

##############################################################################
=pod

=head2 initsite

initsite - ($site, $dbh, %FORM) = &initsite($scriptname, $relpath);

=over 4

=item DESCRIPTION

The init site loads in all required library modules and creates the variables 
that are required throughout the script. 

=item INPUT

$scriptname - The name of the script (login.cgi)

$relpath - The relative path to files that must be required

=item OUTPUT

$site - A hashref containing information required throughout about the current
        site and session

$dbh - current active database handle

%FORM  - A ReadParse version of the FORM to start with

=item NOTES

To add parameters that need to be passed around to a lot of locations, add them
to the $site hashref.

To change the debug of the script, change $site->{'debug_level'} to one of the 
following values:

    0 - no debug

    1 - errors only

    2 - all SQL statements, warnings & errors

    3 - all of the above

To change the location of the debug log, change the value of $site->{'debug_log'}. 
Be sure to start it will >> to allow appending to the file.  To set the Generate
Page? button to be selected by default, change the $site->{'generate_default'} to
1.  To have it non-selected by default, change the $site->{'generate_default'} 
to 0.

=back

=cut
###############################################################################
sub initsite {
    my ($scriptname) = shift;
    my ($relpath) = shift;

    my ($q, $interface, $sts, $h, $x, @temp, $n, $k);
    my ($session_lang, $script, $FORM, $site, $dbh, $select_hash);

    use DBI;
    DBI->trace(1, undef) if ( $site->{'debug_level'} eq "3" );

    # Version 0.9.7
    require "$relpath/lib/cgi-lib.pm";
    require "$relpath/lib/conversions.pm";
    require "$relpath/lib/filetools.pm";
    require "$relpath/lib/formtools.pm";
    require "$relpath/lib/login.pm";
    require "$relpath/lib/state.pm";
    require "$relpath/conf/site.pm";
    require "$relpath/lib/blowfisher.pm";
    require "$relpath/lib/localization.pm";
    require "$relpath/lib/permission_layer.pm";
    require "$relpath/lib/language.pm";
    require "$relpath/lib/db_layer.pm";

    # must be the last require statement
    require "$relpath/lib/custom-lib.pm";

    ## establish site-specific parameters
    #
    $site=setsite();

    ## get form data, if any was submitted
    #
    $FORM = &ReadParse();
    $FORM->{'sid'} = &decrypt_sid($FORM->{'sid'}, $site);
    $site->{'sid'}=$$FORM{'sid'};
    $site->{'om_render_lang'}=$$FORM{'lang'};

    ## connect to database
    # system 6 database state, products, and customer tables are collapsed
    #
    $q = "$site->{'db_site_config'}";
    $dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

    #$site->{'om_render_lang'} = ""; Well!! It should be getting the language from the pulldown, not anywhere else
    $interface = "";

    if ($$FORM{'sid'}) {
	$select_hash = {};
	$select_hash->{'TABLE'}->{'NAME'} = "sessions";
	$select_hash->{'TABLE'}->{'FIELDS'}->{'language'} = "language";
	$select_hash->{'TABLE'}->{'FIELDS'}->{'custid'} = "custid";
	$select_hash->{'TABLE'}->{'FIELDS'}->{'interface'} = "interface";
	$select_hash->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("sid", $$FORM{'sid'}, "and");
	$q = &build_select($select_hash, $site, $dbh);
        $sts = $dbh->prepare( $q );
        $sts->execute;
        $h=$sts->fetchrow_hashref('NAME_lc');
        #$site->{'om_render_lang'}=$h->{'language'};Well!! It should be getting the language from the pulldown, not anywhere else
	$site->{'custid'} = $h->{'custid'};
        $session_lang = $h->{'language'};
        $interface=$h->{'interface'};
    }

    if ($site->{'custid'} ne "") {
	$select_hash = {};
	$select_hash->{'TABLE'}->{'NAME'} = "contacts";
	$select_hash->{'TABLE'}->{'FIELDS'}->{'uname'} = "uname";
	$select_hash->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("objid",  $site->{'custid'}, "and");
	$q = &build_select($select_hash, $site, $dbh, 1);
        $sts = $dbh->prepare( $q );
        $sts->execute;
        $h=$sts->fetchrow_hashref('NAME_lc');
	$site->{'uname'} = $h->{'uname'};
    }

    $site->{'om_render_lang'}=$session_lang if ( ! $site->{'om_render_lang'} ); 
    $site->{'om_render_lang'}="eng" if ( ! $site->{'om_render_lang'} );
    #$session_lang="eng" if ( ! $session_lang );
    $interface="html" if ( ! $interface );

    ## load messages
    $script=( split /\./, $scriptname )[0];

    ## done with pull-from-file bits, rest of global settings...
    #
    $x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
    @temp=split /\//, $x;
    @temp=("cgi-bin","test","login.cgi") if (! $ENV{'REQUEST_URI'} );

    $script=( split /\./, $scriptname )[0];
    $n= $#temp - 1;
    # Configure all parameters to pass around in $site hash
    $site->{'selskeletonpath'} = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/html/sel";
    $site->{'skeletonpath'} = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/admin";
    $site->{'scriptpath'} = join "/", ( @temp[0..$n] );
    $site->{'script'} = ( split /\./, $scriptname )[0];
    $site->{'scriptname'} = $scriptname;
    $site->{'relpath'} = $relpath;
    $site->{'permission_path'} = "$site->{'relpath'}/lib/permissions";
    #$site->{'debug_level'} = 3;
    #$site->{'debug_log'} = ">>/tmp/login";
    $site->{'sid'} = $site->{'sid'};
    $site->{'script_msg'} = &message($site);
    $site->{'debug_level'} = 3;
    $site->{'debug_log'} = ">>/tmp/login";


    # Flag, set to 0 to have default for Generate page? as no, and
    # set to 1 to have default as yes
    #$site->{'generate_default'} = 0;

    #&debug("Debugging login.cgi...","login", $site->{'debug_level'}, ">/tmp/login");
    return ($site, $dbh, %{$FORM});
}

1;

