#!/usr/bin/perl  
#-d:ptkdb

sub BEGIN {
    $ENV{'DISPLAY'} = "10.1.1.92:0.0";
}
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# statsman.cgi
#    Administration of stats reports
#
# Version 2 TG 20000918
#    Changed ReadParse2 to ReadParse
# Version 1 TG 20000914
#    Fixed subroutine parameters after changed routines to meet standards
# Version 0.9.14 NC 20000828
#    Use strict, add headers
# Version 0.9.13 IB 20000719
#    FORM variables were not being filled before the second pass
# Version 0.9.12 IB 20000717
#    put names of months into message table
#    om_render_language->om_render_lang
# Version 0.9.11 IB 20000712
#    selection of dates at the end of the report
# Version 0.9.10 IB 20000701
#    moved the stats reports from stats to data/stats
# Version 0.9.9 JC 20000628
#    patch for line 193 on bad cookies
# Version 0.9.8 IB 20000608
#    language and interface from table 'sessions'
# Version 0.9.7 IB 20000607
#    Corrected a message.
# Version 0.9.6 IB 20000606
#    corrected the database call
# Version 0.9.5 IB 20000603
#    further conversion
# Version 0.9.4 IB 20000602
#    converted to Rel. 1.0.1
# Version 0.9,3 IB 20000531
#    added custom-lib.pm
# Version 0.9.2 GF 20000524
#    changed targ
# Version 0.9.1 IB 20000502
#    introduced $script variable
# Version 0.7.15 JC 20000411
#    $om_render_lang update
# Version 0.7.14 JC 20000410
#    multilingual messages
# Version 0.7.13 IB 20000402
#    new directory structure
# Version 0.7.12 JC 20000330
#    changed connect statement
# Version 0.7.11 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.10 IB 20000327
#    corrected $relpath
# Version 0.7.9 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.8 IB 20000302
#    updated copyright
# Version 0.7.7 IB 20000228
#    changed store to site
# Version 0.7.6 JZ 20000216
#    show all stats files
# Version 0.7.5 JZ 20000214
#    use templates for snapshot  
# Version 0.7.4 JZ 20000211
#    corrected dir files lookup and run_stats argument
# Version 0.7.3 JZ 20000204
#    change to dynamic stats output
# Version 0.7.2 JZ 20000202
#    add snapshot view
# Version 0.7.1 JZ 20000126
#    creation

use strict;

&main();


##############################################################################
=pod

=head2 main

main - &main();

=over 4

=item DESCRIPTION

This  function is responsible for giving statistics for the store. It has three
ways to show data, one is general stats, one is dynamic stats, the other is automatically generated reports by system everyday.

=item INPUT

NONE

=item OUTPUT

The report is populated and the display is posted according the the choices made
by the user.

=item NOTES

The main processing of the report is done in os_allcommerce/crons/run_stats.pl

=back

=cut
###############################################################################
sub main {


    my ($site, $dbh, %FORM) = &initscript();

    my $nicedt=nicedatetime();

    my $now=time();

    ## construct some shorthands
    my $script_html = join "-", ("os_allcommerce",$site->{'script'},"");

    ## start the replacements hash
    #
    my %NVP=();
    $NVP{'sitename'}=$site->{'sitename'};
    $FORM{'sid_ok'} = check_login($site, $dbh);

    if ( $FORM{'sid_ok'} ) {
        if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
           # hard error, redirected to login page
            print "Location: /cgi-bin/om/admin/login.cgi\n\n";
            exit 0 ; 
        } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
           # soft error, send to default mode
            $FORM{'mode'}="home";
            $NVP{'__PAGE_ERROR_MSG__'}=$FORM{'sid_ok'};
        } else {
           # welcome to the page...
        }   
        print "Content-type: text/html\n\n";
    } else {
      # unknown why sid_ok not populated with some string...
      #
      print "Content-type: text/html\n\n";
      print "<HTML><HEAD></HEAD><BODY>\n";
      print "$FORM{'sid'} sid $site->{'script_msg'}{1} $FORM{'sid_ok'} \n";
      exit 0;
    }

    $NVP{'sid'}=$FORM{'sid'};
    $NVP{'lastmode'}=$FORM{'mode'};
    $NVP{'script'}="$site->{'scriptpath'}/$site->{'scriptname'}";
    $NVP{'datetime'}=$nicedt;
    $NVP{'scriptpath'}=$site->{'scriptpath'};

    my $crondir = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/data/stats/cron";
    opendir (DIR, $crondir);
    my @statsfiles = readdir(DIR);
    close (DIR);
    shift @statsfiles;
    shift @statsfiles;   

    ##create stats file
    my ($q, $sth, $sts, $num, $statsuser, @custid, $statsdata, @results);

    if ($FORM{'mode'} eq 'home') { #home, need to create stats snapshot

        #$q = "SELECT custid from sessions where sid=$FORM{'sid'} ";
        my $select_hash = {};
        $select_hash->{'TABLE'}->{'NAME'} = "sessions";
        $select_hash->{'TABLE'}->{'FIELDS'}->{'custid'} = "custid";
        $select_hash->{'TABLE'}->{'WHERE'}[0] = build_where_hash("sid",$FORM{'sid'}, "and");
        $select_hash->{'statement'} = "SELECT";
        $q = &build_select($select_hash, $site, $dbh, 1);
	$num = &query_getAll($q, $site, $dbh, \@results);

        if ( $num==1 ) {
           #$q = "SELECT uname from contacts where objid=\'$custid[0]\' ";
           $select_hash = {};
           $select_hash->{'TABLE'}->{'NAME'} = "contacts";
           $select_hash->{'TABLE'}->{'FIELDS'}->{'uname'} = "uname";
           $select_hash->{'TABLE'}->{'WHERE'}[0] = build_where_hash("objid",$results[0]->{'custid'}, "and"); 
           $select_hash->{'statement'} = "SELECT";
           $q = &build_select($select_hash, $site, $dbh, 1);
	   my $num_users = &query_getAll($q, $site, $dbh, \@results);
	   $statsuser = $results[0]->{'uname'};
#           $statsuser = $sts->fetchrow;
        } else {
           print "Content-type: text/html\n\n";
           print "<HTML><HEAD></HEAD><BODY>\n";
           print "$statsuser $site->{'script_msg'}{3}\n";
           exit 0;
        }

	$statsuser = 'Zelerate' if (!$statsuser);
	#special characters is assumed not allowed in uname in database
	$statsuser =~ s/"/\\"/g;
	$statsuser =~ s/`/\\`/g;
	$statsuser =~ s/\$/\\\$/g;

	$statsdata = `$site->{'fsrootcron'}/run_stats.pl "$statsuser" $now`;
#	$statsdata = &run_stats($statsuser, $now, $site, $dbh);

	##get the snapshot view data
	my @snap = split /\&/, $statsdata;
	$NVP{'fromtime'} = shift @snap;
	$NVP{'totime'} = shift @snap;
	$NVP{'statsuser'} =  shift @snap;
	$NVP{'tot_page'} =  shift @snap;
	$NVP{'tot_visitor'} =  shift @snap;
	$NVP{'tot_order'} =  shift @snap;
	$NVP{'order_total'} =  shift @snap;
	$NVP{'topitems'} =  shift @snap;
	$NVP{'filedate'} =  shift @snap;

    } elsif ($FORM{'detail'}) { #mode is display, check if display detailed realtime stats
         open(D, "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/data/stats/include/$FORM{'detail'}");
         while (<D>) { $statsdata .= $_; }
         close(D);
    } else { 
         # find the file and display
	  my $filename = $FORM{'statsfile'};

	  $statsdata ="";
	  foreach my $f (@statsfiles) {
		if (  $f eq $filename ) {
			open(DF, "<$crondir/$f");
			while (<DF>) { $statsdata .= $_; }
			close (DF);		
			last;
		}
	}
	
	if (!$statsdata) { 
		$NVP{'PAGE_ERROR_MSG'} = "$site->{'script_msg'}{2}";
		$FORM{'mode'} = 'home';
		$NVP{'fromtime'} = $FORM{'fromtime'};
		$NVP{'totime'} = $FORM{'totime'}; 
		$NVP{'statsuser'} = $FORM{'statsuser'} ;
		$NVP{'tot_page'} = $FORM{'tot_page'} ;
	        $NVP{'tot_visitor'} =  $FORM{'tot_visitor'} ;
        	$NVP{'tot_order'} = $FORM{'tot_order'} ;
        	$NVP{'order_total'} = $FORM{'order_total'}; 
       	 	$NVP{'topitems'} = $FORM{'topitems'} ;
        	$NVP{'filedate'} =$FORM{'filedate'} ;
	}
    }

    my $t = loadtemplate("row_option", $site->{'skeletonpath'});
    $t =~ s/<!--.*-->\n//s;
    my @mh=($site->{'script_msg'}{4}, $site->{'script_msg'}{5}, $site->{'script_msg'}{6}, $site->{'script_msg'}{7}, $site->{'script_msg'}{8}, $site->{'script_msg'}{9}, $site->{'script_msg'}{10}, $site->{'script_msg'}{11}, $site->{'script_msg'}{12}, $site->{'script_msg'}{13}, $site->{'script_msg'}{14}, $site->{'script_msg'}{15});
    
    my %ST=();
    my $select;
    foreach my $f (sort @statsfiles) {	
            next if $f !~ /\d+\.html$/;
            my $y = substr($f, 0, 4);
            my $m = $mh[substr($f, 4, 2)-1];
            my $d = substr($f, 6, 2);
            $ST{'VALUE'} = $f;
            $ST{'DVALUE'} = "$m  $d  $y";
            $select .= permutebit($t, \%ST);
    }

    my $targ="os_allcommerce-".$site->{'script'}."-".$FORM{'mode'};
    if ($NVP{'lastaction'}) {
	$targ="os_allcommerce-statsman-home";
	$FORM{'mode'}="home";
    }

    my $l = loadtemplate($targ, $site->{'skeletonpath'});
    $l=permutebit($l, \%NVP);

    $l=~ s/__selectstats__/$select/;
    $l =~ s/__statsdata__/$statsdata/;
    $l = permuteclean($l);

    print $l;

    $dbh->disconnect if ( $dbh );
}

##############################################################################
=pod

=head2 message

message - $site->{'script_msg'} = &message($site);

=over 4

=item DESCRIPTION

To support multiple languages, all error messages need to be stripped out of
the script and translated to different languages.  This routine loads in the
messages for the $site->{'om_render_lang'} that is currently active.

=item INPUT

$site - A hashref containing information required throughout about the current
        site and session

=item OUTPUT

A reference to the %script_msg hash of messages that need to be used in the
script

=item NOTES

=back

=cut
###############################################################################
sub message {
    # check the language that is being used and open appropriate
    # message language file or get messages below
    my %script_msg=();
    my ($site) = shift;

    if ($site->{'om_render_lang'} eq "eng" ) {
      $script_msg{1}="evaluates as";
      $script_msg{2}="No information was found for a specified date. Please try another date.";
      $script_msg{3}="unknown.";
      $script_msg{4}="Jan";
      $script_msg{5}="Feb";
      $script_msg{6}="Mar";
      $script_msg{7}="Apr";
      $script_msg{8}="May";
      $script_msg{9}="Jun";
      $script_msg{10}="Jul";
      $script_msg{11}="Aug";
      $script_msg{12}="Sep";
      $script_msg{13}="Oct";
      $script_msg{14}="Nov";
      $script_msg{15}="Dec";
    } else {
      open( EM, "<$site->{'relpath'}/bits/$site->{'om_render_lang'}/system/$site->{'script'}.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         my @temp=split /\t/;
         $site->{'script_msg'}{$temp[0]}=$temp[1];
      }
      close(EM);
    }

    return \%script_msg;
} 

######################### INITIALIZATION SUBROUTINES #######################

##############################################################################
=pod

=head2 initscript

initscript - (%FORM, $site, $dbh) = &initscript();

=over 4

=item DESCRIPTION

Determine the relative path, and set up the script's environment and variables

=item INPUT

none

=item OUTPUT

$site - A hashref containing information required throughout about the current
        site and session

$dbh - current active database handle

%FORM  - A ReadParse version of the FORM to start with

=item NOTES

=back

=cut
###############################################################################
sub initscript {
    my ($s, @temp, @rpath, $rundir, $siteshortname, $u, $scriptname, $relpath);
    my (%FORM, $k, $dbh, $site);
    
	# Find out where we are, so we can load libs.
	##
	use Cwd;
	my $separator = '/'; # What separates dirnames in this architecture?
	my ($scriptname, $args, $rundir);
	($scriptname, $args) = split /\?/, $0;
	if ($scriptname =~ /$separator/) {
		$scriptname =~ /^(.*)$separator(.*)$/;
		$rundir = $1;
		$scriptname = $2;
	} else {
		$rundir = cwd();
	}
	my @path = split(/$separator/, $rundir);
	my $relpath;
	while (my $d = pop @path) {
		$relpath .= "..$separator";
		if ($d eq 'cgi-bin') {
			$relpath .= "..$separator";
			last;
		}
	}
	my $siteshortname = pop @path;
	$relpath .= $siteshortname;
	###########

    ($site, $dbh, %FORM) = &initsite($scriptname, $relpath);

    foreach $k (keys %FORM) {
        &debug("$k is $FORM{$k}","statsman", $site->{'debug_level'}, $site->{'debug_log'});
    }
    
    return ($site, $dbh, %FORM);
}

##############################################################################
=pod

=head2 initsite

initsite - ($site, $dbh, %FORM) = &initsite($scriptname, $relpath);

=over 4

=item DESCRIPTION

The init site loads in all required library modules and creates the variables 
that are required throughout the script. 

=item INPUT

$scriptname - The name of the script (statsmancgi)

$relpath - The relative path to files that must be required

=item OUTPUT

$site - A hashref containing information required throughout about the current
        site and session

$dbh - current active database handle

%FORM  - A ReadParse version of the FORM to start with

=item NOTES

To add parameters that need to be passed around to a lot of locations, add them
to the $site hashref.

To change the debug of the script, change $site->{'debug_level'} to one of the 
following values:

    0 - no debug

    1 - errors only

    2 - all SQL statements, warnings & errors

    3 - all of the above

To change the location of the debug log, change the value of $site->{'debug_log'}. 
Be sure to start it will >> to allow appending to the file.  To set the Generate
Page? button to be selected by default, change the $site->{'generate_default'} to
1.  To have it non-selected by default, change the $site->{'generate_default'} 
to 0.

=back

=cut
###############################################################################
sub initsite {
    my ($scriptname) = shift;
    my ($relpath) = shift;
    
    my ($find, $q, $interface, $sts, $h, $x, @temp, $n, $k);
    my ($session_lang, $script, $FORM, $site, $dbh, $select_hash);
   
    $site->{'debug_level'} = 3;
    $site->{'debug_log'} = ">>/tmp/statsman";

    use DBI;
    DBI->trace(1, undef) if ( $site->{'debug_level'} eq "3" );  

    # Version 0.9.7
    #require "$relpath/lib/variant.pm";

    require "$relpath/lib/cgi-lib.pm";
    #require "$relpath/lib/stats.pm";
    require "$relpath/lib/conversions.pm";
    require "$relpath/lib/filetools.pm";
    require "$relpath/lib/formtools.pm";
    require "$relpath/lib/permission_layer.pm";
    require "$relpath/lib/blowfisher.pm";
    require "$relpath/lib/db_layer.pm";
    require "$relpath/lib/login.pm";
    require "$relpath/lib/validate.pm";
    #require "$relpath/lib/objects.pm";
    require "$relpath/conf/site.pm";
    require "$relpath/lib/localization.pm";
    #require "$relpath/lib/generate_triggers.pm";
    #require "$relpath/lib/inventory.pm";
    
    # must be the last require statement
    require "$relpath/lib/custom-lib.pm";
    
    ## establish site-specific parameters
    #
    $site=setsite();
    
    ## get form data, if any was submitted
    #
    $FORM = &ReadParse();
    $FORM->{'sid'}=&decrypt_sid($FORM->{'sid'}, $site); 
    $site->{'sid'}=$$FORM{'sid'};
    
    $find=$$FORM{'skuskel'};
    if (!$find) {$find=$$FORM{'keyword'};}
    
    ## connect to database
    # system 6 database state, products, and customer tables are collapsed
    #
    $q = "$site->{'db_site_config'}";
    $dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});
    
    $site->{'om_render_lang'} = "";
    $interface = "";
    
    my (@results);
    if ($$FORM{'sid'}) {
	     $select_hash = {};
	     $select_hash->{'TABLE'}->{'NAME'} = "sessions";
	     $select_hash->{'TABLE'}->{'FIELDS'}->{'language'} = "language";
	     $select_hash->{'TABLE'}->{'FIELDS'}->{'interface'} = "interface";
	     $select_hash->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("sid", $$FORM{'sid'}, "and");
	     $q = &build_select($select_hash, $site, $dbh);
	     &query_getAll($q, $site, $dbh, \@results);
	     $h = $results[0];
#        $sts = $dbh->prepare( $q );
#        $sts->execute;
#        $h=$sts->fetchrow_hashref('NAME_lc');
        $site->{'om_render_lang'}=$h->{'language'};
        $session_lang = $h->{'language'};
        $interface=$h->{'interface'};
    }
    
    $site->{'om_render_lang'}=$site->{'om_locale_lang_def'} if ( ! $site->{'om_render_lang'} );
    $site->{'om_render_lang'}="eng" if ( ! $site->{'om_render_lang'} );
    $session_lang="eng" if ( ! $session_lang );
    $interface="html" if ( ! $interface );
    
    ## load messages
    $script=( split /\./, $scriptname )[0];
    #   &initClassAndType();
    
    ## done with pull-from-file bits, rest of global settings...
    #
    $x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
    @temp=split /\//, $x;
    @temp=("cgi-bin","test","statsman.cgi") if (! $ENV{'REQUEST_URI'} );
    
    $script=( split /\./, $scriptname )[0];
    $n= $#temp - 1;

    # Configure all parameters to pass around in $site hash
    $site->{'selskeletonpath'} = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/html/sel";
    $site->{'skeletonpath'} = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/admin";
    $site->{'scriptpath'} = join "/", ( @temp[0..$n] );
    $site->{'script'} = ( split /\./, $scriptname )[0];
    $site->{'scriptname'} = $scriptname;
    $site->{'relpath'} = $relpath;
    #$site->{'debug_level'} = 3;
    #$site->{'debug_log'} = ">>/tmp/statsman";
    $site->{'sid'} = $site->{'sid'};
    #($site->{'OBJCLASSES'}, $site->{'OBJTYPES'}) = &getClassesAndTypes();
    $site->{'STATUS_TXT'} =  &loadseltomem("sel_status");
    $site->{'session_lang'} = $session_lang;
    $site->{'scriptinfo'} = "$site->{'scriptpath'}/$site->{'scriptname'}";
    $site->{'script_msg'} = &message($site);
    
    # Flag, set to 0 to have default for Generate page? as no, and
    # set to 1 to have default as yes
    $site->{'generate_default'} = 0;

    &debug("Debugging statsman.cgi...","statsman", $site->{'debug_level'}, ">/tmp/statsman");
    return ($site, $dbh, %{$FORM});
}

###############################################################################

=pod

=head2 debug

debug - &debug($err_msg, $filename, $debug_level, $msg_level);

=over 4

=item DESCRIPTION

Debug the script and output the debug message

=item INPUT

$err_msg - the message will be displayed when debug

$filename - the file name which the debug report is written in

$debug_level - the debug level that is using

$msg_level - the directory whcih the debug file locates

=item OUTPUT

debug report

=item NOTES

=back

=cut
###############################################################################
sub debug {

    my ( $err_msg, $filename, $debug_level, $msg_level )= @_;

        if ( $msg_level <= $debug_level) {
           open FH, ">>/tmp/$filename";
           print FH "$err_msg\n";
           close FH;
        }
}

1;

