#!/usr/bin/perl
# This is a test
############################################################################
#    Copyright (C) 1999-2000 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

####
# cart.cgi
#    shopping cart script
#    RF 981203
#
####

####
#
# Version 6 TG 20000918
#      Changed ReadParse2 to ReadParse
# Version 5 TG 20000915
#      Fixed calls to cart_perm_template
# Version 4 TG 20000913
#      Fixed parameters to permute_include and localize_template
# Version 3 LCF 20000911
#	integrated further changes for Oracle compliance 
#	and modularity
# Version 2 LCF 20000907
#	moved more of the rows stuff into cart-lib,
#	changed "where am I" code to new version
# Version 0.8.62 LCF 20000825
#    added use strict, put much stuff in cart-lib.pm
# Version 0.8.61 JC 20000822
#    put purchase limit on cart
# Version 0.8.60 JC 20000722
#    bug fixes
# Version 0.8.59 IB 20000717
#    om_render_language -> om_render_lang
# Version 0.8.57 JC 20000708
#    fixed messaging error
# Version 0.8.56 JC 20000706
#    fixed price listing so that it is the lowest
# Version 0.8.55 IB 20000606
#    language and interface from table 'sessions'
# Version 0.8.54 IB 20000503
#    added custom-lib.pm
# Version 0.8.53 GF 20000524
#    objtype to objclass
# Version 0.8.52 GF 20000521
#    added logic for variants/master
# Version 0.8.47 GF 20000516
#    variants squashed into things   
# Version 0.8.46 GF 20000508
#    error messages
# Version 0.8.41 GF 20000504
#    takes an objid    
# Version 0.8.40 GF 20000504
#    sku -> objid   
#    lowercase field names
#    u_email to custid
# Version 0.8.36 JC 20000417
#    changed loadtemplate to localize_template
# Version 0.8.35 IB 20000417
#    fixed messages
# Version 0.8.34 GF 20000413
#    fixed sku, var translations 
#    changed UID to U_EMAIL
#       TBD - hardcode xpr for promotions
#           - translation of sku, vsku and vcode 
# Version 0.8.33 IB 20000411
#    default to language in site.pm
# Version 0.8.32 IB 20000410
#    corrected a comment
# Version 0.8.31 IB 20000409
#    language
# Version 0.8.30 IB 20000405
#    language fix
#    corrected a typo
# Version 0.8.29 IB 20000404
#    new directory structure
# Version 0.8.28 IB 20000402
#    new directory structure
# Version 0.8.27 IB 20000331
#    cell templates renaming
# Version 0.8.26 IB 20000330
#    changed connect statement
# Version 0.8.25 JC 20000329
#    changed DBI prepare/connect
# Version 0.8.24 IB 20000327
#    corrected $relpath
# Version 0.8.23 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.8.22 JC 20000322
#    put colon in at ssl_prefix
# Version 0.8.21 IB 20000317
#    renaming of templates
# Version 0.8.20 IB 20000313
#    corrected an operator
# Version 0.8.19 IB 20000302
#    updated copyright information and removed -w
# Version 0.8.18 IB 20000226
#    changed store to site
# Version 0.8.17 GF 20000202
#    added in no_item message when cart is empty
# Version 0.8.16 IB 20000128
#    fixed storeurl
# Version 0.8.15 JN 20000127
#    fixed addrid bug
# Version 0.8.14 JN 20000124
#    added wishlist and registry.cgi
# Version 0.8.13 JN 20000117
#    changed http to store.pm ref when accessing checkout
# Version 0.8.12 JN 20000103
#    fixed the price display when adding more items to an existing item
#    in the cart
# Version 0.8.11 IB 991217
#    reversed the order of two instructions in order to avoid messages
#    on the screen
# Version 0.8.10 IB 991203
#    added track.cgi
# Version 0.8.8 IB/GF 991202
#    added bits/site to bits
#    added in loadtemplate for footer element
#    removed bottom_nav loadtemplate element
# Version 0.8.7 JN 991202
#    variant support fixed
# Version 0.8.6 IB 991126
#    corrected bits/pages to bits/site/pages
# Version 0.8.4 IB 991111
#    corrected the determining of a relpath
#    removed foreach
#    corrected $scriptname
# Version 0.8.3 IB 991111
#    corrected DBI statement position, eliminated store_env
# Version 0.8.2 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.8.1 IB 991102
#    general cleanup
# Version 0.7.6 SH 990903
#    specify active prices
# Version 0.7.1 GF 990829
#    Made work with variants
#    Accepts a VCODE and then translates sku and vcode
# Version 1 - 981204
#

# Start docs
=pod

=head1 NAME 

cart.cgi

=head1 SYNOPSIS

This cgi creates and manages the shopping cart display.

=head1 DESCRIPTION

This script manages items in the shopping cart. Whenever a user views their cart, removes items, or changes quantities of items, this is the code that deals with that.

=head1 NOTES & BUGS

Still somewhat messy. More of the program logic should be in cart-lib.pm.

=cut
# End docs

use strict;

## Load libraries, determine name and path
#
##warn "Start: loading libs... \n";
my ($scriptname, $relpath) = &load_libs();
##warn "done.\n";

## Load standard script data
#
##warn "Running init_script... \n";
my ($site, $form, $dbh, $script_msg) = &init_script($scriptname, $relpath);
##warn "done.\n";
$form->{'sid'} =  &setsessionid($site,$dbh,%{$form}); #setsessionid needs to be called to check for sid.
warn "SID is $form->{'sid'}\n";
my $sid_encrypt = &encrypt_sid($form->{'sid'}, $site);
warn "Encrypted sid is $sid_encrypt\n";

##warn "Received form data:\n";
#foreach my $key (keys %{$form}) {
	##warn "\t$key -> $form->{$key}\n";
#}

if ($form->{'nowishlist.x'} || $form->{'nowishlist.y'} || $form->{'nowishlist'}) {
	##warn "Received 'nowishlist. Canceling wishlist key\n";
	$form->{'wishlist'} = '';
	$form->{'nowishlist'} = '';
	$form->{'cartclass'} = '81001-A';
	$form->{'db_cart'} = 'tcart';
}

## Determine the page to target "Return to shopping" at
#
##warn "Running determine_target_page... \n";
$form->{'pg_targ'} = &determine_target_page($site, $form);
##warn "done.\n";


## fork env and track user 
#
#warn "Tracking with track.cgi...\n";
`$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/cgi-bin/om/track.cgi`;
#warn "done.\n";

## Get a customer id from the sessions table. Undef if not found
#
#warn "Running get_custid...\n";
$site->{'custid'} = &get_custid($site, $form);
#warn "done.\n";

# check if any items have been checked out
# if so, put hquant back to lstock
# and set hquant and squant to 0
# delete rows from table extraprop, tcart, orders
&put_checkout_back($form, $site) if ($site->{'custid'});

## Figure out what the "continue" page should be
#
#warn "Running get_next_page_url...\n";
$form->{'nextcheckoutpg'} = &get_next_page_url($site, $form);
#if (!$ENV{'HTTP_COOKIE'} && ($form->{'nextcheckoutpg'} !~ /checkout.cgi/)) {
#	my $e_sid = &encrypt_sid($form->{'sid'},$site);
#	$form->{'nextcheckoutpg'} = "/cgi-bin/om/wrapper.cgi?sid=$e_sid&target=$form->{'nextcheckoutpg'}";
#}
#warn "done.\n";

if ($form->{'wishlist'}) {
	$site->{'cartclass'} = '81002-A';
	$site->{'db_cart'} = 'pcart';
}


## MOVE FROM WISHLIST TO CART ####################################
#warn "Checking for wishlist->cart purchases...\n";

foreach my $key (keys %{$form}) {
	if ($key =~ /^row\.(.*?)\.mv_tcart$/) {
		my $rowid = $1;
		#warn "Moving row $rowid to tcart...\n";
		&pcart_to_tcart($site, $form, $rowid);
	}
}
#warn "Move complete.\n";
## MOVE COMPLETE #################################################




## ADD ITEM SECTION ##############################################
#warn "Starting Add section...\n";
## If there's an object and an add quantity, try to add the object
#
if ($form->{'objid'} && $form->{'add'}) {
	# Run cartaddcheck to determing outcome of attempt
	#warn "\trunning &cartaddcheck($form->{'add'},'',$form->{'objid'},$form->{'sid'},$form->{'cartclass'},'','',$site)\n";
        $form->{'currency'} = $site->{'om_locale_curr_def'} if (!$form->{'currency'});        
	my ($objid, $availquant, $err) = &cartaddcheck($form->{'add'},'',$form->{'objid'},$form->{'sid'},$form->{'cartclass'},'',$site->{'custid'},$form->{'currency'},$site);
	#warn "\tdone. ($objid, $availquant, $err)\n";

        ## use only one currency
            my %this_symbol;

            my $cur = "$site->{'om_locale_curr_def'},$site->{'om_locale_curr_act'}";
            my $sym = $site->{'currency_symbol'};

            $cur =~ s/\s+//g;
            $sym =~ s/\s+//g;
            $cur =~ tr/a-z/A-Z/;

            my @store_cur = split /,/, $cur;
            my @store_sym = split /,/, $sym;

            my $num = @store_cur;
            foreach (0..$num-1) {
               $this_symbol{$store_cur[$_]} = $store_sym[$_] if $store_sym[$_];
            }   
   
            $site->{'currency_symbol'} = $this_symbol{$form->{'currency'}};
	
	# Determine what the error was, if any
	$err = &determine_err_msg($err, $script_msg);

	# Display error message on page
	$form->{'cart_error'}=$err;
	
	# Update $form with new row values	
	$form = &update_row_values($form, $objid, $availquant, $err);
}
#warn "Add complete.\n";
## ADD COMPLETE #####################



## REMOVE ITEM SECTION ###########################################	
#warn "Starting Remove section...\n";
## Collect object id's to remove, then remove them.
#
#warn "\tRunning &find_objs_to_delete($form)\n";
my $obj_del = &find_objs_to_delete($form);
#warn "\tdone.\n";

# Now remove those objectids.
#warn "\tRunning &delete_objects($site, $obj_del)\n";
&delete_objects($site, $form, $obj_del);
#warn "\tdone.\n";

#warn "Remove complete.\n";
## REMOVE COMPLETE ##################



## ADJUST QUANTITY SECTION ########################################
#warn "Starting Adjust section...\n";
## Run through form keys and find ones that indicate a quantity change.
#
foreach my $key (keys %{$form}) {
	# Check for a real adjust quant key. Returns true if so
	my ($row_id, $old_quant) = &validate_quant_adjust($form, $key);
	next unless ($row_id && $old_quant);
	
	# Do the adjust
	my ($obj_id, $quant, $err_code) = &adjust_quantity($form, $site, $key, $row_id, $old_quant);
	
	# Determine err message, if any (will be blank if there's no $err_code)
	$form->{"row.".$row_id.".quant_err"} = &determine_err_msg($err_code, $script_msg);
}	
#warn "Adjust complete.\n";
## ADJUST COMPLETE ##################


	
my ($rows, $count);
($rows, $form, $count) = &get_cart_rows($site, $dbh, %{$form});  # row hashrefs

unless ( $count ) {                 # error messages when either no items
                                  # are in the cart or cartaddcheck 

   if ( $form->{'cart_error'} eq '' && $form->{'wishlist'} ) {
   	  $form->{'cart_error'}=$script_msg->{12};
   } elsif ( $form->{'cart_error'} eq '' ) {
      # sorry you have no items in your cart
      $form->{'cart_error'}=$script_msg->{2};
   } else {
      # error message from cartaddcheck
      #$form->{'cart_error'}="$c_err";
   }
}  

## encrypt sid
$form->{'sid'} = &encrypt_sid($form->{'sid'},$site);

## load and permute templates
#
my $templates = &cart_perm_template($site, $site->{'current_interface'}, $form->{'wishlist'});

## construct "new" item row
#
my ($templates, $form) = &new_item_row($rows, $form, $templates);


## construct "old" item rows
#
$form = &old_item_row($form, $rows, $templates);

## output the file to stdout
#
my $thispage;

if ($form->{wishlist} && !$site->{'custid'}) {
	$thispage=localize_template("page_wishlist_login",$site->{'current_interface'},0, $site);
} elsif ($form->{wishlist} && $site->{'custid'}) {
	$thispage=localize_template("page_wishlist_cart",$site->{'current_interface'},0, $site);
} else {
	$thispage=localize_template("page_cart_cart",$site->{'current_interface'},0, $site);
}

## output the file to stdout
#
$thispage = permutebit( $thispage, $form );
$thispage = permutebit( $thispage, $site );
$thispage = permutebit( $thispage, \%ENV );
$thispage = permuteclean ( $thispage  );
$thispage = permute_include( $thispage, "html", 0, $site);

print "content-type: text/html\n\n";
print $thispage;

## cleanup
#
$dbh->disconnect if ( $dbh );


	
sub load_libs {
	## determine path from store (site) root and store db name...
	#
	#  note - this script runs at server root or in cgi-bin/om,
	#    generally. Test these conditions first.
	#  $0 - may not contain a full path, bootstrap with "pwd"
	#

	# Find out where we are, so we can load libs.
	##
	use Cwd;
	my $separator = '/'; # What separates dirnames in this architecture?
	my ($scriptname, $args, $rundir);
	($scriptname, $args) = split /\?/, $0;
	if ($scriptname =~ /$separator/) {
		$scriptname =~ /^(.*)$separator(.*?)$/;
		$rundir = $1;
		$scriptname = $2;
	} else {
		$rundir = cwd();
	}
	my @path = split(/$separator/, $rundir);
	my $relpath;
	while (my $d = pop @path) {
		$relpath .= "..$separator";
		if ($d eq 'cgi-bin') {
			$relpath .= "..$separator";
			last;
		}
	}
	my $siteshortname = pop @path;
	$relpath .= $siteshortname;
	###########

	use DBI;
	require "$relpath/lib/cgi-lib.pm";
	require "$relpath/lib/formtools.pm";
	require "$relpath/lib/filetools.pm";
	require "$relpath/conf/site.pm";
	require "$relpath/lib/state.pm";
	require "$relpath/lib/localization.pm";
	require "$relpath/lib/cart-lib.pm";
	require "$relpath/lib/conversions.pm";
	require "$relpath/lib/permission_layer.pm";
	require "$relpath/lib/db_layer.pm";
        require "$relpath/lib/blowfisher.pm";
	
	# must be the last require statement
	require "$relpath/lib/custom-lib.pm";

	############
	
	return ($scriptname, $relpath);
}
	
