#!/usr/bin/perl

use strict;


sub main {

    my ($scriptname, $relpath) = &load_libs();

    ## Get the site hash
    #
    my $site = &setsite();

    ## get the FORM bits
    #
    my $form = &ReadParse();

    $form->{'sid'} = &decrypt_sid($form->{'sid'}, $site);

    ## decide url
    my $url;
    if (!$form->{'return_page'}) {
        if (( $ENV{'HTTP_REFERER'} =~ /($site->{'sitedomain'}|$site->{'sitessldomain'})/ ) and ( $ENV{'HTTP_REFERER'} !~ /$scriptname/ )) {
            $url = $ENV{'HTTP_REFERER'}; 
        }
    }  

    $form->{'return_page'} = $url if ($url);

    ## establish connection to database
    #
    my $dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'})
                || die "Can't connect to database! ".DBI->errstr();

    ## Add dbh to $site, for convenience
    $site->{'dbh'} = $dbh;

    ## Get the language and interface, if possible
    #
    my $h = {};

    if ( $form->{'sid'} ) {        

        my $q ="SELECT custid from sessions where sid='$form->{'sid'}' ";
        my $sth = $dbh->prepare($q);
           $sth->execute;
        $form->{'custid'} = $sth->fetchrow; 

    }

    if ( !$form->{'sid'} || !$form->{'custid'} ) {

         # if there is no sid or custid,
         # move to welcome.cgi
         print "Status: 302/Moved\n";
         print "Location: http://$site->{'siteurl'}/cgi-bin/om/welcome.cgi?pg_targ=myaccount.cgi&return_page=$form->{'return_page'}\n\n\n";
         exit 0;
    }

    if ($form->{'sid'}) {
        my $sth = &get_lang_interf($form->{'sid'}, $site->{'dbh'});
        $h = $sth->fetchrow_hashref("NAME_lc") || {};
        $sth->finish();

    }

    $site->{'om_render_lang'} = $h->{'language'} || $site->{'om_locale_lang_def'} || 'eng';
    $site->{'current_interface'} = $h->{'interface'} || "html";    

    # Add scriptname and relpath to site for convenience
    $site->{'scriptname'} = $scriptname;
    $site->{'relpath'} = $relpath;

    ## Get the script error messages hash
    #  put in site
    $site->{'msg'} = &myaccount_message($site);

    print "Content-type: text/html\n\n";

    &permute_out($form,$site,$dbh);

    $dbh->disconnect() if ($dbh);

}

&main();

sub load_libs {

    ## determine path from store (site) root and store db name...
    #
    #  note - this script runs at server root or in cgi-bin/om,
    #    generally. Test these conditions first.
    #  $0 - may not contain a full path, bootstrap with "pwd"
    #

    # Find out where we are, so we can load libs.
    ##
    use Cwd;
    my $separator = '/'; # What separates dirnames in this architecture?
    my ($scriptname, $args, $rundir);
    ($scriptname, $args) = split /\?/, $0;
    if ($scriptname =~ /$separator/) {
        $scriptname =~ /^(.*)$separator(.*?)$/;
        $rundir = $1;
        $scriptname = $2;
    } else {
        $rundir = cwd();
    }
    my @path = split(/$separator/, $rundir);
    my $relpath;
    while (my $d = pop @path) {
        $relpath .= "..$separator";
        if ($d eq 'cgi-bin') {
            $relpath .= "..$separator";
            last;
        }
    }
    my $siteshortname = pop @path;
    $relpath .= $siteshortname;
    ###########

    use DBI;

    require "$relpath/lib/validate.pm";
    require "$relpath/lib/checkout-lib.pm";
    require "$relpath/lib/checkout_cells.pm";
    require "$relpath/lib/cgi-lib.pm";
    require "$relpath/lib/blowfisher.pm";
    require "$relpath/lib/formtools.pm";
    require "$relpath/lib/filetools.pm";
    require "$relpath/conf/site.pm";
    require "$relpath/lib/state.pm";
    require "$relpath/lib/myaccount.pm";
    require "$relpath/lib/localization.pm";
    require "$relpath/lib/cart-lib.pm";
    require "$relpath/lib/conversions.pm";
    require "$relpath/lib/permission_layer.pm";
    require "$relpath/lib/db_layer.pm";

    # must be the last require statement
    require "$relpath/lib/custom-lib.pm";

    return ($scriptname, $relpath);

}

sub init_script {
        my ($scriptname, $relpath, $url) = @_;
        my $thispage;

        ## Get the site hash
        #
        my $site = &setsite();

        ## get the FORM bits
        #
        my $form = &ReadParse();

if ( ! $form->{'sid'} || ! $form->{'custid'} ) {
           $site->{'myaccountlogin'} = "http://$site->{'siteurl'}/cgi-bin/om/welcome.cgi?";
           print "content-type: text/html \n\n";
           my $myacountlogin = &localize_template("page_myaccount_login" , "html" , 0, $site);
           $myacountlogin = &permutebit($myacountlogin, $site );
           $thispage = &permuteclean( $myacountlogin );
}

        ## establish connection to database
        #
        my $dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'})
                || die "Can't connect to database! ".DBI->errstr();

        ## Add dbh to $site, for convenience
        $site->{dbh} = $dbh;

        ## Get the language and interface, if possible
        #
        my $h = {};

        if ($form->{'sid'}) {
           my $sth = &get_lang_interf($form->{'sid'}, $site->{dbh});
           $h = $sth->fetchrow_hashref('NAME_lc') || {};
           $sth->finish();

        }                                         

        $site->{'om_render_lang'} = $h->{'language'} || $site->{'om_locale_lang_def'} || 'eng';
        $site->{'current_interface'} = $h->{'interface'} || "html";

        # Add scriptname and relpath to site for convenience
        $site->{scriptname} = $scriptname;
        $site->{relpath} = $relpath;

        $form->{'url'} = $url if ($url);

        ## Get the script error messages hash
        #
my %script_msg = {};
#        my %script_msg = &message($site->{'om_render_lang'}, $scriptname, $relpath);          # user interaction messages

        return ($site, $form, $dbh, \%script_msg);
} 

1;
