#!/usr/bin/perl 
#-d:ptkdb

sub BEGIN {
    $ENV{'DISPLAY'} = "10.1.1.92:0.0";
}

############################################################################
#    Copyright (C) 1999-2000 OpenSales, Inc.
# 
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

#####
# track.cgi
#    IB 991025 - the script for tracking site usage
#                (the script inbound.cgi also helps keep track of site usage)
#
#####

####
# Version 2 LCF 20000918
#    Changed ReadParse2 to ReadParse
# Version 1 LCF 20000911
#	Bugfixes to work under strict, general code 
#	cleaning
# Version 0.7.19 NC 20000830
#    use strict, add headers
# Version 0.7.18 IB 20000606
#    added comment for custom-lib.pm
# Version 0.7.17 IB 20000601
#    added custom-lib.pm
# Version 0.7.16 IB 20000330
#    changed connect statement
# Version 0.7.15 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.14 IB 20000327
#    corrected $relpath
# Version 0.7.13 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.12 IB 20000309
#    replaced uninitialized variable with initialized one to avoid message
# Version 0.7.11 IB 20000302
#    updated copyright and removed -w
# Version 0.7.10 IB 20000226
#    changed store to site
# Version 0.7.8 GF 991203
#    relaced REFERER with HTTP_REFERER 
# Version 0.7.7 RF 991111
#    minor change to add script name detection
# Version 0.7.6 IB 991111
#    correcting the location of a DBI statement
# Version 0.7.5 RF 991108
#    added handling for lib location if called from command line
# Version 0.7.4 RF 991108
#    repaired defective relative link to libraries 
# Version 0.7.3 IB 991025
#    the UID field has been dropped from table clicks 
# Version 0.7.2 RF 991022
#    stole appropriate bits from inbound.cgi
#
##############################################################################
use strict;
##############################################################################
=pod

=head1 track.cgi

track.cgi - the script for tracking site usgae

=head1 SYNOPSIS

http://YOURDOMAIN/cgi-bin/om/tarck.cgi

=head1 DESCRIPTION

This script is responsible for tracking site usage

=head1 NOTES & BUGS

=cut
###############################################################################
# Find out where we are, so we can load libs.
##
use Cwd;
my $separator = '/'; # What separates dirnames in this architecture?
my ($scriptname, $args, $rundir);
($scriptname, $args) = split /\?/, $0;
if ($scriptname =~ /$separator/) {
   $scriptname =~ /^(.*)$separator(.*)$/;
   $rundir = $1;
   $scriptname = $2;
} else {
   $rundir = cwd();
}
my @path = split(/$separator/, $rundir);
my $relpath;
while (my $d = pop @path) {
   $relpath .= "..$separator";
   if ($d eq 'cgi-bin') {
      $relpath .= "..$separator";
      last;
   }
}
my $siteshortname = pop @path;
$relpath .= $siteshortname;
###########

require "$relpath/lib/track.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/state.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/conversions.pm";
require "$relpath/lib/db_layer.pm";
require "$relpath/lib/permission_layer.pm";
require "$relpath/lib/blowfisher.pm";

print "Content-type: text/html\n\n";


# must be the last require statement
require "$relpath/lib/custom-lib.pm";

my $site = &setsite;
my $dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});
$site->{'debug_level'} = 3;
$site->{'debug_log'} = ">>/tmp/track";
&track_main($site,$dbh);
$dbh->disconnect if $dbh;

