#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

####
# receiving.cgi
#	Receiving interface for Zelerate WMS
#	LCF 20001208
####


############################################################
# Begin standard init
############################################################

use strict;
my ($scriptname, $relpath) = &load_libs();
my ($site, $form, $dbh)    = &init_script($scriptname, $relpath);

# Extra site data
$site->{'sid'}      = &setsessionid($site, $dbh, %{$form});
$site->{'home'}     = "http://$site->{siteurl}/html/eng/wms/";
$site->{'subtitle'} = '[Receiving]';

# Page and nav defaults
my $current_page = 'wm_page_receiving_main';
my $nav          = qq{| Receiving};

############################################################
# End standard init 
############################################################


############################################################
# Begin main script operation
############################################################

if ($form->{'receive'} && $form->{'ponum'} && $form->{'receiveline'}) {
	$form->{'inp_err'} = &check_receiving_input($form, $site);
	$form->{'inp_err'} = &receive_po_line($form, $site);
}	

if ($form->{'today'} && $form->{'ponum'}) {
	my $po = &get_po_head($form->{'ponum'}, $site);
	unless ($po->{'ponum'}) {
		$form->{'get_ponum'} = 1;
		$form->{'today'} = ''; 
		$form->{'inp_err'} = "Can't find PO $form->{'ponum'}\n";
		$form->{'ponum'} = '';
	}
}

if ($form->{'edit_box'} && $form->{'boxid'}) {
	my $box = &get_one_box($site, $form->{'boxid'});
	
	unless ($box->{'objid'}) {
		$form->{'inp_err'} = "Can't find box $form->{'boxid'}\n";
		$form->{'boxid'} = '';
	}
}
	
if ($form->{'receive'} && $form->{'ponum'}) {

	$form->{'inp_err'} = &check_for_po($form->{'ponum'}, $site);
	$form->{'po_summ'} = &receive_po($site, $form) unless ($form->{'inp_err'});
	$form->{'new_boxes'} = &find_new_boxes($form, $site);
	
	$current_page = ($form->{'inp_err'}) ? 'wm_page_receiving_find' : 'wm_page_receiving_receive';
	$nav          = qq{| <A HREF="receiving.cgi">Receiving</A> | <A HREF="receiving.cgi?receive=1">Find PO</A> | Receive PO and Print Label};
	
} elsif ($form->{'receive'}) {

	$current_page = 'wm_page_receiving_find';
	$nav          = qq{| <A HREF="receiving.cgi">Receiving</A> | Find PO};

} elsif ($form->{'move'} && $form->{'save'}) {
	
	$form->{'inp_err'} = &move_box($site, $form->{'objid'}, $form->{'uid'}, $form->{'location'}, 'reserve', 'new');
	$current_page = 'wm_page_receiving_move';
	$nav          = qq{| <A HREF="receiving.cgi">Receiving</A> | Move Box};
	
} elsif ($form->{'move'}) {
	
	$current_page = 'wm_page_receiving_move';
	$nav          = qq{| <A HREF="receiving.cgi">Receiving</A> | Move Box};

} elsif ($form->{'new'}) {
	
	$form->{'report'} = &new_box_report($site);
	$form->{'head_title'} = 'Boxes Still in NEW Status';
	$current_page = 'wm_page_receiving_reports';
	$nav		  =	qq{| <A HREF="receiving.cgi">Receiving</A> | $form->{'head_title'}};

} elsif ($form->{'today'} && $form->{'ponum'}) {
	
	$form->{'report'} = &date_po_report($site, $form->{'ponum'}, $form->{'today'});
	my $day = $form->{'today'} if (&check_date($form->{'today'}));
	$day = "today" unless $day;
	$form->{'head_title'} = "Day's Receiving for $day, PO: $form->{'ponum'}";

	$current_page = 'wm_page_receiving_reports';
	$nav		  =	qq{| <A HREF="receiving.cgi">Receiving</A> | Receiving by Day and PONUM};
	

} elsif ($form->{'today'}) {
	
	$form->{'report'} = &today_report($site, $form->{'today'});
	my $day = $form->{'today'} if (&check_date($form->{'today'}));
	$day = "today" unless $day;
		
	$form->{'head_title'} = "Day's Receiving for $day";
	$current_page = 'wm_page_receiving_reports';
	$nav		  =	qq{| <A HREF="receiving.cgi">Receiving</A> | Receiving by Day};
	
} elsif ($form->{'get_ponum'}) {
	
	$form->{'report'} = &get_rept_ponum($site, $form);
	$form->{'head_title'} = "Enter PONUM";
	$current_page = 'wm_page_receiving_reports';
	$nav		  =	qq{| <A HREF="receiving.cgi">Receiving</A> | Receiving by Day and PONUM};
	
} elsif ($form->{'show_box'}) {

	$form->{'report'} = &display_box($site, $form->{'show_box'});
	$form->{'head_title'} = "Details of Box $form->{'show_box'}";
	$current_page = 'wm_page_receiving_reports';
	$nav		  =	qq{| <A HREF="receiving.cgi">Receiving</A> | Show Box Details};

} elsif ($form->{'edit_box'} && $form->{'boxid'}) {

	$form->{'inp_err'} = &edit_box_save($site, $form);
	$form->{'box_details'} = &display_box($site, $form->{'boxid'});
	$form->{'edit_details'} = &box_edit_form($site, $form->{'boxid'});
	$current_page = 'wm_page_box_edit';
	$nav		  =	qq{| <A HREF="receiving.cgi">Receiving</A> | Edit Box Details};
	
} elsif ($form->{'edit_box'}) {

	$form->{'report'} = &enter_boxid($site, $form);
	$form->{'head_title'} = "Correct Receiving Error by Editing Boxes";
	$current_page = 'wm_page_receiving_reports';
	$nav		  =	qq{| <A HREF="receiving.cgi">Receiving</A> | $form->{'head_title'}};
	
} elsif ($form->{'change_box_status'}) {

	if ($form->{'boxid'}) {
		$form->{'inp_err'} = &change_box_status($site, $form);
	}
	
	$form->{'report'} = &box_status_form($site, $form);
	$form->{'head_title'} = "Change status of a First Quality box";
	$current_page = 'wm_page_receiving_reports';
	$nav		  =	qq{| <A HREF="receiving.cgi">Receiving</A> | $form->{'head_title'}};

} elsif ($form->{'find_sku'}) {

	$form->{'report'} = &localize_template('wm_cell_find_sku_input', $site->{'current_interface'},0,$site);
	
	if ($form->{'sku'}) {
		$form->{'report'} .= &find_boxes_by_sku($site, $form);
	}
	
	$form->{'head_title'} = "Find SKU in Active and Reserve Locations";
	$current_page = 'wm_page_receiving_reports';
	$nav		  =	qq{| <A HREF="receiving.cgi">Receiving</A> | $form->{'head_title'}};

} elsif ($form->{'find_bin'}) {
	
	my $find = &localize_template('wm_cell_find_bin_input', $site->{'current_interface'},0,$site);
	$form->{'report'} = &permutebit($find, $form);
	
	if ($form->{'bin'}) {
		my $stat = $form->{'status'} || 'reserve';
		$form->{'report'} .= &list_bin_contents($site, $form, $stat);
	}
	
	$form->{'head_title'} = "List Inventory by Bin Location: $form->{'status'}";
	$current_page = 'wm_page_receiving_reports';
	$nav		  =	qq{| <A HREF="receiving.cgi">Receiving</A> | $form->{'head_title'}};
	
}
	
&page_out($form, $site, $current_page, $nav);

############################################################
# Begin local libraries
############################################################

sub load_libs {
	use Cwd;
	my $separator = '/'; # What separates dirnames in this architecture?
	my ($scriptname, $args, $rundir);
	($scriptname, $args) = split /\?/, $0;
	if ($scriptname =~ /$separator/) {
		$scriptname =~ /^(.*)$separator(.*?)$/;
		$rundir = $1;
		$scriptname = $2;
	} else {
		$rundir = cwd();
	}
	my @path = split(/$separator/, $rundir);
	my $relpath;
	while (my $d = pop @path) {
		$relpath .= "..$separator";
		if ($d eq 'cgi-bin') {
			$relpath .= "..$separator";
			last;
		}
	}
	my $siteshortname = pop @path;
	$relpath .= $siteshortname;

	use DBI;
	require "$relpath/lib/wms_funcs.pm";
	# Load standard lib
	&load_standard_libs($relpath);
	
	# must be the last require statement
	require "$relpath/lib/custom-lib.pm";

	
	return ($scriptname, $relpath);
}
	

