#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

####
# sku.cgi
#	SKU manager for Zelerate WMS
#	LCF 20001120
####

####
# po.cgi
#	PO manager for Zelerate WMS
#	LCF 20001125
####

############################################################
# Begin standard init
############################################################

use strict;
my ($scriptname, $relpath) = &load_libs();
my ($site, $form, $dbh)    = &init_script($scriptname, $relpath);

# Extra site data
$site->{'sid'}      = &setsessionid($site, $dbh, %{$form});
$site->{'home'}     = "http://$site->{siteurl}/cgi-bin/wms/";
$site->{'subtitle'} = '[PO - SKU]';

# Page and nav defaults
my $current_page = 'wm_page_po_sku';
my $nav          = qq{| <A HREF="po.cgi">PO</A> | SKU};

############################################################
# End standard init 
############################################################


############################################################
# Begin main script operation
############################################################

# Check for all required input, if we're trying to save something
$form->{inp_err} = &check_sku_input($form, $site) 
	if ($form->{'save'});

# Insert the new SKU stuff. This will either return a "confirm" message, or 
# An error message. Either one goes in the same place anyway.
$form = &create_new_sku($form, $site) 
	unless ($form->{inp_err} || !$form->{'save'});

####
# Finish up
#    Now do the standard output stuff, with the data as set above.
####

&page_out($form, $site, $current_page, $nav);


############################################################
# End of main script.
############################################################


############################################################
# Begin local libraries
############################################################

sub load_libs {
	use Cwd;
	my $separator = '/'; # What separates dirnames in this architecture?
	my ($scriptname, $args, $rundir);
	($scriptname, $args) = split /\?/, $0;
	if ($scriptname =~ /$separator/) {
		$scriptname =~ /^(.*)$separator(.*?)$/;
		$rundir = $1;
		$scriptname = $2;
	} else {
		$rundir = cwd();
	}
	my @path = split(/$separator/, $rundir);
	my $relpath;
	while (my $d = pop @path) {
		$relpath .= "..$separator";
		if ($d eq 'cgi-bin') {
			$relpath .= "..$separator";
			last;
		}
	}
	my $siteshortname = pop @path;
	$relpath .= $siteshortname;

	use DBI;
	require "$relpath/lib/wms_funcs.pm";
	# Load standard lib
	&load_standard_libs($relpath);
	
	# Load custom lib
	# must be the last require statement
	require "$relpath/lib/custom-lib.pm";

	
	return ($scriptname, $relpath);
}
	
