#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# Version 4 TG 20000915
#   Fixed parameters for localize_template
# Version 3 JC 20000822
#   bux fix for master variant display
# Version 2 JC 20000818
#   added removal of old pages
# Version 1 JC 20000814
#   creation based on version 0.9.20
#   of generate site
#


use strict;

#############################################################################
=pod

=head1 generate.pm

generate.pm - Subroutines for creating content management 

=head1 DESCRIPTION

This library is used for the creation of html, wml, and other formated content
files.

=head1 NOTES & BUGS

The calling script must require db_layer.pm

=cut

##############################################################################


sub query_database {

    my ($site) = shift;
    my ($dbh)  = shift;  
 
    my(%objid,$objid,@index,$index,$select_hashref,$q,$numRows,$value);

    keys(%objid)=512;

    $select_hashref = {};
    $select_hashref->{'statement'} = "SELECT";
    $select_hashref->{'TABLE'}->{'NAME'} = "things";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'objid'} = "objid";
    $select_hashref->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("visibility", "110000-A", "and");
    $select_hashref->{'TABLE'}->{'WHERE'}[1] = &build_where_hash("objclass", "134-A", "and");
    $select_hashref->{'TABLE'}->{'WHERE'}[2] = &build_where_hash("visibility", "110000-A", "or");
    $select_hashref->{'TABLE'}->{'WHERE'}[3] = &build_where_hash("objclass", "136-A", "and");
    $q =  &build_sql($select_hashref, $site, $dbh, 1);
    $numRows = &query_getAll($q, $site, $dbh, \@index);

    foreach $value (@index) {
        $objid{$value->{'objid'}}->{'objid'}=$value->{'objid'};
    }

    $objid=\%objid;
    $index=\@index;

    return ($objid,$index); 

}

sub query_things {

    my ($site) = shift;
    my ($dbh) = shift;
    my ($objid) = shift;
    my ($index) = shift;

    my ($select_hashref,$q,$numRows,$value,$values,@results,@index);

    $select_hashref = {};
    $select_hashref->{'statement'} = "SELECT";
    $select_hashref->{'TABLE'}->{'NAME'} = "things";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'objid'} = "objid";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'objclass'} = "objclass";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'objtype'} = "objtype";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'msku'} = "msku";    
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'vcode'} = "vcode";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'language'} = "language";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'ref_from'} = "ref_from";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'title'} = "title"; 
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'brief'} = "brief";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'visibility'} = "visibility";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'pagestyle'} = "pagestyle";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'cellstyle'} = "cellstyle";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'behavior'} = "behavior";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'status'} = "status";
    $select_hashref->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("visibility", "110000-A", "and");
    $q =  &build_sql($select_hashref, $site, $dbh, 1);
    $numRows = &query_getAll($q, $site, $dbh, \@results);

    foreach $value (@results) {

        next if ( ! $value->{'objid'} );

        $value->{'title'} = string_tohtml(string_exmysql($value->{'title'}));
        $value->{'brief'} = string_tohtml(string_exmysql($value->{'brief'}));
        $value->{'pagestyle'} = string_exmysql($value->{'pagestyle'}); 

        $objid->{$value->{'objid'}}->{'objclass'}=$value->{'objclass'};
        $objid->{$value->{'objid'}}->{'objtype'}=$value->{'objtype'};
        $objid->{$value->{'objid'}}->{'msku'}=$value->{'msku'};
        $objid->{$value->{'objid'}}->{'vcode'}=$value->{'vcode'};
        $objid->{$value->{'objid'}}->{'language'}=$value->{'language'};
        $objid->{$value->{'objid'}}->{'ref_from'}=$value->{'ref_from'};
        $objid->{$value->{'objid'}}->{$value->{'language'}}->{'title'}=$value->{'title'};
        $objid->{$value->{'objid'}}->{$value->{'language'}}->{'variant_plaintext'}=$value->{'title'} if ( $value->{'ref_from'} and $value->{'ref_from'} ne $value->{'objid'});
        $objid->{$value->{'objid'}}->{$value->{'language'}}->{'brief'}=$value->{'brief'};
        $objid->{$value->{'objid'}}->{'visibility'}=$value->{'visibility'};
        $objid->{$value->{'objid'}}->{'pagestyle'}=$value->{'pagestyle'};
        $objid->{$value->{'objid'}}->{'cellstyle'}=$value->{'cellstyle'};
        $objid->{$value->{'objid'}}->{'behavior'}=$value->{'behavior'};
        $objid->{$value->{'objid'}}->{'status'}=$value->{'status'};

        if ( $value->{'ref_from'} and $value->{'ref_from'} ne $value->{'objid'} ) {

            push @{$objid->{$value->{'ref_from'}}->{'variant'}}, $value->{'objid'};

        }

    }
    
    return ($objid,$index);

}

sub query_prices {

    my ($site) = shift;
    my ($dbh) = shift;
    my ($objid) = shift;
    my ($index) = shift;

    my ($select_hashref,$q,$numRows,$value,$values,@results,@index);

    $select_hashref = {};
    $select_hashref->{'statement'} = "SELECT";
    $select_hashref->{'TABLE'}->{'NAME'} = "prices";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'objid'} = "objid";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'groupid'} = "groupid";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'unitct'} = "unitct";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'unitpr'} = "unitpr";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'currency'} = "currency";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'ddate'} = "ddate";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'cdate'} = "cdate";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'edate'} = "edate";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'mdate'} = "mdate";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'autogen'} = "autogen";
    $select_hashref->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("status", "15000-A", "and") if ( $site->{'site_datadriver'} !~ /Oracle/ );
    $q =  &build_sql($select_hashref, $site, $dbh, 1);
    $numRows = &query_getAll($q, $site, $dbh, \@results);

    foreach $value (@results) {
        if ( (! $objid->{$value->{'objid'}}->{'unitpr'}) || ($value->{'unitpr'} < $objid->{$value->{'objid'}}->{'unitpr'}) ) {

            $objid->{$value->{'objid'}}->{'groupid'}=$value->{'groupid'};
            $objid->{$value->{'objid'}}->{'unitct'}=$value->{'unitct'};
#            $objid->{$value->{'objid'}}->{'unitpr'}=$value->{'unitpr'};
            $objid->{$value->{'objid'}}->{$value->{'currency'}}->{'unitpr'}=$value->{'unitpr'}; 
            $objid->{$value->{'objid'}}->{'ddate'}=$value->{'ddate'};
            $objid->{$value->{'objid'}}->{'cdate'}=$value->{'cdate'};
            $objid->{$value->{'objid'}}->{'edate'}=$value->{'edate'};
            $objid->{$value->{'objid'}}->{'mdate'}=$value->{'mdate'};
            $objid->{$value->{'objid'}}->{'autogen'}=$value->{'autogen'};

        }

    }

    return ($objid,$index);

}        

sub query_extraprop {

    my ($site) = shift;
    my ($dbh) = shift;
    my ($objid) = shift;
    my ($index) = shift;

    my ($select_hashref,$q,$numRows,$value,$values,@results,@index);

    $select_hashref = {};
    $select_hashref->{'statement'} = "SELECT";
    $select_hashref->{'TABLE'}->{'NAME'} = "extraprop";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'objid'} = "objid";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'fieldname'} = "fieldname";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'body'} = "body"; 
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'language'} = "language";
#    $select_hashref->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("status", "15000-A", "and"); 
    $q =  &build_sql($select_hashref, $site, $dbh, 1);
    $numRows = &query_getAll($q, $site, $dbh, \@results);

    foreach $value (@results) {

        $value->{'body'}=string_tohtml(string_exmysql($value->{'body'}));

        $objid->{$value->{'objid'}}->{$value->{'language'}}->{$value->{'fieldname'}} = $value->{'body'};
        $objid->{$value->{'objid'}}->{$value->{'language'}}->{'variant_plaintext'} = $value->{'body'} if ( $value->{'fieldname'}=~ /title/&& $objid->{$value->{'objid'}}->{'vcode'} );
    }
    return ($objid,$index);

}            

sub query_inventory {

    my ($site) = shift;
    my ($dbh) = shift;
    my ($objid) = shift;
    my ($index) = shift;

    my ($select_hashref,$q,$numRows,$value,$values,@results,@index);

    $select_hashref = {};
    $select_hashref->{'statement'} = "SELECT";
    $select_hashref->{'TABLE'}->{'NAME'} = "inventory";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'lstock'} = "lstock";
    $q =  &build_sql($select_hashref, $site, $dbh, 1);
    $numRows = &query_getAll($q, $site, $dbh, \@results);

    foreach $value (@results) {

        $objid->{$value->{'objid'}}->{'lstock'} = $value->{'lstock'};

    }

    return ($objid,$index);

}  

sub query_linkage {

    my ($site) = shift;
    my ($dbh) = shift;

    my ($select_hashref,$q,$numRows,$value,$values,@results,@index);
    my ($linkup,$linkdown,$link_hash);

    $select_hashref = {};
    $select_hashref->{'statement'} = "SELECT";
    $select_hashref->{'TABLE'}->{'NAME'} = "linkage";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'objid'} = "objid";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'obj1'} = "obj1";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'obj2'} = "obj2";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'linkwt_sys'} = "linkwt_sys"; 
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'linkwt_man'} = "linkwt_man";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'linkwt_use'} = "linkwt_use";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'cellstyle'} = "cellstyle";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'celldepth'} = "celldepth"; 
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'visibility'} = "visibility";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'status'} = "status";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'ddate'} = "ddate";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'cdate'} = "cdate"; 
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'edate'} = "edate";
    $select_hashref->{'TABLE'}->{'FIELDS'}->{'mdate'} = "mdate";  
    $q =  &build_sql($select_hashref, $site, $dbh, 1);
    $numRows = &query_getAll($q, $site, $dbh, \@results);

    foreach $value (@results) {

        $value->{'cellstyle'}=string_exmysql($value->{'cellstyle'});

        $link_hash = {

            'objid'  => $value->{'objid'},
            'obj1'   => $value->{'obj1'}, 
            'obj2'   => $value->{'obj2'},
            'linkwt_sys' => $value->{'linkwt_sys'}, 
            'linkwt_man' => $value->{'linkwt_man'},
            'linkwt_use' => $value->{'linkwt_use'}, 
            'cellstyle' => $value->{'cellstyle'},
            'celldepth' => $value->{'celldepth'}, 
            'visibility' => $value->{'visibility'},
            'status' => $value->{'status'}, 
            'ddate' => $value->{'ddate'},
            'cdate' => $value->{'cdate'}, 
            'edate' => $value->{'edate'},
            'mdate' => $value->{'mdate'}, 

        };

        ## linkup refers to the topnav bar at the top of the page
        push @{$linkup->{$value->{'obj2'}}}, $link_hash;

        ## linkdown refers to the cells that need to be generated on the page
        push @{$linkdown->{$value->{'obj1'}}}, $link_hash;

    }

    return ($linkup,$linkdown);

} 

sub build_pages {

    my ($site) = shift;
    my ($dbh) = shift;
    my ($objid) = shift;
    my ($extra) = shift; 
    my ($linkup) = shift;
    my ($linkdown) = shift; 

    my ($tot_page,$objids,%objid,$targetpath,$templates,$targ,$tn,$thispage,%templates,%nccol,$columns,%columns);
    my (@links,@variants,$foobar,%linkdown,@temp,$variant,$h,$q,$i,$replacetitle,%h,$image,@currs_sys,$stock,@currs);
    my ($curr,$currs,$curr_create,$thispage,$interface,$filetype,%catch,%extantvars,$space,$tobereplace,$search_page,$t);
    my (@langs,$notlangs,$lang,@langsgen,@interfaces,$om_render_lang,$language,@currs_sym,$currsym);

    ## get languages that will be used to generate template
    #
    @langs=split /,/, $site->{'om_locale_lang_act'};
    $notlangs=$site->{'om_locale_lang_inact'}; # inactive languages
    @langsgen=($site->{'om_locale_lang_def'});  # include default language

    if ( $notlangs ) {
        foreach $lang (@langs) {
            if ( $notlangs !~ $lang ) { push @langsgen,$lang; }; # do not include languages that are inactive
        } # done checking for inactive languages
    }  elsif ( @langs ) {
        push @langsgen,@langs;
    }


    @interfaces=split /,/, $site->{'interfaces'};
    if ( ! @interfaces ) { @interfaces="html"; }   

    ## page generation
    #
    $tot_page = 0;
    foreach $objids ( sort keys %{$objid} ) {
        next if ( $objid->{$objids}->{'visibility'} ne "110000-A" );
      foreach $language (@langsgen) {
      $site->{'om_render_lang'} = $language;    
        @links=();
# hard coded interface and language for development
        $targetpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/html/$site->{'om_render_lang'}/auto";
# hard coded interface and language for development
        $targ = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/html/$site->{'om_render_lang'}/auto/$objids.shtml";

        $tn=$objid->{$objids}->{'pagestyle'}; 
        $tn="page_product_master" if ( ! $tn );
        $tn="page_product_master_vv" if ( ( $objid->{$objids}->{'vcode'} ) and ( $tn =~ /master$/ )); 

        if ( $objid->{$objids}->{'vcode'} ) { 
# hard coded language
            $objid->{$objids}->{$site->{'om_render_lang'}}->{'descript'}=$objid->{$objid->{$objids}->{'ref_from'}}->{$site->{'om_render_lang'}}->{'descript'};
            $objid->{$objids}->{$site->{'om_render_lang'}}->{'alttitle'}=$objid->{$objid->{$objids}->{'ref_from'}}->{$site->{'om_render_lang'}}->{'alttitle'}; 
            $objid->{$objids}->{$site->{'om_render_lang'}}->{'brief'}=$objid->{$objid->{$objids}->{'ref_from'}}->{$site->{'om_render_lang'}}->{'brief'};

        }
         if ( $site->{'om_locale_lang_def'} ne $site->{'om_render_lang'} ) {

             $objid->{$objids}->{$site->{'om_render_lang'}}->{'brief'} = $objid->{$objids}->{$site->{'om_locale_lang_def'}}->{'brief'} if (! $objid->{$objids}->{$site->{'om_render_lang'}}->{'brief'} );

             $objid->{$objids}->{$site->{'om_render_lang'}}->{'title'} = $objid->{$objids}->{$site->{'om_locale_lang_def'}}->{'title'} if (! $objid->{$objids}->{$site->{'om_render_lang'}}->{'title'} ); 

             #$objid->{$objids}->{$site->{'om_render_lang'}}->{'variant_plaintext'} = $objid->{$objids}->{$site->{'om_locale_lang_def'}}->{'title'} if (! $objid->{$objids}->{$site->{'om_render_lang'}}->{'variant_plaintext'} ); 


             $objid->{$objids}->{$site->{'om_render_lang'}}->{'descript'} = $objid->{$objids}->{$site->{'om_locale_lang_def'}}->{'descript'} if (! $ objid->{$objids}->{$site->{'om_render_lang'}}->{'descript'} ); 
         }      


# hard coded interface and language for development       

        ($templates{$tn},$columns{$tn})=&templatecheck( $tn, "html", $site);

        $thispage = $templates{$tn};
        %nccol=%{$columns{$tn}};  # number of columns per cell width

if ( $objid->{$objids}->{'vcode'} ) { $objid->{$objids}->{$site->{'om_render_lang'}}->{'variant_plaintext'}=""; };
#print "$objid->{$objids}->{'vcode'} \t $objids \t $templates{$tn}\n";
            ######
            ### Start Generation of on-page Cells
            ######

            ## load down linkage data of relevance
            #
            @links = @{$linkdown->{$objids}} if defined $linkdown->{$objids};

            @links = sortlinks(@links);
            ## override default linkage for master products - show only variants
            #
            if ( $objid->{$objids}->{'ref_from'} and $objids eq $objid->{$objids}->{'ref_from'} ) {
                @links=();
                ## create link to own variants
                #
                @temp = @{$objid->{$objids}->{'variant'}} if ($objid->{$objids}->{'variant'});
                foreach $variant ( @temp ) {
                    $h=();
                    $h->{'obj1'}=$objids;             # from this sku
                    $h->{'obj2'}=$variant;
                    $h->{'title'}=$objid->{$variant}->{$site->{'om_render_lang'}}->{'title'};     # needs a title
                    $h->{'linkwt_use'}=$objid->{$variant}->{'weight_use'}; # relative weight
#                   $h->{'cellstyle'}=$defcells{'variants'};
## hard coded cell style
                    $h->{'cellstyle'}="cell_140_master_vv";
                    push @links, $h;
                } # done pushing phony links up
            } # done with load       


         ## generate cells from this...
         #     go through links in order, construct %expand{colwidth}
         #
         my %expand=(); # holds expanded strings for column substitution
         my %cellct=(); # count of linkage cells per cellwidth
         foreach my $i ( 0..$#links ) {
            my $q="";
            my $u=$links[$i]->{'cellstyle'} ;
            next if ( ! $objid->{$links[$i]->{'obj2'}}->{'visibility'} );
          #next if ( length($u)<8 );

            my %filler;
            my $x= ( split /_/, $u )[1];

            ( $templates{$u}, $filler{$u} ) = &templatecheck( $u, "html", $site, $templates);

            if ( $expand{$x} ) {
               $cellct{$x}++;
               $expand{$x}.="\n <!-- START_ELEMENT_$cellct{$x} --> \n";
            } else {
               $cellct{$x}=1;
               $expand{$x}="<!-- start of column -->\n";
               $expand{$x}.="\n <!-- START_ELEMENT_$cellct{$x} --> \n";
            }
            ## add subcell handling...                                                                                               #

            ## overwrite default fields with manual entries
            #     just TITLE for now...
            my %h=%{$objid->{$links[$i]->{'obj2'}}};
            my %h=%{$objid->{$links[$i]->{'obj2'}}->{$site->{'om_render_lang'}}} if ($objid->{$links[$i]->{'obj2'}}->{$site->{'om_render_lang'}});
            $h{'title'}=$objid->{$links[$i]->{'obj2'}}->{$site->{'om_render_lang'}}->{'title'};
            $h{'brief'}=$objid->{$links[$i]->{'obj2'}}->{$site->{'om_render_lang'}}->{'brief'};
            $h{'objid'}=$objid->{$links[$i]->{'obj2'}}->{'objid'};
            $h{'descript'}=$objid->{$links[$i]->{'obj2'}}->{$site->{'om_render_lang'}}->{'descript'}; 
            $h{'plaintext_variant'}=$objid->{$links[$i]->{'obj2'}}->{$site->{'om_render_lang'}}->{'plaintext_variant'}; 
# hard coded language
#            $h{'title'}=$objid->{$links[$i]->{'obj2'}}->{'variant_plaintext'} if ( $objid->{$links[$i]->{'obj2'}}->{'vcode'} );
#            $h{'title'}=$objid->{$links[$i]->{'objid'}}->{$site->{'om_render_lang'}}->{'alttitle'} if ( $objid->{$links[$i]->{'objid'}}->{$site->{'om_render_lang'}}->{'alttitle'} && $objid->{$links[$i]->{'objid'}}->{$site->{'om_render_lang'}}->{'status'} eq "15000-A");
            my $image=$objids."_80x80.jpg";
            my $image2=$objids.".gif";
# hardcoded language
            if ( -e "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/$site->{'om_render_lang'}/products/80/$image" || -e "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/$site->{'om_render_lang'}/duotone/$image2" ) {
               $h->{'image'}=$objids;
               $h{'image'}=$objids;
            } else {                 

               $h->{'image'}="default";
               $h{'image'}="default";


            }
            $h{'unitpr'}=$objid->{$links[$i]->{'obj2'}}->{$site->{'om_locale_curr_def'}}->{'unitpr'}; 
            
            my %stock={};

            @currs_sys = split/,/, $site->{'currency_symbol'};
            @currs=split /,/, $site->{'om_locale_curr_act'};    

            $h{'currency_symbol'} = $currs_sys[0]; 
            $i=0;
            foreach $currs (@currs_sys) {
                next if $currs eq $h{'currency_symbol'};
                @currs_sym[$i]=$currs; 
                $i++;
            }
            
            $site->{'objid'} = $objids; 
            my $tempvar = $h{'objid'};
            if (($stock{$tempvar} <=  0) and ($objid->{$tempvar}->{'behavior'} =~ /(os|dp)/ )) {
# hardcoded language
              $h{'cartlink'} = localize_template("cell_product_outstock_button", "html", 0, $site);
              $h{'cartlink'} = permutebit($h{'cartlink'}, $site);
              $h{'cartlink'} = permutebit($h{'cartlink'}, \%h);  
            } else {
              $tempvar = $h{'objid'};
# hardcoded language
              $h{'cartlink'} = localize_template("cell_product_purchase_button", "html", 0, $site);
              $h{'cartlink'} = permutebit($h{'cartlink'}, \%h);
              $h{'cartlink'} = permutebit($h{'cartlink'}, $site);
              $objid->{$objids}->{'cartlink'} = permutebit($h{'cartlink'}, $objid);
            }
            $objid->{$objids}->{'multicurrency_cartlink'} = ""; 

            @currs=split /,/, $site->{'om_locale_curr_act'};
                foreach $curr (@currs) {
          #        $h{'unitpr'}=$objid->{$objids}->{$site->{'om_locale_curr_act'}}->{'unitpr'};
                  $i=0;
                  if ( $objid->{$objids}->{$curr}->{'unitpr'} ) {
                      $h{'om_locale_curr_def'} = $curr;
                      $h{'currency_symbol'} = $currs_sym[$i];
                      $h{'unitpr'} = $objid->{$objids}->{$curr}->{'unitpr'};
                      $curr_create = localize_template("cell_product_purchase_button", "html", 0, $site);
                      $curr_create = permutebit( $curr_create, \%h );
                      $curr_create = permutebit( $curr_create, $site );
                      $objid->{$objids}->{'multicurrency_cartlink'} .= $curr_create;
                  }
                  $i++;
              }
     #hard code language
              $objid->{$objids}->{'wishlistlink'} = "<INPUT TYPE=HIDDEN NAME=currency VALUE=\"$site->{'om_locale_curr_def'}\"> \n
<input type=\"image\" src=\"/images/$site->{'om_render_lang'}/buttons/wishlist.gif\" BORDER=0 alt=\"add to wishlist\">";          
             $q=permutebit( $templates{$u}, \%h );
             $expand{$x}.=$q;
         } # done constructing gross column substitution units
         ## now construct bits in case multiple columns per width
         #  

         ## split up column substitution strings as needed
         #
         foreach my $w ( keys %nccol ) {
            my $n = $nccol{$w};
            if ( $n == 1 ) {
               my $k="column_$w"."_1";
               $objid->{$objids}->{$k}=$expand{$w};
               ## geometry addin
               $expand{$w} =~ s/__c__/$n/g;

               my @temp_str = split /\n/, $expand{$w};
               my $temp_out = "";
               my $temp_r=0;
               foreach (@temp_str) {
                  if ($_ =~ /START_ELEMENT/) { $temp_r++; }
                  $_ =~ s/__r__/$temp_r/g;
                  $temp_out .= $_ . "\n";
               }
               $expand{$w} = $temp_out;

               $objid->{$objids}->{$k}=$expand{$w};
            } else {
               my $u = $cellct{$w}/$nccol{$w};
               if ( $u>int($u) ) {
                  $u=int($u)+1;
               }
               # use $u cells per column of this type
               ## assemble columns
               #
               foreach my $k ( 1..$n ) {
                  my $min = (( $k - 1 ) * $u ) + 1 ;
                  my $max = ($k * $u) + 1;
                  next if ( $min > $cellct{$w} );
                  $min='<!-- START_ELEMENT_'.$min.' -->';
                  $max='<!-- START_ELEMENT_'.$max.' -->';
                  if ( $expand{$w} =~ /$min/ ) { # there is something to cut
                     $q = ( split /$min/, $expand{$w} )[1];
                  } else {
                     $q = $expand{$w};
                  } # done cutting too early bits
                  if ( $k < $n ) {               
                     $q = ( split( /$max/, $q ) )[0]
                     if ( $max < $cellct{$w} ) ;
                  } # done cutting too late bits
                  $q =~ s/__c__/$k/g;#

                  my $temp_r = 0;

                  my @temp_str = split /\n/, $q;
                  my $temp_out = "";

                  foreach (@temp_str) {
                     if ($_ =~ /START_ELEMENT/) { $temp_r++; }
                     $_ =~ s/__r__/$temp_r/g;
                     $temp_out .= $_ . "\n";
                  }
                  $q = $temp_out;


                  my $ky="column_$w"."_$k";
                  $objid->{$objids}->{$ky}=$q;
               } # done assembling column bits
            } # done with split or not split branches
         } # done splitting up columns for substitution into template  

         ## topnav construction -- load "up" linkage data of relevance  
         #
         @links= ();
         @links = @{$linkup->{$objids}} if ($linkup->{$objids});
        
         ## push link for main sku if the vcode nonnull
         #
         if ( $objid->{$objids}->{'vcode'} ) {
            $h={};
            $h->{'obj1'}=$objid->{$objids}->{'ref_from'};
            $h->{'obj2'}=$objids;
            $h->{'title'}=$objid->{$objid->{$objids}->{'ref_from'}}->{$site->{'om_render_lang'}}->{'title'};
            $h->{'linkwt_use'}=$objid->{$objid->{$objids}->{'ref_from'}}->{'weight_use'};
            push @links, $h;
#            push @links, @{$linkup->{$objid->{$objids}->{objid}}};
         } # done forging linkage

         ## create sorted list on weight
         #
         @links = sortlinks( @links );

         ## construct topnav
         #
         my %knownlinks=();                              # blank hash for links
         $q="";

         my $x = $#links;

         $x=($site->{'maxtopnav'} - 1) if ( $x > ( $site->{'maxtopnav'} - 1) );
         foreach $i ( 0..$x ) {
            # check for duplicate links
            next if ( $knownlinks{$links[$i]->{'obj1'}} );
            next if ( ! $objid->{$links[$i]->{'obj1'}}->{$site->{'om_render_lang'}}->{'title'} );
            $knownlinks{$links[$i]->{'obj1'}}="here";  # note "been here, done that"
            $q.=" - " if ( $q );
## hard coded language
            $q.='&nbsp;<A HREF="/html/'.$site->{'om_render_lang'}.'/'.$links[$i]->{'obj1'}.'.shtml">';
            $q.=$objid->{$links[$i]->{'obj1'}}->{$site->{'om_render_lang'}}->{'title'};
            $q.='</A>&nbsp;';
            $replacetitle=$objid->{$links[$i]->{'obj1'}}->{$site->{'om_render_lang'}}->{'title'};
         } # done constructing topnav  

    

         ## insert topnav if real, otherwise insert include of default
         if ( length($q)>2 ) {  
             $objid->{$objids}->{'jump_to_nav'} = $q;
	 } else {
## hard coded script message and language
             $objid->{$objids}->{'jump_to_nav'} = "<a href=\"/html/$site->{'om_render_lang'}/home.shtml\">Home Page</a>";
         }  # done with jump_to_nav     

         $h{'unitpr'}=$objid->{$objids}->{$site->{'om_locale_curr_def'}}->{'unitpr'}; 
         ## computed field-like things...
         #
         #   
#hard code language
         if ( -e "/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/$site->{'om_render_lang'}/headers/$objids.gif" ) {
            $objid->{$objids}->{'headergif'} = "$objids.gif";
         } else {
            $objid->{$objids}->{'headergif'} = "genericheader.gif";
         } #/headers

         $image=$objids."_80x80.jpg";

            @currs_sys = split/,/, $site->{'currency_symbol'};                                                                                    @currs=split /,/, $site->{'om_locale_curr_act'};

            $h{'currency_symbol'} = $currs_sys[0];     
            $i=0;
            foreach $currsym (@currs_sys) {
                next if $currsym eq $h{'currency_symbol'};  
                @currs_sym[$i]=$currsym;
                $i++;
            }  
#hard code lanuage 
         if ( -e "/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/$site->{'om_render_lang'}/products/80/$image" || -e "/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/$site->{'om_render_lang'}/duotone/$image" ) {
             $objid->{$objids}->{'image'} = $objids;
         } else {
             $objid->{$objids}->{'image'} = "default";
         }
$site->{'objid'} = $objids;
         if (($stock->{$objids} < 1) and ($objid->{$objids}->{'behavior'} =~ /(os|dp)/ )) {
              $h{'cartlink'} = localize_template("cell_product_outstock_button", "html", 0, $site);
              $h{'cartlink'} = permutebit($h{'cartlink'}, $site);
              $h{'cartlink'} = permutebit($h{'cartlink'}, \%h);
         } else {
              @currs_sys = split/,/, $site->{'currency_symbol'};
              $h{'unitpr'}=$objid->{$objids}->{$site->{'om_locale_curr_def'}}->{'unitpr'}; 
              $h{'currency_symbol'}=$currs_sys[0];
              $h{'om_locale_curr_def'} = $site->{'om_locale_curr_def'};
              $h{'cartlink'} = localize_template("cell_product_purchase_button", "html", 0, $site);
              $h{'cartlink'} = permutebit($h{'cartlink'}, \%h);
              $h{'cartlink'} = permutebit($h{'cartlink'}, $site);
              $objid->{$objids}->{'cartlink'} = permutebit($h{'cartlink'}, $objid);

         }
         $objid->{$objids}->{'multicurrency_cartlink'} = "";
         @currs=split /,/, $site->{'om_locale_curr_act'};
         $i=0;
         foreach $curr (@currs) {
     #        $h{'unitpr'}=$objid->{$objids}->{$site->{'om_locale_curr_act'}}->{'unitpr'};
             if ( $objid->{$objids}->{$curr}->{'unitpr'} ) {
                 $h{'om_locale_curr_def'} = $curr;
                 $h{'currency_symbol'} = $currs_sym[$i];
                 $h{'unitpr'} = $objid->{$objids}->{$curr}->{'unitpr'};
                 $curr_create = localize_template("cell_product_purchase_button", "html", 0, $site);
                 $curr_create = permutebit( $curr_create, \%h );
                 $curr_create = permutebit( $curr_create, $site );                                                      
                 $objid->{$objids}->{'multicurrency_cartlink'} .= $curr_create;
             }
             $i++;              
         }  
#hard code language
         $objid->{$objids}->{'wishlistlink'} = "<INPUT TYPE=HIDDEN NAME=currency VALUE=\"$site->{'om_locale_curr_def'}\"> \n
<input type=\"image\" src=\"/images/$site->{'om_render_lang'}/buttons/wishlist.gif\" BORDER=0 alt=\"add to wishlist\">"; 

         ## backgroundimage
         #
         $objid->{$objids}->{'site_background'} = $site->{'site_background'};
         $objid->{$objids}->{'sitename'} = $site->{'sitename'};
         ## permute the file and dump to the filesystem
         #
         if ( $objid->{$objids}->{'vcode'} ) { $objid->{$objids}->{$site->{'om_render_lang'}}->{'variant_plaintext'}=""; };
         $thispage=permutebit($thispage, $objid->{$objids}->{$site->{'om_render_lang'}});
         $t=permutebit( $thispage, $objid->{$objids} );
         ## permute any variables from site hash
         #

         $t=permutebit( $t, $site ); 
#hard code interface
         $search_page = localize_template("cell_search", "html", 0, $site );
         $search_page =~ s/__exact_inp__/ CHECKED/gms;   # set the exact search as the default
         $t =~ s/__cell_search__/$search_page/gms;
         $t=permuteclean( $t  );

#         if ( $interface eq "html" || $interface eq "palm" ) {
#            $filetype="shtml";
#         }  else {
#            $filetype=$interface;
#         }

# hard code file type
         $filetype="shtml";

         if ($catch{$objids} ne "yes" ) {
            open( FH, ">$targetpath/$objids.$filetype" );

            print FH $t;
            close(FH);
            $tot_page++;
         }                 

#         if ( $interface eq "html" ) {


            @temp=split /\t/, $extantvars{$objids};


            if (($#temp==0)  && (length($objids) > 8) ) {

               $space="";
# hard code language
               $tobereplace="<A HREF=\"/html/$site->{'om_render_lang'}/$objids.shtml\">$replacetitle</A>";

               $t=~ s/$tobereplace/$space/g;

               $t=~ s/<\!--replace-->/$objid->{$objids}->{'jump_to_nav'}/g;
# hard code language
               $t=~ s/<a href=\"\/html\/$site->{'om_render_lang'}\/$objids.shtml\"><IMG SRC=\"\/images\/$site->{'om_render_lang'}\/buttons\/view_button.gif/<IMG SRC=\"\/images\/$site->{'om_render_lang'}\/general\/clear.gif/g;
               open (FH2, ">$targetpath/$objids.$filetype");
               print FH2 $t;
               close(FH2);
               $tot_page++;
               $catch{$objids}="yes";
            }

#        }             
      } # lang loop

    }

## generate links
#

`$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/crons/update_symlinks.pl`;
                                                                             

}

sub readcols {
   my(@cols,$s);
   $s=$_[0];
   @cols = ( $s =~ m/__column_(\w+?)__/gs );
   return @cols;
} #/readcols

sub templatecheck {
   my($om_render_lang,$interface,@temp2,$h,%templates,$k,$v,%columns);
   my $tn = shift;
   my $interface = shift;
   my $site = shift;
   my $templates = shift;
    %templates = %{$templates} if ( $templates);
#   if ( ! exists($templates{$tn}) ) {
      # need to load the template
      $templates{$tn}=&localize_template( $tn, $interface, 0, $site );

#      print "Loading template $tn also $templates{$tn}\n";

      @temp2 = readcols($templates{$tn});
      $h={};
      while (@temp2) {
         ( $k,$v ) = ( split /_/, shift @temp2 )[0..1];
         $h->{$k}=$v if ( ! exists ( $h->{$k} ) );
         $h->{$k}=$v if ( $v > $h->{$k} );
      } # done running through columns
      $columns{$tn} = $h;
#   } # done seeing if the template needs loaded
   return ($templates{$tn}, $columns{$tn} );
} #/templatecheck 

sub generate_specific {

    my $objid_one = shift;
    my $site_one = shift;
    my $dbh = shift;
    my ($objid,$index,$linkup,$linkdown);

my $site = setsite();

    ($objid,$index)=&query_database($site,$dbh);
    ($objid,$index)=&query_things($site,$dbh,$objid,$index);
    ($objid,$index)=&query_prices($site,$dbh,$objid,$index);
    ($objid,$index)=&query_extraprop($site,$dbh,$objid,$index);
    ($objid,$index)=&query_inventory($site,$dbh,$objid,$index);
    ($linkup,$linkdown)=&query_linkage($site,$dbh);
    &build_pages($site,$dbh,$objid,$index,$linkup,$linkdown);

}   

1;
