#!/usr/local/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################   

use strict;

##############################################################################
=pod

=head1 generate_temps.pm

generate_temps.pm - Subroutine for creating sel and gui files 

=head1 DESCRIPTION

This library is used for creating the sel and gui files found
in bits/<lang>/html/sel 

=head1 NOTES & BUGS

=cut

##############################################################################   

##############################################################################
=pod

=head2 generate_temps

generate_temps - &create_object($dbh, $site);

=over 4

=item DESCRIPTION

This subroutine is used for creating the sel and gui files found
in bits/<lang>/html/sel

=item INPUT

$site - A hashref containing information required throughout about the current
        site and session

$dbh - current active database handle

=item OUTPUT

=item NOTES

$site->{'om_render_language'},$site->{'objid'}, and $site->{'extra'} must
be passed in via $site.

=back

=cut
###############################################################################                           

sub generate_temps {
    my ($dbh) = shift; 
    my ($site) = shift;
    my ($objid) = shift;
    my ($extra) = shift;

    my ($s,$datapath,$q,$sth,$v,$k,$title);
    my ($f,$temp,@pulldown,$num,$scriptname,%script_err,$x);
    my ($verbose_errors,$script,$select_hashref,$numRows,@results,$value, %script_msg);

    %script_msg = &get_messages($site->{'om_render_lang'},"generate_temps",$site);

    $datapath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/html/sel";

    chdir( $datapath );          # move into the datapath directory

    ## generate pulldown data file
    #
    open FH, ">$datapath/$objid.sel" || die "$script_msg{'temps_open'} $datapath/$objid.sel";
#print "$objid.sel";
    ## sku_series (brands) pulldown ( in things )
    #

    # don't want to take the _gui selection
    if (( $objid eq "47004-A" ) && (!defined $extra)) {

        $select_hashref = {};
        $select_hashref->{'statement'} = "SELECT";
        $select_hashref->{'TABLE'}->{'NAME'} = "things";
        $select_hashref->{'TABLE'}->{'FIELDS'}->{'objid'} = "objid";  
        $select_hashref->{'TABLE'}->{'FIELDS'}->{'title'} = "title";
        $select_hashref->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("objtype", "$objid", "and");
        $select_hashref->{'TABLE'}->{'WHERE'}[1] = &build_where_hash("status", "15000-A", "and"); 
        $select_hashref->{'TABLE'}->{'ORDER'} = "title DESC"; 
        $q =  &build_sql($select_hashref, $site, $dbh, 1);
        $numRows = &query_getAll($q, $site, $dbh, \@results);

        print FH "| Not Specified\n";
        foreach $value (@results) {
            $k = $value->{'objid'};
            $v = $value->{'title'};
            $v=string_exdbi($v); 
#print "$k \t $v \n";
            print FH "$k\| $v \n"; 
        }
                                                               
        $select_hashref = {};
        $select_hashref->{'statement'} = "SELECT";
        $select_hashref->{'TABLE'}->{'NAME'} = "things";
        $select_hashref->{'TABLE'}->{'FIELDS'}->{'title'} = "title";
        $select_hashref->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("objid", "$objid", "and");
        $q =  &build_sql($select_hashref, $site, $dbh, 1);
        $numRows = &query_getAll($q, $site, $dbh, \@results);

        $title=$results[0]->{'title'};

        ## other pulldowns (ones in extraprop)
        #


    }
    elsif ( $objid eq "74003-A" ) {

        $select_hashref = {};
        $select_hashref->{'statement'} = "SELECT";
        $select_hashref->{'TABLE'}->{'NAME'} = "things";
        $select_hashref->{'TABLE'}->{'FIELDS'}->{'objid'} = "objid";
        $select_hashref->{'TABLE'}->{'FIELDS'}->{'title'} = "title";
        $select_hashref->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("objtype", "$objid", "and");
        $select_hashref->{'TABLE'}->{'WHERE'}[1] = &build_where_hash("status", "15000-A", "and");
        $select_hashref->{'TABLE'}->{'ORDER'} = "title DESC";
        $q =  &build_sql($select_hashref, $site, $dbh, 1);
        $numRows = &query_getAll($q, $site, $dbh, \@results);

        foreach $value (@results) {
            $k = $value->{'objid'};
            $v = $value->{'title'};
            $v=string_exdbi($v);
            print FH "$k\| $v \n";
#print "$k \t $v \n";
        }                       

        $select_hashref = {};
        $select_hashref->{'statement'} = "SELECT";
        $select_hashref->{'TABLE'}->{'NAME'} = "things";
        $select_hashref->{'TABLE'}->{'FIELDS'}->{'title'} = "title";
        $select_hashref->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("objid", "$objid", "and");
        $q =  &build_sql($select_hashref, $site, $dbh, 1);
        $numRows = &query_getAll($q, $site, $dbh, \@results);

        $title=$results[0]->{'title'}; 

        ## other pulldowns (ones in extraprop)
        #
    }
    # GUI def
    elsif ( $objid eq "99002-A" ) {
#print "$datapath \n";
        open FH2, ">$datapath/$extra.gui" || die "$script_msg{'temps_open'} $datapath/$extra.sel";

        $select_hashref = {};
        $select_hashref->{'statement'} = "SELECT";
        $select_hashref->{'TABLE'}->{'NAME'} = "extraprop";
        $select_hashref->{'TABLE'}->{'FIELDS'}->{'body'} = "body";
        $select_hashref->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("objid", "$extra", "and");
        $select_hashref->{'TABLE'}->{'WHERE'}[1] = &build_where_hash("fieldname", "gui_name", "and");
        $q =  &build_sql($select_hashref, $site, $dbh, 1);
        $numRows = &query_getAll($q, $site, $dbh, \@results);

        $f=$results[0]->{'body'}; 

        $select_hashref = {};
        $select_hashref->{'statement'} = "SELECT";
        $select_hashref->{'TABLE'}->{'NAME'} = "extraprop";
        $select_hashref->{'TABLE'}->{'FIELDS'}->{'body'} = "body";
        $select_hashref->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("objid", "$extra", "and");
        $select_hashref->{'TABLE'}->{'WHERE'}[1] = &build_where_hash("fieldname", "gui", "and");
        $q =  &build_sql($select_hashref, $site, $dbh, 1);
        $numRows = &query_getAll($q, $site, $dbh, \@results);

        $v=$results[0]->{'body'};                         

        $v =~ s/\r//g;
        $v = string_exdbi($v);
        @pulldown=split(/\n/,$v);
        for ($x=0; $x<=$#pulldown; $x++) {
            $pulldown[$x] =~ s/\n//gms;
            $temp = $pulldown[$x];
            $temp =~ s/ //gms;
       # only print if there is something to print
            if (length($temp) > 0) {
                print FH2 "$pulldown[$x] \n";
#print "$pulldown[$x] \n";
            }
        }                                      
        $select_hashref = {};
        $select_hashref->{'statement'} = "SELECT";
        $select_hashref->{'TABLE'}->{'NAME'} = "things";
        $select_hashref->{'TABLE'}->{'FIELDS'}->{'title'} = "title";
        $select_hashref->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("objid", "$extra", "and");
        $q =  &build_sql($select_hashref, $site, $dbh, 1);
        $numRows = &query_getAll($q, $site, $dbh, \@results);

        $title=$results[0]->{'title'};
        $title=$f if $f;
        close FH2;
    }
    else {

        $select_hashref = {};
        $select_hashref->{'statement'} = "SELECT";
        $select_hashref->{'TABLE'}->{'NAME'} = "extraprop";
        $select_hashref->{'TABLE'}->{'FIELDS'}->{'body'} = "body";
        $select_hashref->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("objid", "$objid", "and");
        $select_hashref->{'TABLE'}->{'WHERE'}[1] = &build_where_hash("fieldname", "sel_name", "and");
        $q =  &build_sql($select_hashref, $site, $dbh, 1);
        $numRows = &query_getAll($q, $site, $dbh, \@results);
        $f=$results[0]->{'body'};
#        print FH "| Not Specified\n";
        $select_hashref = {};
        $select_hashref->{'statement'} = "SELECT";
        $select_hashref->{'TABLE'}->{'NAME'} = "extraprop";
        $select_hashref->{'TABLE'}->{'FIELDS'}->{'body'} = "body";
        $select_hashref->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("objid", "$objid", "and");
        $select_hashref->{'TABLE'}->{'WHERE'}[1] = &build_where_hash("fieldname", "encoding", "and");
        $q =  &build_sql($select_hashref, $site, $dbh, 1);
        $numRows = &query_getAll($q, $site, $dbh, \@results);
        $v=$results[0]->{'body'};
        $v =~ s/\r//g;
        $v = string_exdbi($v);
        @pulldown=split(/\n/,$v);
        for ($x=0; $x<=$#pulldown; $x++) {
            print FH "$pulldown[$x] \n";
#print "$pulldown[$x] \n";
        }
        $select_hashref = {};
        $select_hashref->{'statement'} = "SELECT";
        $select_hashref->{'TABLE'}->{'NAME'} = "things";
        $select_hashref->{'TABLE'}->{'FIELDS'}->{'title'} = "title";
        $select_hashref->{'TABLE'}->{'WHERE'}[0] = &build_where_hash("objid", "$objid", "and");
        $q =  &build_sql($select_hashref, $site, $dbh, 1);
        $numRows = &query_getAll($q, $site, $dbh, \@results);
        $title=$results[0]->{'title'}; 
        $title=$f if $f;
    }

    close FH;

    $title =~ tr/A-Z/a-z/;
    $title =~ s/\s//g;
    $title =~ s/\\//g; 
#print "$datapath \t $objid \t $extra \t $title \n";
    if ( $objid eq "47004-A" ) {
        if ( $^O !~ /MSWin32/) {
            `/bin/ln -fs 47004-A.sel sel_sku_series.sel`;
        } else {
            rename("47004-A.sel","sel_sku_series.sel");
        }
    }
    elsif ($objid eq "74003-A") {
        if ( $^O !~ /MSWin32/) {
            `/bin/ln -fs 74003-A.sel sel_warehouse.sel`;
        } else {
           rename("74003-A.sel","sel_warehouse.sel");
        }
    }
    elsif ($objid eq "99002-A") {
        if ( $^O !~ /MSWin32/) {
            `/bin/ln -fs "$extra.gui" "$title.gui"`;
        } else {
           rename("$extra.gui","$title.gui");
        }
    } elsif ( $title =~ /^(sel\_)/ ) {
        if ( $^O !~ /MSWin32/) {
            `/bin/ln -fs "$objid.sel" "$title.sel"`;
        } else {
            rename("$objid.sel","$title.sel");     
        }
    } else {
        if ( $^O !~ /MSWin32/) {
            `/bin/ln -fs "$objid.sel" "$title.sel"`;
        } else {
            rename("$objid.sel","$title.sel");
        }
    }


    if ( $^O !~ /MSWin32/) { `chown nobody:nobody $datapath/*.sel`; }
                                        
}

sub debug {


}

1;
