#!/usr/local/perl

use strict;


sub check_for_page {

    my (%FORM,$site,$scriptname,$om_render_lang);

    ## destination upon successful login...
    #
    if ( exists($FORM{'pg_targ'}) ) {       # "target page" element exists
       # don't need to do anything
    } elsif ( $ENV{'HTTP_REFERER'} ) {   # store referer if

       ## check that referred from inside site and not welcome...
       #

       if (( $ENV{'HTTP_REFERER'} =~ /($site->{'sitedomain'}|$site->{'sitessldomain'})/ ) and ( $ENV{'HTTP_REFERER'} !~ /$scriptname/ )) {
           $FORM{'pg_targ'}=$ENV{'HTTP_REFERER'};
       } else {
           ## referer is outside site or this script, default to home
           $FORM{'pg_targ'}="http://$site->{'siteurl'}/html/$om_render_lang/home.shtml";
       } # done looking at plausibility of using the referer as targ

    } else {                                         # default target
       $FORM{'pg_targ'}="http://$site->{'siteurl'}/html/$om_render_lang/home.shtml";
    } # done checking over page to use on outbound

} # end of sub


sub evaluate {

    my $FORM = shift;
    my $site = shift;
    my $dbh = shift;

    my $status = {
               '15018-A' => $site->{'msg'}->{1},
               '15020-A' => $site->{'msg'}->{2},
               '15025-A' => $site->{'msg'}->{3},
               '15027-A' => $site->{'msg'}->{4},
               '15028-A' => $site->{'msg'}->{5},
               '15029-A' => $site->{'msg'}->{5},

    }; 

    if ( $FORM->{'mode'} eq "account" ) {

        my %addressinfo;
        if ($FORM->{'current_page'} eq "addresscenter") {
            %addressinfo = &check_validation_and_update($site, $FORM, $dbh);
        }

        # get pulldown
        &get_pulldown($site, $FORM, $dbh);

        # shows this page is address edit page
        $FORM->{'current_page'} = "addresscenter";

        ## load in state pull down
        my $state = &localize_template("sel_state", $site->{'interfaces'}, 0, $site);
        my @temp = split /\n/, $state;
        $addressinfo{'STATE_SELECT'} = &gen_select(' ', 2, @temp);

        my $addressenter = &localize_template("cell_ck_addressenter" , "html" , 0, $site);
        $addressenter = &permutebit( $addressenter, \%addressinfo );
        $site->{'cell_ck_addressenter'} = &permutebit( $addressenter, $site );

        my $address_display = &localize_template("page_checkout_addressenter" , "html" , 0, $site);
        $address_display = &permutebit( $address_display, $site );

        $address_display = &permuteclean( $address_display );

        return $address_display;

    }

    if ( $FORM->{'mode'} eq "orders" ) {

        my $order_display;

        my $orderid;
        ## if customer select an order from the page
        #  should show this order infomation
        if ( $FORM->{'showorder'} ) {
            $orderid = $FORM->{'showorder'};
        }

        my $orders;
        my $orderid_hashref;
        my $i = 0;
        ## search for orders owned by this customer
        #  and put the hashref into $orders
        my $q ="SELECT * FROM orders WHERE custid='$FORM->{'custid'}' ";
           $q .= "AND status != '15012-A' ";
        my $stt = $dbh->prepare($q);
           $stt->execute;

        while ( $orders->{$i} = $stt->fetchrow_hashref("NAME_lc") ) {
            $orders->{$i}->{'cdate'} = &nicedatetime($orders->{$i}->{'cdate'});
            $orders->{$i}->{'status'} = $status->{$orders->{$i}->{'status'}};
            if ($orders->{$i}->{'objid'} eq $orderid) {
                $orderid_hashref = $orders->{$i};
            }
            $i += 1;
        }

        ## if $i=0, no orders,
        #  if $i=1, one order, show this order information
        #  if $i>1, more than one order, show list of order
        if ($i == 0) {
            $order_display = $site->{'msg'}->{6};
        } elsif ($i == 1) {
            # if already has orderid, means customer select from page
            $orderid = $orders->{0}->{'objid'} if (!$orderid);            
        } 

        ## if there is at least one order, list order status info
        if ($i != 0) {
             
            my $orderlist = "cell_myaccount_orderslist";
            $orderlist = &localize_template("$orderlist" , "html" , 0, $site);

            if ($FORM->{'showorder'}) {
                   $FORM->{'orderinfo'} = &permutebit( $orderlist, $orderid_hashref );
            } else {
                foreach my $i (keys %{$orders}) {
                    next if (!$orders->{$i});
                    $FORM->{'orderinfo'} .= &permutebit( $orderlist, $orders->{$i} );
                } # end of foreach
            } # end of if else

            my $orders_status = &localize_template("cell_myaccount_orders" , "html" , 0, $site);
            $order_display = &permutebit( $orders_status, $FORM );
        }

        if ($orderid) {

            ## get shipping address information
            my $q = "SELECT shipto FROM orders WHERE objid='$orderid' ";
            my $sth = $dbh->prepare($q);
               $sth->execute;
            my $shipid = $sth->fetchrow;

            $q ="SELECT * from addresses where objid='$shipid'";
            $sth = $dbh->prepare($q);
            $sth->execute;  
            my $shipto = $sth->fetchrow_hashref("NAME_lc");

            ($shipto->{'firstname'}, $shipto->{'lastname'}) = split /\|/, $shipto->{'name'};

            my $ship_display = &localize_template("cell_ck_addresslist_shipto" , "html" , 0, $site);
            $FORM->{'cell_ck_addresslist_shipto'} = &permutebit( $ship_display, $shipto );  

            ## get shipping method
            $q = "SELECT lineobjid, linetotal FROM ocart WHERE orderid='$orderid' ";
            $q .= "AND objclass='140-A' ";
            $sth = $dbh->prepare( $q );
            $sth->execute;
            # get shipping method objid
            ($shipto->{'methodid'}, $shipto->{'shipcost'}) = $sth->fetchrow_array;

            # get title for the shipping method
            $q = "SELECT title FROM things WHERE objid='$shipto->{'methodid'}' ";
            $sth = $dbh->prepare( $q );
            $sth->execute;
            $shipto->{'shippingmethod'} = $sth->fetchrow;

            my $shipmethod_template = &localize_template("cell_myaccount_shippingmethod" , "html" , 0, $site);
            $FORM->{'cell_ck_shippingmethod'} = &permutebit( $shipmethod_template, $shipto );

            ## get billing infomation
            $q = "SELECT body FROM extraprop WHERE objid='$orderid' ";
            $q .= "AND fieldname LIKE 'CC|%' ";
            $sth = $dbh->prepare($q);
            $sth->execute;

            my $bill_display = &localize_template("cell_myaccount_payment" , "html" , 0, $site);
            my $bill;
            while (my $body = $sth->fetchrow) {
                my @tem = split /\|/, $body;
                $bill->{'number'} = $tem[1];
                $bill->{'type'} = $tem[2];
                $bill->{'amount'} = $tem[3];
                $bill->{'expire'} = "$tem[4]\/$tem[5]";
                my $billid = $tem[6];
            
                my $s  = "SELECT name, address1, address2, city, ";
                   $s .= "state, postcode, dayphone FROM addresses ";
                   $s .= "WHERE objid='$billid' ";
                my $stq=$dbh->prepare($s);
                   $stq->execute;

                my ($buname, $baddress1, $baddress2, $bcity, $bstate, $bpostcode, $bdayphone)=$stq->fetchrow_array;
                $buname =~ s/\|/ /g;
                $bdayphone =~ s/-|\(|\)|\s*//g;
                my $bplen = length($bdayphone);
                my $bill_bdayphone = substr($bdayphone, -4);
                $bill_bdayphone = substr($bdayphone, -7, 3)."-".substr($bdayphone, -4);                       if ($bplen>7 && $bplen<11) { $bill_bdayphone = substr($bdayphone, 0, $bplen-7)."-".$bill_bdayphone; }
                if ($bplen>10) { $bill_bdayphone = substr($bdayphone, 1, $bplen-8)."-".$bill_bdayphone;  $bill_bdayphone = substr($bdayphone, 0, $bplen-10)."-".$bill_bdayphone; }

                $bill->{'billto'} = "$buname, $baddress1,";
                $bill->{'billto'} .= "$baddress2," if ($baddress2);
                $bill->{'billto'} .= "$bcity, $bstate $bpostcode ($bdayphone)";

                $FORM->{'cell_myaccount_payment'} .= &permutebit( $bill_display, $bill );
            } # end of while
            

            ## get product infomation
            my $items;
            my $item_display = &localize_template("cell_myaccount_items" , "html" , 0, $site);

            $q ="SELECT * from ocart where orderid='$orderid' and objclass != '140-A'";  
            $sth = $dbh->prepare($q);
            $sth->execute;

            while ( my $items = $sth->fetchrow_hashref("NAME_lc") ) {

                $q ="SELECT title from things where objid='$items->{'lineobjid'}' ";
                my $staa = $dbh->prepare($q);
                   $staa->execute;
                ($items->{'title'}) = $staa->fetchrow;
                
                # if no title, means gift wrapping 
                $items->{'title'} = $site->{'msg'}->{8} if (!$items->{'title'});

                $FORM->{'cell_myaccount_items'} .= &permutebit( $item_display, $items );
            } # end of while

            ## load in order detail cell
            my $detail_tem = &localize_template("cell_myaccount_ordersdetail", "html" , 0, $site);
            $order_display .= &permutebit( $detail_tem, $FORM );
        } # end of if ($orderid)

        return $order_display;

    } # if form mode

    elsif ( $FORM->{'mode'} eq "refer" ) {
        my $refer_display;
        my $return_page = $FORM->{'return_page'};

        my @tem = split /\//, $return_page;

        my $refer_objid = $tem[$#tem];

           $refer_objid = (split /\?/, $refer_objid)[0];
           $refer_objid = (split /\./, $refer_objid)[0];
           
        my $q = " SELECT * FROM things WHERE objid='$refer_objid' ";
        my $sth = $dbh->prepare($q);
           $sth->execute;  
        my $refer_hash = $sth->fetchrow_hashref("NAME_lc"); 

        ## if no brief, it's a variant, get brief from master product
        if (!$refer_hash->{'brief'} && $refer_hash->{'ref_from'}) {
             my $q = "SELECT brief FROM things WHERE objid='$refer_hash->{'ref_from'}' ";
             my $sts = $dbh->prepare( $q );
                $sts->execute;
             $refer_hash->{'brief'} = $sts->fetchrow;
        }

        if ( !($FORM->{'current_page'} eq "fillout" || $FORM->{'current_page'} eq  "review") ){
    
            $q="SELECT body  FROM extraprop  WHERE objid='$FORM->{'custid'}' AND  fieldname='refer_email'";
            my $stq = $dbh->prepare($q);
                $refer_display = &permutebit( $refer_display, $refer_hash );
               $stq->execute;
            my $email = $stq->fetchrow;                                        
                $refer_display = &permutebit( $refer_display, $refer_hash );
            ($FORM->{'email'}, $FORM->{'comments'}) = split /\|/, $email;

            $FORM->{'current_page'} = "fillout";
            $refer_display = &localize_template("cell_refer_fillout" , "html" , 0, $site);
            $refer_display = &permutebit( $refer_display, $refer_hash );
            $refer_display = &permutebit( $refer_display, $FORM );
  
        } elsif ($FORM->{'current_page'} eq  "fillout" ) { 

            ## check to make sure each email address is proper and then send
            ## on it's way and store in extraprop
            my $error = 0;
            my $email_tem = $FORM->{'email'};
            $email_tem =~ s/(\s+)//g;
            my @emails = split /\,/, $email_tem;
            foreach my $eaddress ( @emails ) {

                #check valid format
                if($eaddress !~ /^(\w)+(\@)(\w)+(\.)(\w){2,3}$/)        {
                    $FORM->{'email_error_message'} = $site->{'msg'}->{7};  
                    $error = 1; 
                } # end of if ($eaddress) 

            } # end of foreach

            if ( $error ) {
                $FORM->{'current_page'} = "fillout";
                $refer_display = &localize_template("cell_refer_fillout" , "html" , 0, $site);
                $refer_display = &permutebit( $refer_display, $refer_hash );
                $refer_display = &permutebit( $refer_display, $FORM );
            } else {
                $FORM->{'current_page'} = "review";
                $FORM->{'email'} = join '<br>', @emails;
                $FORM->{'hidden_email'} = join ',', @emails;
                $refer_display = &localize_template("cell_refer_review" , "html" , 0, $site);
                $refer_display = &permutebit( $refer_display, $refer_hash );
                $refer_display = &permutebit( $refer_display, $FORM );
            } # end of if else

        } elsif ($FORM->{'current_page'} eq "review") {

            my $q  = "SELECT body  FROM extraprop ";
               $q .= "WHERE objid='$FORM->{'custid'}' ";
               $q .= "AND  fieldname='refer_email'";
            my $stq = $dbh->prepare($q);
               $stq->execute;
            my $email = $stq->fetchrow;

            my $body = "$FORM->{'hidden_email'}|$FORM->{'comments'}";               
            if ($email) {
                if ($email ne $body) {
                    my $q = "UPDATE extraprop set body='$body' ";
                       $q .= "WHERE objid='$FORM->{'custid'}' ";
                       $q .= "AND  fieldname='refer_email'";
                    my $stq = $dbh->prepare($q);
                       $stq->execute;    
                }         
            } else {
                $q = "INSERT INTO extraprop (objid,fieldname,body)";
                $q .= "VALUES ('$FORM->{'custid'}','refer_email','$body') ";
                my $stq = $dbh->prepare($q);
                $stq->execute;      
            } # end of if else

            &send_email($refer_hash, $body, $FORM, $site);
            $refer_display = "<br><b>$site->{'msg'}->{9}</b><br>\n";
        } # end of if elsif elsif
    
        my $complete_display = $refer_display;
        $complete_display = &permuteclean ($complete_display);;

        return $complete_display;

    } # end of if elsif elsif
 
} # end of sub


sub get_pulldown {

    my $site = shift;
    my $FORM = shift;
    my $dbh = shift;

    ## check if there is at least one address,                              
    #  if so, load address pulldown

    # get the shipping address for current custid
    my $q = "SELECT objid FROM addresses WHERE custid = '$FORM->{'custid'}' ";
    my $sth = $dbh->prepare($q);
       $sth->execute;

    my $rows=0;
    while ($sth->fetchrow){
        $rows += 1;
    }

    if ($rows > 0) {     
        $site->{'cell_ck_edit_address'} = &loadtemplate("cell_ck_edit_address","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/$site->{'interfaces'}");

        ##
        ## load addressbook pulldown
        $site->{'address_pulldown'} = &get_address_pulldown($FORM->{'custid'}, $dbh);

        my @addrr = split ( /\n/, $site->{'address_pulldown'} );
        my @newaddr;
        foreach my $addrrs ( @addrr ) {
            next if ( $addrrs =~ /: \, \, \, USA/ );
            push @newaddr, $addrrs;
        } # end of foreach
           
        my $new_address_pulldown = join (/\n/, @newaddr);
        $site->{'address_pulldown'} = $new_address_pulldown;                 
        $site->{'address_pulldown'} = "" if ( $site->{'address_pulldown'} !~ /USA/ ); 
        $site->{'mode'} = "account";
        $site->{'return_page'} = $FORM->{'return_page'};

        $site->{'cell_ck_edit_address'} = &permutebit( $site->{'cell_ck_edit_address'}, $site ) if ($site->{'address_pulldown'});

    } # end of if

} # end of sub     


sub check_validation_and_update {

    my $site = shift;
    my $FORM = shift;
    my $dbh = shift;

    my %addressinfo;
    ## check if this is edit address mode
    #  if so, show address infomation on page
    #  if not, it might be update or create address
    if ($FORM->{'editaddress'}) {

        my $q = "SELECT name, address1, address2, city, state, postcode, country, dayphone FROM addresses WHERE objid='$FORM->{'editaddress'}' ";
        my $sth = $dbh->prepare( $q );
        $sth->execute;

        my $h = $sth->fetchrow_hashref("NAME_lc");

        ($h->{'firstname'}, $h->{'lastname'}) = split /\|/, $h->{'name'};

        foreach my $key (keys %{$h}) {
            my $key_inp = $key."\_inp";
            $addressinfo{$key_inp} = $h->{$key};
        } # end of foreach

        $site->{'addid'} = $FORM->{'editaddress'};
 
     } else {

        ##
        # check the validation for the address information
        # if no errors, update the addresses table
        my $addr = &validateaddr($FORM, $site);
        %addressinfo = %{$addr};
        if ( !$addressinfo{'errors'} ) {

           my $save = 1; # flag for wether or not save this address
                         # by default, it is "save"

           ##
           # get all the addresses for the custid    
           # and see if the entered address has been there
           my $q = "SELECT * FROM addresses WHERE custid = '$FORM->{'custid'}' ";
           my $sth = $dbh->prepare( $q );
              $sth->execute;

           WHILE: while ( my $h = $sth->fetchrow_hashref("NAME_lc") ) {

               ##
               # setup a flag for wether or not the address is ok
               # by testing every  filed of the address inforation
               my $ok = 0;

               ## break name to be last and first names first
               ($h->{'firstname'}, $h->{'lastname'}) = split /\|/, $h->{'name'};

               FOREACH: foreach my $inp (keys %addressinfo) {

                   next if ($inp !~ /_inp$/);

                   my $old = $inp;
                   $old =~ s/_inp$//;

                   ##
                   # if there is any difference between the new entered address
                   # and the exsiting address, then mark it as 'ok'
                   if ( $addressinfo{$inp} ne $h->{$old} ) {
                        $ok = 1;
                        last FOREACH;
                   } # end of if

               } # end of foreach

               ##
               # if the new input address is exactly the same as
               # the existing address, then don't need to save it
               if ( $ok == 0 ) {
                   $save = 0;
                   last WHILE;
               } # end of if       

           } # end of while

           if ($save) {

             ## if addid, means edit, just update database
             #  else it's new address, create new
             if ($site->{'addid'}) {

                 my %update; # a hash for update database
                 my $set;
                 my $q = "SELECT name, address1, address2, city, state, postcode, country, dayphone FROM addresses WHERE objid='$site->{'addid'}' ";
                 my $sta = $dbh->prepare( $q );
                    $sta->execute;
                 ## build name same as database
                 $addressinfo{'name_inp'} = join '|', $addressinfo{'firstname_inp'}, $addressinfo{'lastname_inp'};
                 my $oldadd = $sta->fetchrow_hashref("NAME_lc");
                 foreach my $fieldname (keys %{$oldadd}) {
                     my $fieldname_inp = $fieldname."_inp";
                     if ($addressinfo{$fieldname_inp} ne $oldadd->{$fieldname}){
                         $set .= "$fieldname="."\'$addressinfo{$fieldname_inp}\',";
                     }
                 }
                 chop $set;

                 $q = "UPDATE addresses SET $set WHERE objid='$FORM->{'addid'}' ";
                 $sta = $dbh->prepare( $q );
                 $sta->execute;

             } else {
               ## if the script comes to here,
               # need to update the addresses table
               # update levent first
               my $addressid = &get_new_objid($site, $dbh, "addresses", "$FORM->{'sid'} $FORM->{'custid'} create an new address id");
             

               my $now = time();

               # join the last and first name to input into database
               $addressinfo{'name'} = join '\|', $addressinfo{'firstname_inp'}, $addressinfo{'lastname_inp'};
               $q  = "INSERT INTO addresses ";
               $q .= "(objid, custid, name, address1, address2, city, state, ";
               $q .= "postcode, country, dayphone, cdate, mdate) ";
               $q .= "VALUES ('$addressid', '$FORM->{'custid'}', ";
               $q .= "'$addressinfo{'name'}', ";
               $q .= "'$addressinfo{'address1_inp'}', ";
               $q .= "'$addressinfo{'address2_inp'}', ";
               $q .= "'$addressinfo{'city_inp'}', ";
               $q .= "'$addressinfo{'state_inp'}', ";
               $q .= "'$addressinfo{'postcode_inp'}', ";
               $q .= "'$addressinfo{'country_inp'}', ";
               $q .= "'$addressinfo{'dayphone_inp'}', ";
               $q .= "$now, $now) ";

               $sth = $dbh->prepare( $q );
               $sth->execute;
               $sth->finish;

             } # end of if else
         } # end of if ($save)

         # need to empty the correct input fields
         foreach my $key_inp (keys %addressinfo) {
             next if ($key_inp !~ /_inp$/);    
             $addressinfo{$key_inp} = "";
         }
      
      } # end of if (!$error)
   } # end of of if else

   return %addressinfo;
} # end of sub


sub send_email {

    my $refer_hashref = shift;
    my $body = shift;
    my $form = shift;
    my $site = shift;

    my ($to_emails, $comment) = split /\|/, $body;
    my @emails = split /,/, $to_emails;

    my $content = "$comment\n\n";
       $content .= "$refer_hashref->{'title'}\n";
       $content .= "$refer_hashref->{'brief'}\n";
       $content .= "$form->{'return_page'}\n"; 

    ## setup email program
    my $mailprog = $site->{'mailserver'};
    if ($mailprog) {
 
        ## header
        my $title = $site->{'msg'}->{10};

        foreach my $email (@emails) {
            open (MAIL, "|$mailprog -t");
            print MAIL "To: $email\n";
            print MAIL "FROM: $site->{'customer_service_email_address'}\n";
            print MAIL "Bcc: $site->{'customer_service_email_address'}\n";
            print MAIL "Subject: $title\n\n";
            print MAIL "$site->{'msg'}->{11} $site->{'username'} $site->{'msg'}->{12} $site->{'sitename'}.\n\n";
            print MAIL "$content\n";
            print MAIL "$site->{'msg'}->{13} $site->{'sitename'}!\n";
            close MAIL;
        } # end of foreach

    } # end of if 
        
} # end of sub
              
sub permute_out {

    my $FORM = shift;
    my $site = shift;
    my $dbh = shift;
    my ($pages,$display);
    my ($thispage,$scriptname);
    $scriptname="myaccount";

    my $q = "select uname from contacts where objid='$FORM->{'custid'}'\n";
    my $sth = $dbh->prepare( $q );
    $sth->execute;
    $site->{'username'} = $sth->fetchrow; 

    $pages->{'main'} = "page_account_main";
    $pages->{'refer'} = "page_account_refer";   
    $pages->{'orders'} = "page_account_orders";   
    $pages->{'account'} = "page_account_address";   
    $FORM->{'mode'}="main" if ( ! $FORM->{'mode'} );

    $site->{'account'} = "myaccount.cgi";
    $thispage = &localize_template( $pages->{$FORM->{'mode'}}, "html" , 0, $site);

    $display = &evaluate($FORM,$site,$dbh) if ( $FORM->{'mode'} eq "orders" );
    $display = &evaluate($FORM,$site,$dbh) if ( $FORM->{'mode'} eq "account" ); 
    $display = &evaluate($FORM,$site,$dbh) if ( $FORM->{'mode'} eq "refer" );

    $site->{'display'} = &permutebit( $display, $site );

    $thispage = &permutebit( $thispage, $FORM );
    $thispage = &permutebit( $thispage, $site );
    $thispage = &permutebit( $thispage, \%ENV );
    $thispage =~ s/__SCRIPTNAME__/$scriptname/gsm ;

    $thispage = &permuteclean ( $thispage  );

    print "$thispage";
} # end of sub


#############################################################################
=pod

=head2 message

message - &message($om_render_lang, $scriptname, $relpath); 

=over 4

=item DESCRIPTION

To support multiple languages, all error messages need to be stripped out of
the script and translated to different languages.  This routine loads in the
messages for the $site->{'om_render_lang'} that is currently active.

=item INPUT

$site - Standard $site hash from &setsite

=item OUTPUT

$site - Standard $site hash from &setsite

=item NOTES

=back

=cut
###############################################################################
sub myaccount_message {
   # check the language that is being used and open appropriate
   # message language file or get messages below
   my $site = shift;

   my %script_msg;
   my $om_render_lang = $site->{'om_render_lang'};
   my $scriptname = $site->{'scriptname'};
   my $relpath = $site->{'relpath'};

   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="Tentative Order -  Authorization Pending";
      $script_msg{2}="Awaiting Fulfillment";
      $script_msg{3}="Left Facility and in Route to Customer";
      $script_msg{4}="Shipped with Funds Captured";
      $script_msg{5}="Voided";
      $script_msg{6}="You don't have any orders now.";
      $script_msg{7}="Email address(es) not vaild (be sure to separate each email address by a comma)";
      $script_msg{8}="Gift Wrapping";
      $script_msg{9}="Your email has been sent.";
      $script_msg{10}="Your friend's recommendation";
      $script_msg{11}="Your friend at";
      $script_msg{12}="just send you a recommendation from";
      $script_msg{13}="You are welcome to";

   } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$scriptname.$om_render_lang.messages");    
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         my @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1];
      }
      close(EM);
   }

   return \%script_msg;

}

1;

