sub setup_search_filters {
    my ($FORM) = shift;

    my ($filters);

    $filters->{'things'} = "title,keywords,brief";

    if ($$FORM{'search_status'} ne "") {
	$filters->{'status'} = $$FORM{'search_status'};
    }

    if ($$FORM{'search_objid'} ne "") {
	$filters->{'objid'} = "%$$FORM{'search_objid'}%";
    }

    if ($$FORM{'search_sku_series'} ne "") {
	$filters->{'sku_series'} = $$FORM{'search_sku_series'};
    }
    
    return $filters;
}

sub do_admin_object_search {
    my ($FORM) = shift;
    my ($site) = shift;
    my ($dbh) = shift;

    my ($filters, @results, $link_details, $last_row, $this_start);
    my ($check_search); 

    $check_search = $$FORM{'search_keywords'};
    $check_search =~ s/ //gms;

    if ((length($check_search) == 0)  && (length($$FORM{'search_keywords'}) > 0)) {
	$$FORM{'search_keywords'} = "";
    }
    

    &debug("In do_admin_object_search, start row is $FORM{'startrow'}", 3, $site->{'debug_level'}, $site->{'debug_log'});
    $filters = &setup_search_filters($FORM);
    $this_start = $$FORM{'startrow'};
    $$FORM{'this_startrow'} = $$FORM{'startrow'};
    $$FORM{'this_lang_startrow'} = $$FORM{'lang_startrow'};
    &debug("In do_admin_object_search, this start is $this_start", 3, $site->{'debug_level'}, $site->{'debug_log'});
    &debug("do_admin_object_search: after setup_search_filters, going into do_admin_search", 3, $site->{'debug_level'}, $site->{'debug_log'});
    @results = &do_admin_search($$FORM{'search_keywords'}, "and", "sortby", $filters, $FORM, $site, $dbh);

    &debug("do_admin_object_search: after do_admin_search", 3, $site->{'debug_level'}, $site->{'debug_log'});


    $link_details =  "$site->{'scriptpath'}/$site->{'scriptname'}\?&sid=$site->{'encrypted_sid'}&mode=search&search_keywords=$$FORM{'search_keywords'}&search_objid=$$FORM{'search_objid'}&search_objtype=$$FORM{'search_objtype'}&search_sku_series=$$FORM{'search_sku_series'}&search_status=$$FORM{'search_status'}&foundcount=$$FORM{'foundcount'}";

    $$FORM{'next_startrow'} = $$FORM{'startrow'};
    &debug("After do_admin_object_search, set next row to $$FORM{'next_startrow'}", 3, $site->{'debug_level'}, $site->{'debug_log'});

    if (($$FORM{'foundcount'} == 0) && ($$FORM{'came_from_next_link'} eq "yes")) {    
	&debug("In do_admin_object_search: Going to display results with $this_start (this_start), $$FORM{'startrow'}(startrow)", 3, $site->{'debug_level'}, $site->{'debug_log'});
	&display_search_results($link_details, $$FORM{'previous_startrow'}, $$FORM{'startrow'}, $site, $FORM, \@results);

    }
    elsif ($$FORM{'foundcount'} > 0) {
	&debug("In do_admin_object_search: Going to display results with $this_start (this_start), $$FORM{'startrow'}(startrow)", 3, $site->{'debug_level'}, $site->{'debug_log'});
	&display_search_results($link_details, $$FORM{'previous_startrow'}, $$FORM{'startrow'}, $site, $FORM, \@results);
    }
    # Nothing found, go back home
    else {
	$$FORM{'page_error'} = $site->{'script_msg'}{'nothing_found'};
	$$FORM{'mode'} = "home";
    }
}

sub do_admin_search {
    my ($search_words) = shift;
    my ($type) = shift;
    my ($sortfield) = shift;
    my ($filters) = shift;
    my ($FORM) = shift;
    my ($site) = shift;
    my ($dbh) = shift;

    my (@search_array, $search_results, $search_indx, $objid, $extras, @results, $q, $numRows, $select_hashref);
    my ($where_indx, $check_search);

    $extras->{'status'} = $$FORM{'search_status'};
    $extras->{'objid'} = $$FORM{'search_objid'};
    $extras->{'keyword'} = $search_words;
    $extras->{'objtype'} = $$FORM{'search_objtype'};
    $extras->{'contact_type'} = $site->{'OBJCLASSES'}->{'contact'};
    
    if ($$FORM{'search_sku_series'} ne "") {
	&debug("Adding sku_series to search!", 3, $site->{'debug_level'}, $site->{'debug_log'});
	$select_hashref->{'TABLE'}->{'NAME'} = "extraprop";
	$select_hashref->{'TABLE'}->{'FIELDS'}->{'body'} = "body";
	$where_indx = 0;
	$select_hashref->{'TABLE'}->{'WHERE'}[$where_indx++] = &build_where_hash("objid", "$$FORM{'search_sku_series'}", "and");
	$select_hashref->{'TABLE'}->{'WHERE'}[$where_indx++] = &build_where_hash("fieldname", "sku_skel", "and");
	$q = &build_select($select_hashref, $site, $dbh, 1);
	$numRows = &query_getAll($q, $site, $dbh, \@results);
	$extras->{'sku_skel'} = $results[0]->{'body'};
	&debug("Adding $extras->{'sku_skel'}!", 3, $site->{'debug_level'}, $site->{'debug_log'});
    }

    &debug("Ok, need to set language", 3, $site->{'debug_level'}, $site->{'debug_log'});
    &debug_hashref($extras, 3, $site->{'debug_level'}, $site->{'debug_log'});

    # See if we need to search the language tables.
    if (((!defined $extras->{'objid'}) || ($extras->{'objid'} eq "")) &&
	((!defined $extras->{'objtype'}) || ($extras->{'objtype'} eq "")) &&
	((!defined $extras->{'status'}) || ($extras->{'status'} eq "")) &&
	((!defined $extras->{'sku_skel'}) || ($extras->{'sku_skel'} eq "")))  {
	# This means do treat extraprop as a primary table, so go get_language_primary
	$extras->{'search_language'} = 1;
    }
    else {  # This is for when we have objtype, sku_skel, or objid 
	# This means don't treat extraprop as a primary table, so don't go get_language_primary
	$extras->{'search_language'} = 0;
    }
    # We need to search it, but don't remove the results based on that it is defined in another language, match all languages found
    if ((defined $extras->{'keyword'}) && ($extras->{'keyword'} ne "")) {
	# This means take the record, regardless of the render_lang
	$extras->{'match_all_langs'} = 1;
    }
    else {
	# This means be picky on the record, only in the proper language
	$extras->{'match_all_langs'} = 0;
    }

    $this_lang = $$FORM{'lang_startrow'};
    &debug("in do_admin_search, this lang is $this_lang", 3, $site->{'debug_level'}, $site->{'debug_log'});
   ($$FORM{'foundcount'}, $$FORM{'startrow'}, $$FORM{'next_lang_startrow'}, @search_array) =  &object_search($search_words, $type, $$FORM{'startrow'}, $filters, \&build_load_object_queries, \&build_lang_object_queries, $$FORM{'lang_startrow'}, $extras, $site, $dbh);

    &debug("AFTER: now this_lang is $this_lang", 3, $site->{'debug_level'}, $site->{'debug_log'});
    # sort it, assume text sort
    @search_array = sort { uc($a->{$sortfield}) cmp uc($b->{$sortfield}) } @search_array;    
    return @search_array;
}


sub inventory_search {
    my ($FORM) = shift;
    my ($site) = shift;
    my ($dbh) = shift;

    my ($filters, @results, $link_details, $last_row, $this_start);

    my ($check_search); 

    $check_search = $$FORM{'search_keywords'};
    $check_search =~ s/ //gms;

    if ((length($check_search) == 0)  && (length($$FORM{'search_keywords'}) > 0)) {
	$$FORM{'search_keywords'} = "";
    }

    &debug("In inventory_search, start row is $FORM{'startrow'}", 3, $site->{'debug_level'}, $site->{'debug_log'});
    $filters = &setup_search_filters($FORM);
    $this_start = $$FORM{'startrow'};
    $$FORM{'this_startrow'} = $$FORM{'startrow'};
    $$FORM{'this_lang_startrow'} = $$FORM{'lang_startrow'};
    &debug("In inventory_search, this start is $this_start", 3, $site->{'debug_level'}, $site->{'debug_log'});
    &debug("inventory_search: after setup_search_filters, going into do_admin_search", 3, $site->{'debug_level'}, $site->{'debug_log'});
    @results = &do_inventory_search($$FORM{'search_keywords'}, "and", "sortby", $filters, $FORM, $site, $dbh);

    &debug("inventory_search: after do_admin_search", 3, $site->{'debug_level'}, $site->{'debug_log'});


    $link_details =  "$site->{'scriptpath'}/$site->{'scriptname'}\?&sid=$site->{'encrypted_sid'}&mode=search&search_keywords=$$FORM{'search_keywords'}&search_objid=$$FORM{'search_objid'}&search_objtype=$$FORM{'search_objtype'}&search_sku_series=$$FORM{'search_sku_series'}&search_status=$$FORM{'search_status'}&foundcount=$$FORM{'foundcount'}";

    $$FORM{'next_startrow'} = $$FORM{'startrow'};
    &debug("After do_inventory_search, set next row to $$FORM{'next_startrow'}", 3, $site->{'debug_level'}, $site->{'debug_log'});

    if ($$FORM{'foundcount'} > 0) {
	&debug("In inventory_search: Going to display results with $this_start (this_start), $$FORM{'startrow'}(startrow)", 3, $site->{'debug_level'}, $site->{'debug_log'});
	&display_search_results($link_details, $$FORM{'previous_startrow'}, $$FORM{'startrow'}, $site, $FORM, \@results);
    }
    # Nothing found, go back home
    else {
	$$FORM{'page_error'} = $site->{'script_msg'}{'nothing_found'};
	$$FORM{'mode'} = "home";
    }
}

sub do_inventory_search {
    my ($search_words) = shift;
    my ($type) = shift;
    my ($sortfield) = shift;
    my ($filters) = shift;
    my ($FORM) = shift;
    my ($site) = shift;
    my ($dbh) = shift;

    my (@search_array, $search_results, $search_indx, $objid, $extras, @results, $q, $numRows, $select_hashref);
    my ($where_indx);

    $extras->{'status'} = $$FORM{'search_status'};
    $extras->{'objid'} = $$FORM{'search_objid'};
    $extras->{'keyword'} = $search_words;

    # See if we need to search the language tables.
    if (((!defined $extras->{'objid'}) || ($extras->{'objid'} eq "")) &&
	((!defined $extras->{'status'}) || ($extras->{'status'} eq ""))) {
	# This means do treat extraprop as a primary table, so go get_language_primary
	$extras->{'search_language'} = 1;
    }
    else {  # This is for when we have objtype, sku_skel, or objid 
	# This means don't treat extraprop as a primary table, so don't go get_language_primary
	$extras->{'search_language'} = 0;
    }
    # We need to search it, but don't remove the results based on that it is defined in another language, match all languages found
    if ((defined $extras->{'keyword'}) && ($extras->{'keyword'} ne "")) {
	# This means take the record, regardless of the render_lang
	$extras->{'match_all_langs'} = 1;
    }
    else {
	# This means be picky on the record, only in the proper language
	$extras->{'match_all_langs'} = 0;
    }

    $this_lang = $$FORM{'lang_startrow'};
    &debug("in do_inventory_search, this lang is $this_lang", 3, $site->{'debug_level'}, $site->{'debug_log'});
    if (!defined $site->{'override_permissions'}) {
	$site->{'override_permissions'} = "yes";
	my $changed_perms = "yes";
    }
   ($$FORM{'foundcount'}, $$FORM{'startrow'}, $$FORM{'next_lang_startrow'}, @search_array) =  &object_search($search_words, $type, $$FORM{'startrow'}, $filters, \&build_inv_load_object_queries, \&build_inv_lang_object_queries, $$FORM{'lang_startrow'}, $extras, $site, $dbh);
    if ($changed_perms eq "yes") {
	$site->{'override_permissions'} = undef $site->{'override_permissions'};
    }
    &debug("AFTER: now this_lang is $this_lang", 3, $site->{'debug_level'}, $site->{'debug_log'});
    # sort it, assume text sort
    @search_array = sort { uc($a->{$sortfield}) cmp uc($b->{$sortfield}) } @search_array;    
    return @search_array;
}

sub object_search {
    my ($searchwords) = shift;
    my ($type) = shift;  
    my ($startRow) = shift;
    my ($filter_hashref) = shift;
    my ($build_query_routine) = shift;
    my ($build_lang_query_routine) = shift;
    my ($lang_startat) = shift;
    my ($extras) = shift;
    my ($site) = shift;
    my ($dbh) = shift;

    my (@rows, $i, $search_key, @words, %MasterRec);
    my (@search_queries, $q, $select_hashref, $obj, $results, $numRows, @res);
    my ($h,@variant_products, $keyword, $numExtAdded, $numRowsAdded);
    my (@encoding_match, $master_matched, $numQueries, $foundRows, $found);
    my ($numSearchResults);
    my ($tables, $fields, @where, $num_rows_to_get);
    my ($num_results, $next_start_row, @results, $lang_tables, $lang_fields, @lang_where, @tmp_results);

    $results = {};

    $search_key = $searchwords;
    &debug("object_search: In here with $search_key", 3, $site->{'debug_level'}, $site->{'debug_log'});
    $numQueries = 0;
    ($tables, $fields, @where) = &$build_query_routine($search_key,$extras,$site);
    $site->{'lang_query_params'} = $extras;
    $site->{'this_search_key'} = $search_key;
    $num_rows_to_get = $site->{'search_results_per_page'};
    &debug("object_search: search: $extras->{'search_language'}, match: $extras->{'match_all_langs'}", 3, $site->{'debug_level'}, $site->{'debug_log'});
    my $cont = "yes";
    my $indx = 0;
    while ($cont eq "yes") {
	# Plain search, return everything
	if (($extras->{'search_language'} == 1) && ($extras->{'match_all_langs'} == 0)) {
	    ($num_results, $next_start_row, $lang_startat, @tmp_results) = &load_objects($tables, $fields, \@where, $startRow, $num_rows_to_get, $site, $dbh, $site->{'override_permissions'}, $build_lang_query_routine, $lang_startat, $extras->{'match_all_langs'});
	}
	
	# Keyword search, look in all languages and return the result
	elsif (($extras->{'search_language'} == 1) && ($extras->{'match_all_langs'} == 1)) {
	    ($num_results, $next_start_row, $lang_startat, @tmp_results) = &load_objects($tables, $fields, \@where, $startRow, $num_rows_to_get, $site, $dbh, $site->{'override_permissions'}, $build_lang_query_routine, $lang_startat, $extras->{'match_all_langs'});
	}
	
	# If this is NOT defined, then don't search the language table, 
	# as we only can limit the results based on the main
	# table, therefore it is not necessary
	else {
	    
	    ($num_results, $next_start_row, $lang_startat, @tmp_results) = &load_objects($tables, $fields, \@where, $startRow, $num_rows_to_get, $site, $dbh, $site->{'override_permissions'});
	}

	foreach $result (@tmp_results) {
	    $results[$indx++] = $result;
	}

	$cont = "no";
=pod
	if ($indx >= $num_rows_to_get) {
	    $cont = "no";
	}
	if (!defined $next_start_row) {
	    $cont = "no";
	}
	else {
	    $startRow = $next_start_row;  # set up for next time
	    &debug("object_search: Next time start at: $startRow", 3, $site->{'debug_level'}, $site->{'debug_log'});
	}
=cut
    }

    return ($num_results, $next_start_row, $lang_startat, @results);
}

##############################################################################
=pod

=head2 setSearchNavigation

setSearchNavigation - &setSearchNavigation($pr, $foundcount, $maxrows, $startrow, $lastrow, $scriptinfo);

=over 4

=item DESCRIPTION

To set the Next and Back buttons on a search page

=item INPUT

$pr - location substring:
         sid=$sid&mode=$mode&skuskel=$objid&status_inp=$status_inp

$main_table_rows - hashref defining the following:
                   'pre_row' is the previous row number for all tables, except for the language table
                   'next_row' is the next row number for all tables, except for the language table
                   'this_row' is the next row number for all tables, except for the language table

$lang_table_rows - hashref defining the following:
                   'pre_row' is the previous row number for the language table
                   'next_row' is the next row number for the language table
                   'this_row' is the next row number for the language table

$scriptinfo - path the script and the scriptname: ex: /cgi-bin/om/search.cgi

$site - The site script

=item OUTPUT

$back - the back link

$next - the next link

$firstrecord - the starting row for this page

=item NOTES

=back

=cut
##############################################################################
sub set_search_navigation {
    my ($pr) = shift;
    my ($main_table_rows) = shift;
    my ($lang_table_rows) = shift;
    my ($scriptinfo) = shift;
    my ($site) = shift;
    
    my ($back, $next, $firstrecord, $this_start, $this_page, $startPages, $endPage, $numPages, $totalPages);
    my ($numDisplayPages, $dec, $lastChange, $startPage, $i, $page, $pages);
    my ($running_startrow, $running_lang_startrow, $pre_running_startrow, $pre_lang_running_startrow);
    my (@main, @lang, $i);

    &debug("set_search_navigation: In here with $main_table_rows->{'pre_row'}, $main_table_rows->{'next_row'}", 3, $site->{'debug_level'}, $site->{'debug_log'});
    &debug_hashref($main_table_rows, 3, $site->{'debug_level'}, $site->{'debug_log'});
    &debug_hashref($lang_table_rows, 3, $site->{'debug_level'}, $site->{'debug_log'});
    if (($main_table_rows->{'pre_row'} ne "") || (($main_table_rows->{'pre_row'} eq "") && ($main_table_rows->{'this_row'} ne ""))) {
	@lang = split /\|/, $lang_table_rows->{'pre_row'};
	@main = split /\|/, $main_table_rows->{'pre_row'};
	$running_startrow =  $main[$#main];
	$running_lang_startrow = $lang[$#lang];

	$pre_running_lang_startrow = "";
	for ($i=0; $i < $#lang; $i++) {  # don't want the last one
	    $pre_running_lang_startrow .= "\|$lang[$i]";
	}

	$pre_running_startrow = "";
	for ($i=0; $i < $#main; $i++) {  # don't want the last one
		$pre_running_startrow .= "\|$main[$i]";
	}
	
	&debug("set_search_navigation:  RUNNING: startrow $running_startrow, lang startrow  $running_lang_startrow!", 3, $site->{'debug_level'}, $site->{'debug_log'});	&debug("set_search_navigation:  RUNNING: pre_startrow $pre_running_startrow, pre_lang startrow $pre_running_lang_startrow!", 3, $site->{'debug_level'}, $site->{'debug_log'});
        $back="<A HREF=\"$pr";
        $back.="&startrow=$running_startrow&lang_startrow=$running_lang_startrow&previous_startrow=$pre_running_startrow&pre_lang_startrow=$pre_running_lang_startrow\"><FONT FACE=\"arial,helvetica\" SIZE=\"-1\">$site->{'script_msg'}{'back'}</FONT></A>&nbsp;&nbsp;";
	&debug("set_search_navigation: Built back button: $back", 3, $site->{'debug_level'}, $site->{'debug_log'});	
    }
    if ($main_table_rows->{'next_row'} ne "") {
	if ($main_table_rows->{'this_row'} ne "") {
	    $running_startrow = $main_table_rows->{'pre_row'} . "\|" . $main_table_rows->{'this_row'};
	}
	else {
	    $running_startrow = $main_table_rows->{'pre_row'};
	}
	if ($lang_table_rows->{'this_row'} ne "") {
	    $running_lang_startrow = $lang_table_rows->{'pre_row'} . "\|" . $lang_table_rows->{'this_row'};
	}
	else {
	    $running_lang_startrow = $lang_table_rows->{'pre_row'};

	}
	&debug("set_search_navigation:  Previous_startrow for NEXT should be $running_startrow, running lang startrow is $running_lang_startrow!", 3, $site->{'debug_level'}, $site->{'debug_log'});
        $startrow = $lastrow;
#        $next="\n\n<A HREF=\"$scriptinfo\?$pr";
        $next="\n\n<A HREF=\"$pr";
        $next.="&previous_startrow=$running_startrow&startrow=$main_table_rows->{'next_row'}&lang_startrow=$lang_table_rows->{'next_row'}&pre_lang_startrow=$running_lang_startrow&came_from_next_link=yes\"><FONT FACE=\"arial,helvetica\" SIZE=\"-1\">$site->{'script_msg'}{'next'}</FONT></A>";

	&debug("set_search_navigation: Built next button: $next", 3, $site->{'debug_level'}, $site->{'debug_log'});	
    }
    
    return ($back, $next);
}

sub build_load_object_queries {
    my ($keyword) = shift;
    my ($extras) = shift;
    my ($site) = shift;

    my ($fields, @where, $tables, $where_indx);

    #default at all
    $tables = "contacts,things";
    $fields = "uname,title,objid,objclass,objtype,language,ref_from,axisnames,vcode,status";

    # THINGS QUERY
    $where_indx = 0;
    $where[$where_indx++] = &build_where_hash("objid", "!%-A", "and");
    if ($keyword ne "") {
	# things stuff
	&debug("build_load_object_queries:  Adding $keyword keyword to search", 3, $site->{'debug_level'}, $site->{'debug_log'});
	$where[$where_indx++] = &build_where_hash("(title", "%$keyword%", "or");
	$where[$where_indx++] = &build_where_hash("brief", "%$keyword%", "or");
	$where[$where_indx++] = &build_where_hash("keywords", "%$keyword%)", "and");

	#contacts stuff
	$where[$where_indx++] = &build_where_hash("(uname", "%$keyword%)", "and");
    }
    # This MUST be set for this type of search
    if ($extras->{'objtype'} ne "") {
	&debug("build_load_object_queries:  Adding objtype $extras->{'objtype'} to search", 3, $site->{'debug_level'}, $site->{'debug_log'});

	$where[$where_indx++] = &build_where_hash("(objtype", $extras->{'objtype'}, "or");
	$where[$where_indx++] = &build_where_hash("objclass", "$extras->{'objtype'})", "and");
	&debug("load_object_queries:  $extras->{'objtype'} is the objtype, $site->{'OBJCLASSES'}->{'contact'} is the site stuff!", 3, $site->{'debug_level'}, $site->{'debug_log'});
	if ($extras->{'objtype'} eq $site->{'OBJCLASSES'}->{'contact'}) {
	    $tables = "contacts";
	}
	else {
	    $tables = "things";
	}
    }
	
    if ($extras->{'status'} ne "") {
	&debug("build_load_object_queries:  Adding status $extras->{'status'} to search", 3, $site->{'debug_level'}, $site->{'debug_log'});
	$where[$where_indx++]  = &build_where_hash("(status", "$extras->{'status'})", "and");
    }

    if ($extras->{'objid'} ne "") {
	&debug("build_load_object_queries:  Adding objid $extras->{'objid'} to search", 3, $site->{'debug_level'}, $site->{'debug_log'});
	$where[$where_indx++]  = &build_where_hash("(objid", "%$extras->{'objid'}%)", "and");
    }

    if ($extras->{'sku_skel'} ne "") {
	$tables = "things";
	&debug("build_load_object_queries:  Adding sku_skel $extras->{'sku_skel'} to search", 3, $site->{'debug_level'}, $site->{'debug_log'});
	$where[$where_indx++] = &build_where_hash("(msku", "%$extras->{'sku_skel'}%)", "and");
    }    
    &debug("load_object_queries:  REturning $tables, $fields to look!", 3, $site->{'debug_level'}, $site->{'debug_log'});
    return ($tables, $fields, @where);
}

sub build_lang_object_queries {
    my ($keyword) = shift;
    my ($extras) = shift;
    my ($site) = shift;

    my ($fields, @where, $tables, $where_indx);
    my ($primary_tables, $primary_fields, @primary_where);
    #default at all
    $tables = "extraprop";
    $fields = "objid,body,language";

    # Language Query
    $where_indx = 0;
    $where[$where_indx++] = &build_where_hash("objid", "!%-A", "and");
    if ($keyword ne "") {
	$where[$where_indx++] = &build_where_hash("(fieldname", "title", "and");
	$where[$where_indx++] = &build_where_hash("body", "%$keyword%)", "or");
	$where[$where_indx++] = &build_where_hash("(fieldname", "brief", "and");
	$where[$where_indx++] = &build_where_hash("body", "%$keyword%)", "or");
	$where[$where_indx++] = &build_where_hash("(fieldname", "keywords", "and");
	$where[$where_indx++] = &build_where_hash("body", "%$keyword%)", "or");
    }
    else {
	$where[$where_indx++] = &build_where_hash("(fieldname", "title", "or");
	$where[$where_indx++] = &build_where_hash("fieldname", "brief", "or");
	$where[$where_indx++] = &build_where_hash("fieldname", "descript", "or");
	$where[$where_indx++] = &build_where_hash("fieldname", "keywords)", "or");
    }
	
    if ($extras->{'objid'} ne "") {
	$where[$where_indx++]  = &build_where_hash("objid", "%$extras->{'objid'}%", "and");
    }


    # Don't do if msku, as we won't find any more information
    if ($extras->{'sku_skel'} ne "") {
	return ("","","");
    }    

    # Don't do status, as extraprop status field is rarely populated

    # We don't want the keywords selection part, just the other fields which could effect our results
    ($primary_tables, $primary_fields, @primary_where) = &build_load_object_queries("", $extras, $site);

    return ($tables, $fields, \@where, $primary_tables, "", \@primary_where);
}

sub build_inv_load_object_queries {
    my ($keyword) = shift;
    my ($extras) = shift;
    my ($site) = shift;

    my ($fields, @where, $tables, $where_indx);

    #default at all
    $tables = "things";
    $fields = "title,objid,objclass,objtype,language,ref_from,axisnames,vcode,status";

    $where_indx = 0;
    $where[$where_indx++] = &build_where_hash("objid", "!%-A", "and");
    $where[$where_indx++] = &build_where_hash("objtype", $site->{'OBJTYPES'}->{'product'}, "and");
    
    if ($keyword ne "") {
	# things stuff
	&debug("build_load_object_queries:  Adding $keyword keyword to search", 3, $site->{'debug_level'}, $site->{'debug_log'});
	$where[$where_indx++] = &build_where_hash("(title", "%$keyword%", "or");
	$where[$where_indx++] = &build_where_hash("brief", "%$keyword%", "or");
	$where[$where_indx++] = &build_where_hash("keywords", "%$keyword%)", "and");
    }

    if ($extras->{'status'} ne "") {
	&debug("build_load_object_queries:  Adding status $extras->{'status'} to search", 3, $site->{'debug_level'}, $site->{'debug_log'});
	$where[$where_indx++]  = &build_where_hash("(status", "$extras->{'status'})", "and");
    }

    if ($extras->{'objid'} ne "") {
	&debug("build_load_object_queries:  Adding objid $extras->{'objid'} to search", 3, $site->{'debug_level'}, $site->{'debug_log'});
	$where[$where_indx++]  = &build_where_hash("(objid", "%$extras->{'objid'}%)", "and");
    }    

    &debug("load_object_queries:  REturning $tables, $fields to look!", 3, $site->{'debug_level'}, $site->{'debug_log'});
    return ($tables, $fields, @where);
}

sub build_inv_lang_object_queries {
    my ($keyword) = shift;
    my ($extras) = shift;
    my ($site) = shift;

    my ($fields, @where, $tables, $where_indx);
    my ($primary_tables, $primary_fields, @primary_where);
    #default at all
    $tables = "extraprop";
    $fields = "objid,body,language";

    # Language Query
    $where_indx = 0;
    $where[$where_indx++] = &build_where_hash("objid", "!%-A", "and");
    if ($keyword ne "") {
	$where[$where_indx++] = &build_where_hash("(fieldname", "title", "and");
	$where[$where_indx++] = &build_where_hash("body", "%$keyword%)", "or");
	$where[$where_indx++] = &build_where_hash("(fieldname", "brief", "and");
	$where[$where_indx++] = &build_where_hash("body", "%$keyword%)", "or");
	$where[$where_indx++] = &build_where_hash("(fieldname", "keywords", "and");
	$where[$where_indx++] = &build_where_hash("body", "%$keyword%)", "or");
    }
    else {
	$where[$where_indx++] = &build_where_hash("(fieldname", "title", "or");
	$where[$where_indx++] = &build_where_hash("fieldname", "brief", "or");
	$where[$where_indx++] = &build_where_hash("fieldname", "descript", "or");
	$where[$where_indx++] = &build_where_hash("fieldname", "keywords)", "or");
    }
	
    if ($extras->{'objid'} ne "") {
	$where[$where_indx++]  = &build_where_hash("objid", "%$extras->{'objid'}%", "and");
    }

    # We don't want the keywords selection part, just the other fields which could effect our results
    ($primary_tables, $primary_fields, @primary_where) = &build_inv_load_object_queries("", $extras, $site);

    return ($tables, $fields, \@where, $primary_tables, "", \@primary_where);
}

1;



