#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

##############################################################################
=pod

=head1 objects.pm

objects.pm - Routines to help with mapping

=head1 DESCRIPTION

This library is used to provide a mapping between the internal AllCommerce
data structure, with readable, and flexable perl code.  By not hard coding these
values throughout all of the scripts, it is possible to change the internal
value if necessary at any time without interuption.

=head1 NOTES & BUGS

=cut

##############################################################################

##############################################################################
=pod

=head2 getClassesAndTypes

getClassesAndTypes - &getClassesAndTypes

=over 4

=item DESCRIPTION

Initialize globals for objtypes and objclasses of any that need to be 
referenced.  

=item INPUT

none

=item OUTPUT

$OBJCLASS - Hashref pointing to all of the different types of objects, showing
            their internal object class.

$OBJTYPE - Hashref pointint to all of the different types of objects, showing their
           internal object type.

=item NOTES

=back

=cut
###############################################################################

sub getClassesAndTypes {
    
    my ($OBJCLASSES, $OBJTYPES);
    
    $OBJCLASSES->{'product'} = "134-A";
    $OBJCLASSES->{'product_variant'} = "134-A";
    $OBJCLASSES->{'brand'} = "136-A";
    $OBJCLASSES->{'product_line'} = "136-A";
    $OBJCLASSES->{'article'} = "136-A";
    $OBJCLASSES->{'nonproduct'} = "136-A";
    $OBJCLASSES->{'internal_doc'} = "136-A";
    $OBJCLASSES->{'warehouse'} = "163-A";

    $OBJCLASSES->{'contact'} = "128-A";
    $OBJCLASSES->{'variant'} = "181-A";
    $OBJCLASSES->{'attribute'} = "101-A";
    $OBJCLASSES->{'permission_set'} = "147-A";
    $OBJCLASSES->{'variant_set'} = "188-A";
    $OBJCLASSES->{'encoding'} = "188-A";
    $OBJCLASSES->{'object'} = "188-A";
    
    $OBJTYPES->{'product'} = "45000-A";
    $OBJTYPES->{'product_variant'} = "45000-A";
    $OBJTYPES->{'brand'} = "47004-A";
    $OBJTYPES->{'article'} = "47001-A";
    $OBJTYPES->{'product_line'} = "47005-A";
    $OBJTYPES->{'warehouse'} = "74003-A";
    $OBJTYPES->{'internal_doc'} = "47000-A";
    $OBJTYPES->{'contact'} = "39004-A";

    $OBJTYPES->{'variant'} = "";
    $OBJTYPES->{'variant_set'} = "99004-A";
    $OBJTYPES->{'encoding'} = "99003-A";
    $OBJTYPES->{'object'} = "99002-A";


    return ($OBJCLASSES, $OBJTYPES);
    
}

1;
