#!/usr/bin/perl -w
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# payprocess.pm

###########################################################################
=pod

=head1 NAME 

payprocess.pm

=head1 SYNOPSIS

This is a function library for payment process
by now, it is just a frame, it will be developed later 

=head1 DESCRIPTION

It will check the payment authorization, capture, and refund

=head1 NOTES & BUGS

=cut
############################################################################# 

use strict;

##############################################################################
=pod

=head2 payment_authorization

payment_authorization - payment_authorization

=over 4

=item DESCRIPTION

this function check the authorization of the payment,
and returns status of the order

=item INPUT

$payment - a reference to a hash which contains payment info

$site - Standard $site hash from &setsite

=item OUTPUT

$status - the order stauts, 15018-A if not approved
                            15020-A if approved
=item NOTES

=back

=cut
###############################################################################
sub payment_authorization {

    my $payment = shift;
    my $site = shift;

    ## get payment process from configuration
    my $payprocess = $site->{'payprocess'};

    $payprocess =~ tr/A-Z/a-z/;
    $payprocess =~ s/(\s+)//g;

    my $validation;

    if ($payprocess eq "none") {

        $validation = "false"; 
       
    } elsif ($payprocess eq "offline") {

        $validation = "false";

    } elsif ($payprocess eq "authorize.net") {

        ## call subroutine to authorize it using authorize.net
        #  which should return ture or false
        
        # now, since there is no authorization check
        # give false
        $validation = "false";

    } elsif ($payprocess eq "ccvs") {

        ## call subroutine to authorize it using ccvs
        #  which should return ture or false

        # now, since there is no authorization check
        # give false
        $validation = "false";

    } elsif ($payprocess eq "cybersource") {

        ## call subroutine to authorize it using cybersource
        #  which should return ture or false

        # now, since there is no authorization check
        # give false
        $validation = "false";

    } elsif ($payprocess eq "payment.net") {

        ## call subroutine to authorize it using payment.net
        #  which should return ture or false

        # now, since there is no authorization check
        # give false
        $validation = "false";

    } elsif ($payprocess eq "cybercash") {

        ## call subroutine to authorize it using cybercash
        #  which should return ture or false

        # now, since there is no authorization check
        # give false
        $validation = "false";

    }

    my $status;
    if ($validation eq "true") {
        # if ture, return status as 
        # "order placed, pending fulfillment"
        $status = "15020-A";
    } else {
        # if false, return status as 
        # "order held, pending payment authorization"
        $status = "15018-A";
    }

    return $status;

} # end of sub


sub payment_capture {

} # end of sub


sub payment_refund {

} # end of sub
