#!/usr/bin/perl
############################################################################
#     Copyright (C) 1999,2000 Zelerate, Inc.
#
#     This program is free software; you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation; either version 2 of the License, or
#     (at your option) any later version.
#
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with this program; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

#####
# state.pm
#     RF 981204
#
# customer state management operations
# these assume connection parameters of site.6.pm +
#
#####

###
# Version 3 LCF 20000914
#	 removed:
#	    get_promotion()
# Version 2 LCF 20000901
#	 added params to setsessionid for strict scripts
# Version 1 LCF 20000828
#     added $site parameter to setsessionid (only sets it if it's not global)
# Version 0.7.65 LCF 20000825
#	 added $site parameter to cartaddcheck
# Version 0.7.64 JC 20000822
#     added purchase limit to cart
# Version 0.7.63 JC 20000816
#     bug fix to site_limit_all
# Version 0.7.62 JC 20000807
#     bug fix to $wh 
# Version 0.7.61 JC 20000730
#     bug fixes to cartaddcheck
# Version 0.7.60 JC 20000727
#     added wh to tcart
# Version 0.7.59 JC 20000726
#     cleaned up revert cart
# Version 0.7.58 JC 20000726
#     put insertid back for backwards compatiblity
# Version 0.7.57 JC 20000720
#     replace insertid to mysql_insertid
# Version 0.7.56 JC 20000717
#     fixed weight bug in shipping methods
# Version 0.7.55 GF 20000714
#     fixed problem in setsessionid with mysql_insertid 
# Version 0.7.54 JC 20000711
#     added non-jit behaviors
# Version 0.7.53 JC 20000708
#     added active/inactive for cartaddcheck
# Version 0.7.52 IB 20000628
#     introduced SERVER_ADDR
# Version 0.7.51 JC 20000619
#     updated list_shipping_methods to current database specs
# Version 0.7.50 JC 20000619
#     updated query statement on line 1177 for shipping methods
# Version 0.7.49 JC 20000526
#     changed database and hash on tcart to inventory
# Version 0.7.48 JN 20000525
#     leapfrogged 47
#     fixed tcart_to_ocart
#     fixed non integer add or quant
# Version 0.7.46 GF 20000521
#     cartaddcheck classes for wishlist
# Version 0.7.38 GF 20000516
#     squashed variants into things
# Version 0.7.36 GF 20000507
#     changed vsku to msku,vcode
# Version 0.7.36 GF 20000507
#     cartclass in cartaddcheck
# Version 0.7.35 GF 20000504
#     cartaddcheck takes an objid
# Version 0.7.34 GF 20000426
#     cartaddcheck
# Version 0.7.33 IB 20000420
#     select->SELECT, insert->INSERT, update->UPDATE, set->SET
# Version 0.7.32 JC 20000420
#     added support more additional databases
# Version 0.7.31 GF 20000417
#     UID->CUSTID and miscellaneous changes
# Version 0.7.30 GF 20000414
#     cartaddcheck - working with 0_9
# Version 0.7.29 JC 20000331
#     correction on insertid entry
# Version 0.7.28 JC 20000330
#     insertid change
# Version 0.7.27 JC 20000330
#     changed connect statement
# Version 0.7.26 JC 20000330
#     changed DBI prepare/connect
# Version 0.7.25 IB 20000303
#     commented out a useless statement
# Version 0.7.24 IB 20000302
#     removed -w
# Version 0.7.23 IB 20000229
#     changed table to database
# Version 0.7.22 IB 20000226
#     changed store to site
# Version 0.7.21 JN 20000201
#     fixed multiple wishlist entries
# Version 0.7.20 IB 20000128
#     removed the ERLOG
# Version 0.7.19 JN 20000127
#     fixed bugs in previous version
# Version 0.7.18 JN 20000124
#     added tcart_to_pcart, pcart_to_tcart for wishlist
#     modified cartaddcheck for registry and wishlist
#     modified tcart_to_ocart for registry
# Version 0.7.17 JZ 20000114
#     fixed dvalue match
# Version 0.7.16 RF 000112
#     removed calls to the %FORM global in setsessionid()
# Version 0.7.15 IB 991217
#     removed the ERLOG 
# Version 0.7.14 IB 991115
#     remove commented out statements
# Version 0.7.13 IB 991110
#     replaced $store with $site      
# Version 0.7.12 IB 991027
#     changed setsessionid to return sid > 0 or 0
#     eliminated references to csid
# Version 0.7.11 RF 991022
#     cleanup of some excessive print statements
#     minor process cleanup of setsessionid()
# Version 0.7.8 SH 990801
#     included vcode into inventory cartaddcheck query
#     fixed error messages dropping quant requested
# Version 0.7.7 RF 990831
#     updated 'insertid' to 'mysql_insertid' on 788
# Versiom 0.7.3 GF 990830
#    added in subroutine for shipping method logic
# Version 0.7.2 GF 082899
#     SH swithced rowid back to line id
#     GF in process of revamping
#     Debugging JIT inventory, socheata what have you done here
#     cartaddcheck removed some wh stuff 
# Version 0.7.1 RF 990827
#     created new_eventid( \%h ): \%h -
#          grabs next available eventid and writes preliminary record
# Version 1 RF 981204
###
# Be safe!
use strict;
my $DEBUG = 1;

## new_eventid( \%h ): \%h - allocates and returns an eventid
#
#      Created 0.7.1 - 990827 RF
#      Input hashref:
#            series
#            dtable
#            ekind
#            process
#            status
#            dvalue
#
#      Returned hashref:
#            event
#            errors
#            series
#            dtable
#            ekind
#            process
#            status
#            dvalue
#            cdate
#
sub new_eventid {
     my( $hi,$ho,$n );

     my $h=$_[0];                         # inbound hashref
     my $o={};                             # outbound hashref
     ## check for database connect string
     #

     ## TBD - this is a stub
     #
     $o=$h;

     # return
     return $o;
} #/new_eventid 


# Utility to get a db handle
sub db_connect {
	my $site = shift;
	my $dbh=DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});
	return $dbh;
}
	
## tcart_to_ocart(sid) : $s - moves items from tcart to ocart
#      returns a string stating how many items were moved
#
sub tcart_to_ocart {
	my ( $sid,$site,$oid,$sidwh,$nextwh,$test ) = @_;    # session id and order id as args

	# don't bother to proceed if no sid
	return "Error - No Session ID! Nothing transfered from ccart!" unless ( $sid );  
	
	my $tst;
	if ( $test ) {
	    $tst="xt";			  # testing line status
	} else {
	    $tst="pl";			  # normal placed order status
	} # done with determining order line status to use

	
	## establish connection to the database 
	#
	my $dbh = &db_connect($site);
	
	## run through ccart rows and create scart rows, adding inventory
	#	 back to stock for hard inventory items
	#
	
	my $q = qq|SELECT * from tcart where SID='$sid' and orderid='$oid' |;
	my $sth = $dbh->prepare( $q );
	$sth->execute();
	my $count = 0;

	while ( my $h = $sth->fetchrow_hashref('NAME_lc') ) {
		$count++;
		## there are rows to move... 

		## Fill up ocart
		&ocart_fill($dbh, $h, $oid, $sid, $tst);

		# Return inv to store, if hard quant limit
		&ocart_to_inventory($dbh, $h);

	} # end of moving rows from ccart to scart

	## remove rows from ccart...
	&clear_tcart_order($sid, $oid, $dbh);

	## cleanup
	#
	$sth->finish if ( $sth );
	$dbh->disconnect;

	return $count;
} #/tcart_to_ocart


sub ocart_fill {
	my ($dbh, $h, $oid, $sid, $tst) = @_;
	my $now = time();
	
		
	my $q="INSERT INTO ocart (objid,orderid,sid,custid,msku,vcode,quant,";
	$q.="hquant,squant,unitpr,unitwt,taxable,linetotal,lineobjid,status,cdate,mdate,wh,objclass,objtype) ";
	$q.=" values ";
	$q.="('$h->{'objid'}','$oid','$sid','$h->{'custid'}','$h->{'msku'}','$h->{'vcode'}',";
	$q.="'$h->{'quant'}','$h->{'hquant'}','$h->{'squant'}','$h->{'unitpr'}',";
	$q.="'$h->{'unitwt'}','$h->{'taxable'}','$h->{'linetotal'}','$h->{'lineobjid'}','$tst','$now','$now','$h->{'wh'}','$h->{'objclass'}', '$h->{'objtype'}' )"; 
	$dbh->do( $q );

	return;
}


sub ocart_to_inventory {
	my ($dbh, $h) = @_;
	
	## now update inventory as needed ONLY FOR TEST ORDERS!
	#	 TBD
	# this is a test order, return inventory to store
	my $q="UPDATE inventory SET lstock=lstock+$h->{'hquant'} ";
	$q.=" where objid = '$h->{'objid'}'";

	if ( $h->{'hquant'} ) {
		$dbh->do( $q );
	} # else there was no hard quantity allocation for this...
	  # end of test mode inventory reversion
	  # done with row ...
	
	return;
}
	

sub clear_tcart_order {
	my ($sid, $oid, $dbh) = @_;
	
	# Delete order from tcart, as it is now in ocart instead	
	my $q="DELETE from tcart where SID=$sid and orderid='$oid'";
	$dbh->do( $q );

	return;
}

## tcart_to_inventory : $s - moves items from tcart to inventory
#      returns a string stating how many items were moved
#
sub tcart_to_inventory {
	my $sid  	= shift;
	my $site    = shift;

	# don't bother to proceed if no sid
	return 'Error - No Session ID! Nothing transfered from inventory!' unless ( $sid );
		
	## establish connection to the database
	#
	my $dbh = &db_connect($site);
	
	## run through tcart rows and create tcart rows, adding inventory
	#	 back to stock for hard inventory items
	#
	my $sth = &get_tcart_rows($sid, $dbh);
	
	my $num = 0;
	while ( my $tcart_objid = $sth->fetchrow() ) {
		$num++;
	}

	# Drop from tcart
	my $q = "DELETE from tcart where sid='$sid'";
	$dbh->do( $q );

	## cleanup
	#
	$sth->finish() if ( $sth );
	$dbh->disconnect();

	return $num;
} #/tcart_to_inventory

## get_tcart_rows: returns an executed statement handle
#	from tcart. This is just a row count, it selects objid
#	because it's the primary key, and thus fast.
#
sub get_tcart_rows {
	my ($sid, $dbh) = @_;
	
	my $q = " SELECT objid FROM tcart WHERE sid='$sid' ";
	my $sth = $dbh->prepare( $q );
	$sth->execute();

	return $sth;
} 


## tcart_to_pcart
# clone of pcart to tcart
#
sub tcart_to_pcart {
	my $sid  	= shift;
	my $site 	= shift;
	my $uid		= shift;
	my $lineid 	= shift;


	# Get a db handle
	my $dbh = &db_connect($site);
	
	my $q = "SELECT * from tcart where LINEID='$lineid' and SID='$sid'";

	my $sth = $dbh->prepare($q);
	$sth->execute();
	my $h = $sth->fetchrow_hashref('NAME_lc');
	
	my $success = 0;
	if ($h) {
		my @keys;
		my @vals;
		
		foreach my $k (keys %{$h}) {
			next unless ($h->{$k});
			next if ($k eq 'UID');
			push @keys, $k;
			push @vals, $h->{$k};
		}
		
		push @keys, 'UID';
		push @vals, $uid;

		my $pcartstring = join(',',@keys);
		my $pcartvalstring = join (',',@vals);
		
		$q    = "INSERT into pcart ($pcartstring) VALUES ($pcartvalstring)";
		$sth = $dbh->prepare($q);
		$sth->execute();

		$success = 1;
	}

	$sth->finish if ( $sth );
	$dbh->disconnect;

	return $success;
}
				

sub pcart_to_tcart {
	my ($site, $form, $rowid) = @_;
	
	# Get row from pcart
	my $q = qq|SELECT * FROM pcart WHERE custid = '$site->{custid}' AND objid = '$rowid'|;
	my $sth = $site->{dbh}->prepare($q);
	my $rv = $sth->execute();
	my $row = $sth->fetchrow_hashref('NAME_lc');
	$sth->finish();
	
	return unless $row->{'objid'}; # Bail if there's no data
	
	# Try to add this item to the cart
	my ($objid, $availquant, $err) = &cartaddcheck($form->{'row.'.$rowid.'.quant_inp'},'',$row->{'lineobjid'},$form->{'sid'},'81001-A','',$site->{'custid'},$site->{'om_locale_curr_def'},$site);

	return if (!$availquant || $err); # Bail if there's no quantity or an error happens
	
	# Otherwise, Remove row from pcart
	$q = qq|DELETE from pcart where objid = '$rowid' AND custid = '$row->{'custid'}'|;
	$sth = $site->{dbh}->prepare($q);
	$rv = $sth->execute();
	$sth->finish;
	
	return;
}

## cartaddcheck gets( sku,var,sid,quant,unitpr ): outputs(lineid,quant,err);
#
# Version 0.7.21 20000507 GF
#     cartslass
# Version 0.7.20 20000504 GF 
#     OBJID for sku,vcode
#
# Version 0.7.19 20000414 GF
#
sub cartaddcheck {
	my $AC = &set_ac_obj(@_);

    # check to see if have a requested quantity, if we don't 
    # set it to the requested $add
    &state_debug("quant is $AC->{quant}") if $DEBUG;

  	# Set quantities
	if (!$AC->{quant}) { 
        $AC->{quant}		= $AC->{add};
        $AC->{availquant}	= $AC->{quant};
    } 
    &state_debug("availquant is $AC->{availquant}") if $DEBUG;
    
	# Bail with error if they are not requesting an integer amount
	return( 0,0,'Sorry, positive integers only') unless (&quant_test($AC));
	&state_debug("Quant is valid") if $DEBUG;
	
    # sid should have been validated before user got here 
	# Bail if there's no session id.
    return( 0,0,"Error - no session id!" ) unless ( $AC->{sid} );
	&state_debug("There is a session id. It's $AC->{sid}") if $DEBUG;
	
    # see if user is looking for wishlist or registry
    $AC = &cart_wish_or_reg($AC);

	# if $dbcart isn't a cart, it's an error, and we should return it now.
	return (0,0,$AC->{db_cart}) if ($AC->{db_cart} !~ /cart$/);
	&state_debug("Cart is valid.") if $DEBUG;
	
	## find the customer's existing cart entry for this item
    $AC = &get_existing_cart($AC);
	&state_debug("Orderid in cart: $AC->{cart_element}->{orderid}") if $DEBUG;

    $AC = &what_currency($AC);

	# Get an orderid, or set create_orderid flag
    $AC = &check_empty_orders($AC) if ( ! $AC->{err} );
	&state_debug("Orderid: $AC->{orderid}, create new: $AC->{create_orderid}") if $DEBUG;

	# create a new orderid if we need to
	$AC = &create_orderid($AC) if ( ! $AC->{err} );
	
    # now actually check the cart to see if the user has this item in cart
    $AC = &check_for_item($AC) if ( ! $AC->{err} );

	# If we need to, this will update the quantity of this item
    $AC = &update_cart_quant($AC) if ( ! $AC->{err} );
	&state_debug("Item is $AC->{lineid}") if $DEBUG;
	
	# check inventory and see if product is in local stock 
    $AC = &check_inventory($AC) if ( ! $AC->{err} );
    &state_debug("Local stock inventory is $AC->{inventory}->{lstock}");

	# See if the product is a master or variant, and if it's active
    $AC = &master_or_variant($AC) if ( ! $AC->{err} );
	&state_debug("Master? ($AC->{master}) Variant? ($AC->{variant}) Active? ($AC->{active})");	

	# need to see if there will be overflow in the amount they are putting in the cart
	# Sets $AC->{err} on error
	$AC = &check_cart_overflow($AC) if ( ! $AC->{err} );
	&state_debug("Overflow? ($AC->{err})");
	
	# If there was no error in the last check, See if there's a behavior problem
	$AC = &check_for_behavior_error($AC) unless ($AC->{err});
    &state_debug("done checking inventory rules, quant is $AC->{availquant}");
	
	# now try to add stuff to the cart
	#$AC = &add_to_cart($AC) if ($AC->{availquant} > 0 && !$AC->{err});
	# error check disables setting quant properly when hitting error.
	$AC = &add_to_cart($AC) if ($AC->{availquant} > 0);
	
    ## check for addition of master product
    #

    if ( $AC->{master} ) {
        $AC->{err}="4";
    }
    if ( $AC->{act} ) {
        $AC->{err}="5";
    }

	&state_debug("Error code is: $AC->{err}") if $AC->{err};
	$AC->{dbh}->disconnect();
	
    return ( $AC->{objid},$AC->{availquant},$AC->{err} );
} # /cartaddcheck




## Simple debugging routine
#
sub state_debug {
	my $msg = shift;
	my $now = localtime(time());
	
	warn "[$now, state.pm] $msg\n";
	return;
}

## Create a nice bundle of useful stuff, so we don't have
#	to pass a million args all over the place.
#
sub set_ac_obj {	
	my ( $add,$quant,$lineid,$sid,$cartclass,$addrid,$custid,$currency,$site ) = @_;

	my $AC = {
		add 		=> $add,
		quant 		=> $quant,
		lineid 		=> $lineid,
		sid 		=> $sid,
		cartclass 	=> $cartclass,
		addrid 		=> $addrid,
		custid 		=> $custid,
                currency	=> $currency,
		site 		=> $site
	};
		
	# Set the database handle 
	$AC->{dbh} = &db_connect($site);

	# Set the render lang if it isn't found
	$AC->{render_lang} = $site->{'om_render_lang'};

    ## get the time
    #
    $AC->{now}=time();

    my $warn = "In cartaddcheck:\n";
	foreach my $key (keys %{$AC}) {
		$warn .= "\t$key => $AC->{$key}\n";
	}
    &state_debug($warn) if $DEBUG;

	return $AC;
}

## Test that quantity requested is an int.
#	takes $AC, returns 0 for fail, 1 for success.
#
sub quant_test {
	my $AC = shift;
	
	# Check if this contains anything non numeric
   if ($AC->{quant} =~ /[\D]+/) { return 0 }
	return 1;
}




## Determine if a request is for a wishlist or a registry.
#
sub cart_wish_or_reg {
	my $AC = shift;
	if ( ($AC->{cartclass} eq '81000-A') || ($AC->{cartclass} eq '81002-A') ) {
        # must have uid for registry and wishlist
		&state_debug("Customer ID is $AC->{custid}") if $DEBUG;
		return $AC unless ( $AC->{custid} );	
        $AC->{db_cart} = 'pcart';
    } else {
        $AC->{db_cart} = 'tcart';
		$AC->{cartclass} = '81001-A';
    }
	&state_debug("dbcart is $AC->{db_cart}") if $DEBUG;
	
 	return $AC;
}



## Find orderid from cart, if there is one
#
sub get_existing_cart {
	my $AC = shift;
	my $cartid; # For wishlist stuff?
	
	my $q="SELECT orderid from $AC->{db_cart} where ";
 
    if ($AC->{cartclass} eq "81002-A") {            # wish list
        $q.=" custid='$AC->{custid}' and objclass='81002-A'";
    } elsif ($AC->{cartclass} eq "81000-A"){      # gift registry
        $q.=" and objclass='81000-A' and orderid='$AC->{cartid}' ";
    } else {
        $q.=" sid='$AC->{sid}' ";
    }
	&state_debug("Getting existing cart with: $q") if $DEBUG;

    my $sth = $AC->{dbh}->prepare( $q );
    $sth->execute();
    
	$AC->{cart_element} = $sth->fetchrow_hashref('NAME_lc');

        my $q="SELECT currency from $AC->{db_cart} where ";
     if ($AC->{cartclass} eq "81002-A") {            # wish list
         $q.=" custid='$AC->{custid}' and objclass='81002-A'";
     } elsif ($AC->{cartclass} eq "81000-A"){      # gift registry
         $q.=" and objclass='81000-A' and orderid='$AC->{cartid}' ";
     } else {
         $q.=" sid='$AC->{sid}' ";
     }  

     my $sth = $AC->{dbh}->prepare( $q );
     $sth->execute();  
        $AC->{cart_currency} = $sth->fetchrow;

 	$sth->finish();
	
	return $AC;
}
	

## If we have an empty cart...
#
sub check_empty_orders {
	my $AC = shift;
	if (exists($AC->{cart_element}->{orderid})) {
		&state_debug("Orderid is not empty. It is $AC->{cart_element}->{orderid}");
		$AC->{orderid} = $AC->{cart_element}->{orderid};
		return $AC;
	}

	&state_debug("Orderid is empty. Looking for existing...");
	my $q="SELECT objid FROM orders WHERE sid='$AC->{sid}' AND custid='$AC->{custid}' AND status='15012-A'";
    
	my $sth = $AC->{dbh}->prepare( $q );
    $sth->execute;
    $AC->{orderid} = $sth->fetchrow();
	$sth->finish();
	
	$AC->{create_orderid} = 1 unless ( $AC->{orderid} );
	return $AC;
} 


## Create a new orderid, if needed
#
sub create_orderid {
	my $AC = shift;
	
	# See if we have one?
	return $AC if (defined($AC->{orderid}) || !$AC->{create_orderid});
	
	&state_debug("Creating new order id") if $DEBUG;
	my $dvalue="Create OrderID";

        if ( $AC->{site}->{'site_datadriver'} =~ /mysql/ ) {
	
	    my $q="INSERT into levents (dtable,dvalue,cdate,series) values 
	         ('tcart','$dvalue','$AC->{now}','$AC->{site}->{'series'}') ";
	
	    my $sth = $AC->{dbh}->prepare($q);
	    my $rv = $sth->execute();
	
	    $q = "SELECT event,series from levents where dtable='tcart'
	        and dvalue='$dvalue' and cdate='$AC->{now}' ";

	    $sth = $AC->{dbh}->prepare($q);
	    $sth->execute();
	    my ($event, $series) = $sth->fetchrow();
	    $sth->finish();
	
	    $AC->{orderid} = $event."-".$series;

        } elsif ( $AC->{site}->{'site_datadriver'} =~ /Pg/ ) {

            my $q="INSERT into levents (event,dtable,dvalue,cdate,series) values ";
               $q.=" (NEXTVAL('event'),'tcart','$dvalue','$AC->{now}','$AC->{site}->{'series'}') ";
            my $sth = $AC->{dbh}->prepare( $q );
               $sth->execute;

               $q="SELECT CURRVAL('event'),series from levents where dtable='tcart' ";
               $q.= " AND cdate='$AC->{now}' ";
               $sth=$AC->{dbh}->prepare($q);
               $sth->execute;
               my ($event,$series)=$sth->fetchrow;
            $AC->{orderid} = $event."-".$series;
        } elsif ( $AC->{site}->{'site_datadriver'} =~ /Oracle/ ) {

            my $q="INSERT into levents (event,dtable,dvalue,cdate,series) values ";
            $q.=" (levents_event.nextval,'tcart','$dvalue','$AC->{now}','$AC->{site}->{'series'}') ";
            my $sth =$AC->{dbh}->prepare( $q );
            $sth->execute;

            $q="SELECT levents_event.currval FROM DUAL";
            $sth=$AC->{dbh}->prepare($q);
            $sth->execute;
            my $event=$sth->fetchrow;

            $AC->{orderid}=$event."-".$AC->{site}->{'series'}; 
        }

	&state_debug("Created new orderid $AC->{orderid}") if $DEBUG;

	return $AC;
}


## See if we have this item already...
#
sub check_for_item {
	my $AC = shift;	
	my $where;
	
	if ($AC->{cartclass} eq "81002-A") {									
        $where = " and orderid='$AC->{orderid}' and objclass='81002-A'";	

    } elsif ($AC->{cartclass} eq "81000-A"){
        $where = " and cartclass='81000-A' and orderid='$AC->{orderid}'";
 
    } else {
        $where = " and sid='$AC->{sid}' ";
 	}
        
    my $q = qq|SELECT 
				orderid,objid,sid,msku,vcode,wh,quant,linetotal 
			   FROM 
			   	$AC->{db_cart}
               WHERE 
			   	lineobjid='$AC->{lineid}' $where|;
          
	&state_debug("Checking for item with: $q") if $DEBUG;
	
    my $sth = $AC->{dbh}->prepare( $q );
    my $rv = $sth->execute();
    $AC->{item} = $sth->fetchrow_hashref('NAME_lc') || undef;
	$sth->finish();
	
	&state_debug("Do we have this item? Quant is: $AC->{item}->{quant}.") if $DEBUG;
	return $AC;
}


## Set the cart quantity to old + new, if we're doing a quant update
#
sub update_cart_quant {
	my $AC = shift;
	&state_debug("Cartclass is $AC->{cartclass}") if $DEBUG;
	
	#return $AC if ( $AC->{cartclass} eq '81002-A' ); # Wishlist, maybe? Yes-- now allowed.
	return $AC unless ($AC->{item}->{quant});	     # item exists in the cart?
	return $AC unless ($AC->{add});                  # are we adding to the cart?
	
	&state_debug("Item exists. Updating quantity.") if $DEBUG;
	&state_debug("Old quant was $AC->{item}->{quant}, Adding $AC->{quant}") if $DEBUG;
    
	# Now just take the old val, and the new, and add 'em up.
	# Make $AC->{quant} equalt the new value.
	$AC->{quant} = $AC->{quant} + $AC->{item}->{quant};

	&state_debug("Quantity is now $AC->{quant}") if $DEBUG;
	return $AC;
}


## See if we have the item in stock
#
sub check_inventory {
	my $AC = shift;

	&state_debug("Checking inventory for item $AC->{lineid}.") if $DEBUG;
	
	#my $q = qq|SELECT lstock,wh,status from inventory 
	my $q = qq|SELECT lstock from inventory 
           where objid='$AC->{lineid}' and status='15000-A'|;
    
	&state_debug("Checking inv with $q") if $DEBUG;
    
	my $sth = $AC->{dbh}->prepare( $q );
    $sth->execute();
	
	
	my $count = 0;
	my $inv;
	$inv = $sth->fetchrow;
	#while ($inv = $sth->fetchrow_hashref('NAME_lc')) {
	#&state_debug("inventory is AC: $AC->{inventory} INV: $inv");
	#	$count++;
	#}
	$sth->finish();
	
	&state_debug("Number of inventory rows is $count");
	#return $AC if ($count != 1);	# Must only match one row!
	$AC->{inventory}->{lstock} = "$inv";
	&state_debug("inventory is AC: $AC->{inventory} INV: $inv");
	return $AC;
}




##  Determine if the product is a master or a variant.
#    Sets $AC->{master} or $AC->{variant} flags
#	Also checks for active or not, and sets $AC->{active} flag
sub master_or_variant($AC) {
	my $AC = shift;
	
	my $q = "SELECT msku,vcode,ref_from,behavior,status from things where objid='$AC->{lineid}'";
	my $sth = $AC->{dbh}->prepare( $q );
	my $rv  = $sth->execute();

	my ($ref_from, $activity);
    ( $AC->{msku},$AC->{vcode},$ref_from,$AC->{behavior},$activity ) = $sth->fetchrow(); 
	&state_debug("ref from is $ref_from, behavior is $AC->{behavior}");
	$sth->finish();
	
	## check to see if this is active or inactive
	#
	$AC->{active} = 0;
	if ( $activity eq "15001-A" ) {
	    $AC->{active} = 1;
	}

	if ( (length($ref_from) > 2) && ( $AC->{lineid} eq $ref_from )) {  

		# refrom larger than 2
		# can't add master product to cart
    		#$num = 0;
    		$AC->{master} = 1;
		&state_debug("this is a master product");

     } else { # variant
      
    	$q="SELECT behavior from things where objid='$ref_from'";
    	$sth=$AC->{dbh}->prepare( $q );
    	$sth->execute;
    	$AC->{behavior} = $sth->fetchrow() || $AC->{behavior};
		$sth->finish();
		$AC->{variant} = 1;
		&state_debug("this is a variant");

    }
    return $AC;

} 


## Check to see that the amount requested does not exceed 99999.99 in price
#
sub check_cart_overflow {
	my $AC = shift;
	
    my $q = "SELECT lineobjid,unitpr,quant FROM tcart WHERE orderid='$AC->{orderid}' and status != '140-A'";
    &state_debug("Checking for cart overflow with $q") if $DEBUG;
	
	my $sth = $AC->{dbh}->prepare( $q );
    $sth->execute();
 
    my $total = 0;
	my $qtty;
	while (my ($item,$price,$qtt)=$sth->fetchrow()) {
	
    	if ( $item eq $AC->{lineid} ) {
   			$qtty = $qtt;
            $qtt  = $AC->{quant};    
        } 

    	$total += $price * $qtt;
    }
	$sth->finish();
	
	unless ($total) {
		$q = qq|SELECT unitpr from prices where objid = '$AC->{lineid}' and currency = '$AC->{currency}'|;
		$sth = $AC->{dbh}->prepare($q);
		$sth->execute();
		my $price = $sth->fetchrow();
		
		$total += $price * $AC->{quant};
	}
	
	&state_debug("Line total price is: $total") if $DEBUG;
	if ( $total > 99999.99) {
      ## overflow in amount that can be purchased
      &state_debug("Error! You can't buy \$$total worth of stuff!") if $DEBUG;
	  $AC->{err} = "8";
      $AC->{availquant} = $qtty;
	}
	
	return $AC;
}



############
## Stock checking routines:
############

## Check limits on JIT saleable stock
#                                       
# inventory site limit rules
# jit limit 	   $site_limit_jit
# general limit  $site_limit_all
# see how it compares to the request
# jit -  compare to limit plus positive 
# stock only

sub check_jit_quant_limit {
	my $AC = shift;
	
	my $limitjit = $AC->{site}->{'site_limit_jit'};
    #$limitjit += $x if ( $x > 0 ); # ??? Where did "$x" come from ???

                                 # jit error message

    if ( $AC->{quant} > $limitjit ) {
        #error - Sorry quantity is limited to this item.
        $AC->{err} = "1";
        $AC->{availquant} = $limitjit;

    } else {
            $AC->{availquant} = $AC->{quant};
    } #/examining JIT scenarios
	return $AC;
}


## check the behavior to see if we can sell this product
#
sub check_for_behavior_error {
	my $AC = shift;
    
	## classes coded
   # 90000-A special order if no stock
   # 90001-A special order regardless of stock
   # 90002-A jit saleable if no stock
   # 90003-A back orderable if no stock
   # 90004-A advance orderable if no stock
   # 90005-A potentially restockable if no stock
   #                ( ok to add to wish list or notify me list )
   # 90006-A saleable irrespective of stock
   # 90007-A discontinued
   # 90008-A recalled
   ##                     
	&state_debug("starting check for behavior $AC->{behavior}");



	# Check behaviors that might be valid
	if ( $AC->{behavior} eq '90002-A' || $AC->{cartclass} eq '81002-A' || $AC->{cartclass} eq '81000-A') {

		# Behavior is JIT saleable, do JIT stock check
    	$AC = &check_jit_quant_limit($AC);

	} elsif ( $AC->{behavior} eq '90006-A' ) { 

		$AC->{availquant}=$AC->{quant};

	} elsif ( $AC->{behavior} eq '90005-A' ) {                      

		&state_debug("Enter 90005-A check");
    	## Potentially restockable-- check $AC->{inv} hashref for lstock
    	#
      if ( $AC->{inventory}->{lstock} <= 0 ) {
			&state_debug("Lstock is less or equal to $AC->{inventory}->{lstock} <= 0");
         #error - Sorry, but this item is now out of stock.
         $AC->{err} = "3";
         $AC->{availquant} = 0;
			return $AC;
      }   	
		# quantity requested is more than lstock
		if ( $AC->{quant} > $AC->{inventory}->{lstock}) {	 
			&state_debug("Lstock: $AC->{quant} >  $AC->{inventory}->{lstock}");
         #set quant to local stock  											 	 
		  	$AC->{availquant} = $AC->{inventory}->{lstock};
        	$AC->{quant} = $AC->{availquant};
	      $AC->{err} = "2";			
			return $AC;
      }
		$AC->{availquant}=$AC->{quant};
  	}
	 
	## do last check, but check_site_limit needs to be last.
	#
	$AC = &known_error_behaviors($AC);
   $AC = &check_site_limit_exceeded($AC);
   return $AC;
}
 
 
 
##  If behavior is  90007-A (discontinued) or 90008-A (recalled),
#	then we can't sell this item. Just set availquant to 0 and error
sub known_error_behaviors {
	my $AC = shift;
	# First check for known error behaviors, and bail immediately if so
	&state_debug("starting check for known error behavior $AC->{behavior}");

	if ( $AC->{behavior} eq '90007-A' ) { 
		&state_debug("Enter 90007-A check. inventory: $AC->{inventory}->{lstock}");
      ## discontinued
      #
      if ( $AC->{inventory}->{lstock} <= 0 ) {
			&state_debug("Lstock is less or equal to $AC->{inventory}->{lstock} <= 0");
         #error - Sorry, but this item is now out of stock.
			$AC->{err} = "6";
         $AC->{availquant} = 0;
			return $AC;
      }   	
		# quantity requested is more than lstock
		if ( $AC->{quant} > $AC->{inventory}->{lstock}) {	 
			#set quant to local stock  											 	 
	  		$AC->{availquant} = $AC->{inventory}->{lstock};
     		$AC->{quant} = $AC->{availquant};
	   	$AC->{err} = "2";			
			return $AC;
   	}
		$AC->{availquant}=$AC->{quant};
	} elsif ( $AC->{behavior} eq '90008-A' ) { 
    		## recalled
    		#
    		$AC->{err}="7";
    		$AC->{availquant}=0;
		}
	return $AC;
}


##  Generic check to be sure requested quant doesn't exceed the hard site limit for stock
sub	check_site_limit_exceeded {
	my $AC = shift;
   	if ( $AC->{quant} > $AC->{site}->{'site_limit_all'} ) {
       	#error - Sorry quantity is limited to this item.
       	$AC->{err} = "1";
       	$AC->{availquant} = $AC->{site}->{'site_limit_all'};
   	} 
	return $AC;
}


sub add_to_cart {
	my $AC = shift;
	
	my $unit_price = &get_obj_price($AC);
	
	## unit price x quantity available
	#
	$AC->{linetotal} = $unit_price * $AC->{availquant};
        $AC->{unitpr} = $unit_price;
	&state_debug("Linetotal is $AC->{linetotal}");

    ## already one in cart do an update
    #
	my $done_already = 0;
    if ( !$AC->{create_orderid} && ($AC->{item}->{quant}) ) {     # update cart, adding another item
		&state_debug("Updating order $AC->{orderid}") if $DEBUG;
		
		&update_existing_obj($AC);
		$done_already = 1;
    } #/update existing row 

	# Insert new stuff
	if ( ( $AC->{objid} == 0 ) and 
	     ( !$AC->{master}    ) and 
	     ( !$AC->{active}    ) and 
		 ( !$done_already    ) ) {  # new item, create the entry for this sid
		
		&state_debug("Inserting new item.") if $DEBUG;
		$AC = &insert_new_obj($AC);


	} # end of decision on whether or not, and how, to add the item

	return $AC;
}



sub insert_new_obj {
	my $AC = shift;
	
	$AC = &create_cart_event($AC);
		
	## insert line in to cart
	#
	if ( $AC->{addrid} ) {
		$AC->{cartclass} = 'REG';
	}

	$AC = &get_warehouse($AC);
	&update_cart($AC);

	return $AC;
}


sub update_existing_obj {
	my $AC = shift;

	my $q = qq|
		UPDATE $AC->{db_cart}
		SET 
			linetotal='$AC->{linetotal}', quant='$AC->{availquant}', mdate='$AC->{now}', unitpr='$AC->{unitpr}' 
		WHERE 
			orderid='$AC->{orderid}' AND lineobjid='$AC->{lineid}'|;
	
	my $sth = $AC->{dbh}->prepare( $q );
	my $rv = $sth->execute();
	
	&state_debug("Updating order. Query was $q and return was $rv");
	return $AC;
}
	

sub get_obj_price {
	my $AC = shift;
		
	my $q="SELECT unitpr from prices where objid='$AC->{lineid}' and currency='$AC->{currency}' and status='15000-A' ";
	my $sth = $AC->{dbh}->prepare( $q );
	$sth->execute(); 

	my $unitpr;
	while ( my $unitpr_temp = $sth->fetchrow()) {
		$unitpr = $unitpr_temp if ( ! $unitpr );
		$unitpr = $unitpr_temp if ( $unitpr > $unitpr_temp );  
	} 

	&state_debug("Price is: $unitpr");
	return $unitpr;
}


sub create_cart_event {
	my $AC = shift;
	my $dvalue="Create ObjectId";     # used to be lineid
        my $objid;
	
	my $now = time();
        if ( $AC->{site}->{'site_datadriver'} =~ /mysql/ ) {  

       	my $q="INSERT into levents (dtable,dvalue,cdate,series) values ('tcart','$dvalue','$now', '$AC->{site}->{'series'}') ";
	my $sth = $AC->{dbh}->prepare($q);
	$sth->execute();
	$sth->finish();
	
	$q="SELECT event,series from levents where dtable='tcart' and dvalue='$dvalue' and cdate='$now' ORDER BY event DESC";
	$sth = $AC->{dbh}->prepare($q);
	$sth->execute();
	my ($event, $series) = $sth->fetchrow();
	$objid = $event."-".$series;  

        } elsif ( $AC->{site}->{'site_datadriver'} =~ /Pg/ ) {

            my $q="INSERT into levents (event,dtable,dvalue,cdate,series) values ";
               $q.=" (NEXTVAL('event'),'tcart','$dvalue','$now','$AC->{site}->{'series'}') ";
            my $sth = $AC->{dbh}->prepare( $q );
               $sth->execute;

               $q="SELECT CURRVAL('event'),series from levents where dtable='tcart' ";
               $q.= " AND cdate='$now' ";
               $sth=$AC->{dbh}->prepare($q);
               $sth->execute;
               my ($event,$series)=$sth->fetchrow;
             $objid = $event."-".$series; 
        } elsif ( $AC->{site}->{'site_datadriver'} =~ /Oracle/ ) {

            my $q="INSERT into levents (event,dtable,dvalue,cdate,series) values ";
            $q.=" (levents_event.nextval,'tcart','$dvalue','$now','$AC->{site}->{'series'}') ";
            my $sth =$AC->{dbh}->prepare( $q );
            $sth->execute;

            $q="SELECT levents_event.currval FROM DUAL";
            $sth=$AC->{dbh}->prepare($q);
            $sth->execute;
            my $event=$sth->fetchrow;

            $objid=$event."-".$AC->{site}->{'series'};
        }
	
	$AC->{objid} = $objid;
	return $AC;
}


sub get_warehouse {
	my $AC = shift;
	
	## if a warehouse does not exist (e.g. jit), get the first one on the list
	#
	my $librelpath = "$AC->{site}->{'fsroothtml'}/$AC->{site}->{'fsrelativeroot'}";
	$librelpath .= "/bits/$AC->{render_lang}/html/sel"; 
	unless ( $AC->{item}->{wh} ) {
    	open(WH, "<$librelpath/sel_warehouse.sel") || die "Cannot open $librelpath/sel_warehouse.sel: $!";
    	my @raw=<WH>;
    	close(WH);
    	$AC->{wh} = (split /\|/, $raw[1])[0];
	}     
	return $AC;
}

sub what_currency {
	my $AC = shift;

        if ( $AC->{cart_currency} ) {

            if ( $AC->{cart_currency} ne $AC->{currency} ) {

                $AC->{currency} = $AC->{cart_currency};

                my $p="SELECT * FROM prices WHERE objid='$AC->{lineid}' and currency='$AC->{'currency'}' ";
                   $p.=" AND status='15000-A' ";
                my $sth=$AC->{dbh}->prepare($p);
                   $sth->execute;

                if ( my $pp=$sth->fetchrow_hashref('NAME_lc') ) {
                   # there is another price
                } else {
                    $AC->{objid} = 0;
                    $AC->{availquant} = 0;
                    $AC->{err} = "This item does not have the appropriate currency to be added to this cart."; 
                }
            
            }


        } 

        return $AC;
}

sub update_cart	{
	my $AC = shift;
	my $q= qq|
		INSERT INTO $AC->{db_cart}
	 		(objid,orderid,sid,msku,vcode,quant,wh,cdate,mdate,unitpr,
	     	 linetotal,lineobjid,objclass,custid,currency)
	 	values ('$AC->{objid}','$AC->{orderid}','$AC->{sid}','$AC->{msku}','$AC->{vcode}','$AC->{availquant}','$AC->{wh}','$AC->{now}',
	 	        '$AC->{now}','$AC->{unitpr}','$AC->{linetotal}','$AC->{lineid}','$AC->{cartclass}','$AC->{custid}','$AC->{currency}')|;
	
	my $sth = $AC->{dbh}->prepare($q);		 
	my $rv = $sth->execute();

	&state_debug("Update cart. Query is $q, returned $rv");

	return;
}



##  setsessionid(): $s - checks %FORM for sid, if needed sets cookie
#                              and returns either sid > 0 or 0
#
#          v6 2000521 GF - retrofit to 0.9 datastructure
#          v5 2000112 RF - removed %FORM dependancies, read data from
#                              the %ENV ( as $ENV{'REQUEST_URI'} ) instead
#          v4 991027  IB - changed setsessionid to return sid > 0 or 0
#          v3 991023  RF - added handling of AFFILIATE for affiliate referrals
#                              and cleanup of diagnostic printing to logfile
#          v2 981213  RF - added handling of ADBUY and ARTWORK
#          v1 981204  RF
#
sub setsessionid {
    my $site = shift;
    my $dbh = shift;
    my %FORM = @_;
    
    my $sid = 0;

    ## read URI domain name and use for setting cookie
    #
    my $td;
	$td = $ENV{'SERVER_NAME'};
    $td = $ENV{'SERVER_ADDR'} unless ( $td );
    my ($adbuy, $artwork, $referer) = &get_ad_params();

    # do not read the FORM hash, read the ENV{HTTP_COOKIE} directly
	# There is no cookie, see if we have a sid in the FORM
	if ( ($FORM{'sid'}) && (!$ENV{'HTTP_COOKIE'}) ) {
		$sid = $FORM{'sid'};
    }
	
	# If they did have a cookie, see if we can get an sid out of it.
	if ( (!$sid) && ($ENV{'HTTP_COOKIE'}) ) {
		$sid = &extract_sid_from_cookie();
                $sid = &decrypt_sid($sid, $site);
	}
	
	# If whatever we tried above didn't produce a cookie, set a new one.
	$sid = &setsession_fresh($site, $dbh, $adbuy, $artwork, $referer, %FORM)
		unless $sid;

    # Make sure the sid is in the FORM
        my $sid_encrypt = &encrypt_sid($sid, $site);
	$FORM{'sid'}=$sid_encrypt;
    ## now set the cookie
    print "Set-Cookie: sid=$sid_encrypt; path=/; domain=$td\n";

	return $sid;
}


sub extract_sid_from_cookie {
	my $sid = 0;
	my @temp = split /;(\s*)/, $ENV{'HTTP_COOKIE'};
    
	while (my $element = shift @temp) {
        my ( $k,$v ) = split /=/,$element,2 ;
        $sid=$v if ( $k eq "sid" );
    } # done walking through bits

	return $sid;
}

## Find ad params from ENV
#
sub get_ad_params {
    
	## parse out the affiliate, advert or adbuy, and artwork parameters
    #  from the $ENV{''} (do not require call to read_parse in cgi-lib.pm
    #  for the setting of session ids -- all required data is in the raw
    #  environment parameters).
    #
	my ($adbuy, $artwork, $referer);
	
    $adbuy     = ( $ENV{'REQUEST_URI'} =~ /(?:adbuy|advert)=(.*?)(?:$|\&)/o )[0];
    #$affiliate = ( $ENV{'REQUEST_URI'} =~ /affiliate=(.*?)(?:$|\&)/o )[0];
    $artwork   = ( $ENV{'REQUEST_URI'} =~ /artwork=(.*?)(?:$|\&)/o )[0];
    $referer   = $ENV{'HTTP_REFERER'} if ( exists($ENV{'HTTP_REFERER'}) );

	return ($adbuy, $artwork, $referer);
}


sub setsession_fresh {
    my ($site, $dbh, $adbuy, $artwork, $referer, %FORM) = @_;
	my $sid = 0;
	my ($q);
	# there is no session id, get a new one
    my $now = time();

	# get $sid before insert for msql - this is just temporary
    $sid = &get_sid_preinsert($dbh) if ($site->{'site_datadriver'} =~ /msql/);
    $ENV{'HTTP_USER_AGENT'}=substr( $ENV{'HTTP_USER_AGENT'},0,40 );
    if ( $site->{'site_datadriver'} =~ /mysql/ ) {
         $q = qq|INSERT into sessions 
				(sid,browser,sourceip, referer,adbuy,artwork,cdate,mdate) 
            VALUES 
		  		($sid,'$ENV{'HTTP_USER_AGENT'}','$ENV{'REMOTE_ADDR'}', 
		  		 '$referer','$adbuy','$artwork',$now,$now) |;
    } elsif ( $site->{'site_datadriver'} =~ /Oracle/ ) {

         $q = qq|INSERT into sessions
                                 (sid,browser,sourceip, referer,adbuy,artwork,cdate,mdate)
             VALUES
                                 (sessions_sid.nextval,'$ENV{'HTTP_USER_AGENT'}','$ENV{'REMOTE_ADDR'}',
                                  '$referer','$adbuy','$artwork',$now,$now) |;

    } elsif ( $site->{'site_datadriver'} =~ /Pg/ ) {

         $q="INSERT into sessions (sid,browser,sourceip,";
         $q.="referer,adbuy,artwork,cdate,mdate) ";
         $q.=" VALUES ";
                     $q.=" (NEXTVAL('sid'),'$ENV{'HTTP_USER_AGENT'}','$ENV{'REMOTE_ADDR'}',";
         $q.="'$referer','$adbuy','$artwork',$now,$now) ";

    }          


    my $sth = $dbh->prepare( $q );
    $sth->execute();

	# get $sid after insert - this is just temporary 
    if ( $site->{'site_datadriver'} =~ /mysql/ ) {
        $sid = $sth->{mysql_insertid};
    } elsif ( $site->{'site_datadriver'} =~ /informix/ ) {
        $sid = $sth->{ix_sqlerrd}[1];
    } elsif ( $site->{'site_datadriver'} =~ /Pg/ ) {
        $q = "SELECT currval('sid')";
        $sth = $dbh->prepare($q);
        $sth->execute;
        $sid = $sth->fetchrow;
    } elsif ( $site->{'site_datadriver'} =~ /Oracle/ ) {
        $q = "SELECT sessions_sid.currval FROM DUAL";
        $sth = $dbh->prepare($q);
        $sth->execute;
        $sid = $sth->fetchrow;
    } 
    $sth->finish;

	return $sid;
}
	

## get $sid before insert for msql - this is just temporary
#
sub get_sid_preinsert {
	my ($dbh) = @_;

    my $q = "SELECT _sid FROM sessions";
    my $sth = $dbh->prepare($q);
    $sth->execute();
    my $sid=$sth->fetchrow(); 

	return $sid;
}


# Functions included:
#     list_ship_methods( tocntry, tozip, weight [,frmcntry [,frmzip ]] ) :
#          @(sku:price:method name)
#
#
#
#
### list_ship_methods
##      returns an array of join-ed sku, price, method name for the parcel
##      args: ( tocountry, tozip, weight [,fromcountry [,fromzip ]] ) : @array
##      NEW 990524 RF
#
sub list_ship_methods {
    # Takes $site as first arg!
    my @methods = ();
    my %titles  = ();
	my $site = shift;
    my ($tocntry, $tozip, $weight, $fromcntry, $fromzip) = @_;

	# Get a db handle
	my $dbh = &db_connect($site);
	
    ## check arguments and set defaults or throw an error message
    #
    $fromcntry = "USA" if ( ! $fromcntry );
    $tocntry   = "USA" if ( ! $tocntry );
    $weight    = 1.0   if ( ! $weight );

    if ( ! $tozip ) {
        @methods = ( "ERROR - insufficient data to price shipping!",
                     "ERROR - $tocntry,$tozip,$weight,$fromcntry,$fromzip" );
        return @methods;
    } # done with exit early passing error messages

    ## get list of active shipping methods ( STATUS="pn" )
    #
    ## HACK RF 3-990526 to accomodate System V style calls
    #
 
#need to put back later when database is good
#    my $q = "SELECT * from things WHERE status='15000-A' AND objclass='140-A' ";
   my $q = "SELECT * from things WHERE objclass='140-A' "; 
   my $sth=$dbh->prepare($q);
    $sth->execute();
    my $count = 0;
	
	while (my $h = $sth->fetchrow_hashref('NAME_lc')) {
        $count++;
		$titles{$h->{'objid'}} = $h->{'title'};  
    } # done loading active shipping methods
    
	$sth->finish() if ( $sth );
    
	if ( $count < 1 ) { # exit early...
        @methods = ( "ERROR - no available shipping methods!",
                     "ERROR - $tocntry,$tozip,$weight,$fromcntry,$fromzip" );
        return @methods;
    } # done with nothing found branch

    ## prepare querry
    $q = "SELECT * from zonemap where destzipmn<='$tozip' and destzipmx>='$tozip' ORDER BY shipmeth ";
    $sth = $dbh->prepare( $q );
    $sth->execute();
    
	$count = 0;
	my ($old, $old2);
	## construct available methods...
    while ( my $h = $sth->fetchrow_hashref('NAME_lc') ) {
    	next if ( ! $titles{$h->{'shipmeth'}} || ($old eq $h->{'shipmeth'}));
    	$old = $h->{'shipmeth'};
    	$old2= $h->{'shipzone'};
    	my $meth = join "\t", ("$h->{'shipmeth'}","$h->{'shipzone'}" );
    	push @methods, ( $meth );
		$count++;
    } # done constructing list of methods

	$sth->finish();
	
	if ( $count < 1 ) {    # no available shipping....
        @methods = ( "ERROR - no shipping available to destination!",
                     "ERROR - $tocntry,$tozip,$weight,$fromcntry,$fromzip" );
        return @methods;
    } # done with nothing found branch

    $old="old";
    $old2="old";    

    ## now get costs for each available method
    foreach my $i ( 0 .. $#methods ) {
    	my ( $meth,$zone ) = split /\t/, $methods[$i];
    	$q = "SELECT * from zonerate 
		      WHERE shipmeth='$meth' and shipzone='$zone' and shipwt>='$weight'
              ORDER BY shipwt ";
		warn "Q is $q\n";	  
        $sth = $dbh->prepare($q);
        $sth->execute();
        my $h = $sth->fetchrow_hashref('NAME_lc');
		if ( $h ) {  # just need the first returned record
            $methods[$i] = join "\t", ( $meth, $h->{'shipcost'}, $titles{$meth} ); 
        } else {             # this isn't available for here
            $methods[$i]="ERROR - method not available for this location";
        } # done with decision on results

    } # done  getting costs
    ## disconnect and cleanup
    #
    $sth->finish() if ( $sth );

    my $error = 1;
    foreach my $method (@methods) {
        $error = 0 if ($method !~ /^ERROR/);        
    }

    if ($error == 1) {
        return @methods;
    }

    # cleanup error rows from list
    my @temp=();
    while ( @methods ) {
        my $l = shift @methods;
        next if ( $l =~ /^ERROR/ );
        push @temp, ( $l );
    }
    @methods=@temp;

    return @methods;
} # /list_ship_methods



1;


