#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

##############################################################################
=pod

=head1 track.pm

track.pm - the library for tracking site usgae

=head1 SYNOPSIS

http://YOURDOMAIN/cgi-bin/om/track.cgi

=head1 DESCRIPTION

This library is used with track.cgi which is responsible for tracking site usage

=head1 NOTES & BUGS

=cut
###############################################################################
use strict;
##############################################################################
=pod

=head2 track_main

track_main - &track_main();

=over 4

=item DESCRIPTION

The main driver is responsible for tracking site usage

=item INPUT

$site - the site parameters

$dbh - the database handler

NONE

=item OUTPUT

record site usage into database

=item NOTES

=back

=cut
###############################################################################
sub track_main {
	my ($site, $dbh) = @_;
	
	 use DBI;
    ## use a very restricted library set -- get cookie from %ENV
    #     only invoke libraries etc... if we have to set a sid
    #
    my $sid=$ENV{'HTTP_COOKIE'};
    $sid=( split /sid=/, $sid )[1] if ( $sid );
    $sid=( split /&/, $sid )[0] if ( $sid );
    $sid=&decrypt_sid($sid,$site); 
    my $now=time();
    my $site=setsite();

    ## write the pageview to the clicks table...
    #
	my ($req_uri, $http_ref) = '';
    if ($ENV{'REQUEST_URI'}) {
        $req_uri = $ENV{'REQUEST_URI'};
    } 

    if ($ENV{'HTTP_REFERER'}) {
        $http_ref = $ENV{'HTTP_REFERER'};
    }

    my $select_hash = {};
    $select_hash->{'TABLE'}->{'NAME'} = "clicks";
    $select_hash->{'TABLE'}->{'FIELDS'}->{'sid'} = $sid;
    $select_hash->{'TABLE'}->{'FIELDS'}->{'request'} = $req_uri;
    $select_hash->{'TABLE'}->{'FIELDS'}->{'referer'} = $http_ref;
    $select_hash->{'TABLE'}->{'FIELDS'}->{'os_cluster'} = $site->{'clusterid'};
    $select_hash->{'statement'} = "INSERT";
    my $q = &build_sql($select_hash, $site, $dbh, 1);
    &debug($q, 2, $site->{'debug_level'}, $site->{'debug_log'});

#    $q = "INSERT INTO clicks VALUES ('$sid','$now','$req_uri','$http_ref','$site->{'clusterid'}')";
#    old sql statement. 

    if (!&query_execute($q, $site, $dbh)) {
	&debug("track_main: Cannot execute $q", 1, $site->{'debug_level'}, $site->{'debug_log'});
    }

    ## cleanup statement handles and close connection
    #
}
 
###############################################################################

1;
