use strict;
###############################################################################
# Bin object description:
#
#	objid        [assigned]
#	objclass     wmsbin
#	level        [upper/lower]
#	name         [location name]
#	status       [active/reserve]
#	quant        [quantity of boxes or items]
#	wh           [warehouse id]
#	size         [size objid (pointer to size object)]
#	msku          [currently contains what? (sku objid)]
#	cdate
#	mdate
###############################################################################

sub get_one_bin {
	my ($site, $id) = @_;
	
	my $bin = &get_one_object($site, $id, 'wmsbin');
	
	$bin->{'nosave'} = {
		'objid' => 1,
		'objclass' => 1,
		'msku' => 1
	} if ($bin);
	
	return $bin;
}


sub store_bin {
	my ($site, $bin) = @_;
	return undef unless ($bin->{'objid'} && ($bin->{'objclass'} eq 'wmsbin'));
	
	my ($newbin, $err) = &store_object($site, $bin);
	return ($newbin, $err);
}


1;
