#/usr/bin/perl

use strict;
use DBI;

&main(@ARGV);

1;

sub main {
    my (@ARGV) = @_;
    
    my ($site, $dbh, $objid, $object_hashref, $key, $where_clause);
    my ($fields, @definitions, $sql, $all_sql, $h, $key, $q);

    my ($hash, @defs);

    ($site, $dbh) = &initscript();

    $dbh = DBI->connect($site->{'db_site_connect'}, "$site->{'site_dbiuser'}", "$site->{'site_dbipwd'}");

    $object_hashref->{'statement'} = "INSERT";
    $object_hashref->{'TABLE'}->{'NAME'} = "things";
    $object_hashref->{'TABLE'}->{'FIELDS'}->{'objclass'} = "188-A";
    $object_hashref->{'TABLE'}->{'FIELDS'}->{'objtype'} = "109000-A";
    $object_hashref->{'TABLE'}->{'FIELDS'}->{'status'} = "15000-A";
    $object_hashref->{'TABLE'}->{'FIELDS'}->{'brief'} = "This is an internal field for AllCommerce.";
    $object_hashref->{'TABLE'}->{'FIELDS'}->{'visibility'} = "109000-A";    
    $object_hashref->{'TABLE'}->{'FIELDS'}->{'language'} = $site->{'om_render_lang'};
    $object_hashref->{'append_objid'} = 1;

    $defs[0]->{'title'} = "Brand";
    $defs[0]->{'body'} = 
"gen|Generate Page
title:Name
brief:Brief
descript:Description
keywords:Keywords
status:Status
visibility:Render
pagestyle:Pagestyle
weight_man:Weight
sku_skel:Sku Code
";
    $defs[0]->{'sel_name'} = "sel_47004-A_gui";

    $defs[1]->{'title'} = "Product";
    $defs[1]->{'body'} = 

"title:Name
brief:Brief
descript:Description
keywords:Keywords
status:Status
visibility:Render
pagestyle:Pagestyle
weight_man:Weight
behavior|Stock Behavior
axisname|Variational Set
ship_weight|Shipping Weight
msku|SKU
<link>:page=sel_inventory_gui:href=__inventory_link__|Inventory
<link>:page=sel_price_gui:href=__price_link__|Pricing
";
    $defs[1]->{'sel_name'} = "sel_45000-A_gui";

    $defs[2]->{'title'} = "Variant Product";
    $defs[2]->{'body'} = 
"<row_start>
<sel_var_new_gui>
<row_end>
<row_start>
<sel_var_exists_gui>
<row_end>";
    $defs[2]->{'sel_name'} = "sel_variant_gui";

    $defs[3]->{'title'} = "Existing Variant Products";
    $defs[3]->{'body'} = 
"<row_start>
title:display|Name
status|Status
visibility|Render
weight_man|Weight
ship_weight|Shipping Weight
<link>:page=sel_inventory_gui:href=__inventory_link__|Inventory
<link>:page=sel_price_gui:href=__price_link__|Pricing
<row_end>
";
    $defs[3]->{'sel_name'} = "sel_var_exists_gui";

    $defs[4]->{'title'} = "Add Variant Product";
    $defs[4]->{'body'} = 
"<row_start>
axis1:|__title1__
axis2:|__title2__
axis3:|__title3__
axis4:|__title4__
status|Status
visibility|Render
weight_man|Weight
ship_weight|Shipping Weight
<link>:page=sel_inventory_gui:href=__inventory_link__|Inventory
<link>:page=sel_price_gui:href=__price_link__|Pricing
<row_end>
";
    $defs[4]->{'sel_name'} = "sel_var_new_gui";


    $defs[5]->{'title'} = "Variant";
    $defs[5]->{'body'} = 
	"title|Name";
    $defs[5]->{'sel_name'} = "sel_181-A_gui";


    $defs[6]->{'title'} = "Encoding";
    $defs[6]->{'body'} = 
"title|Name
briefBrief
encoding|Encoding
sel_name|Select Filename";
    $defs[6]->{'sel_name'} = "sel_188-A_gui";

    $defs[7]->{'title'} = "Product Line";
    $defs[7]->{'body'} = 
"gen|Generate Page
title|Name
brief|Brief
descript|Description
keywords|Keywords
status|Status
visibility|Render
pagestyle|Pagesytle
weight_man|Weight
";
    $defs[7]->{'sel_name'} = "sel_47005-A_gui";

    $defs[8]->{'title'} = "Article";
    $defs[8]->{'body'} = 
"gen|Generate Page
title|Title
brief|Brief
descript|Article
keywords|Keywords
status|Status
visibility|Render
pagestyle|Pagesytle
weight_man|Weight
author|Author
ship_weight|Shipping Weight
<link>:page=sel_inventory_gui:href=__inventory_link__|Inventory
<link>:page=sel_price_gui:href=__price_link__|Pricing
";
    $defs[8]->{'sel_name'} = "sel_47001-A_gui";


    $defs[9]->{'title'} = "Internal Document";
    $defs[9]->{'body'} = 
"title|Title
brief|Brief
descript|Article
keywords|Keywords
status|Status
visibility|Render
pagestyle|Pagesytle
weight_man|Weight
author|Author
";
    $defs[9]->{'sel_name'} = "sel_47000-A_gui";


    $defs[10]->{'title'} = "Warehouse";
    $defs[10]->{'body'} = 
"title|Name
brief|Brief
keywords|Keywords
status|Status";
    $defs[10]->{'sel_name'} = "sel_74003-A_gui";

    $defs[10]->{'title'} = "Permission Set";
    $defs[10]->{'body'} = 
"title|Title
brief|Brief
uperm|Permissions";
    $defs[10]->{'sel_name'} = "sel_147-A_gui";

    $defs[11]->{'title'} = "User";
    $defs[11]->{'body'} = 
"uname|User Name
passwd|Password
hint|Hint
uperms|Permission Sets
gen_trigs|Generate Site Pages?
uperm|Unique Permissions";
    $defs[11]->{'sel_name'} = "sel_128-A_gui";

    $defs[12]->{'title'} = "Attribute";
    $defs[12]->{'body'} = 
"title|Name
brief|Brief
html|HTML String
lang_sens|Language Sensitive
";
    $defs[12]->{'sel_name'} = "sel_101-A_gui";

    $defs[13]->{'title'} = "Prices";
    $defs[13]->{'body'} = 
"<row_start>
<row_price_new_gui>
<row_end>
<row_start>
<row_price_exist_gui>
<row_end>
<link>:page=sel_inventory_gui:href=__inventory_link__|Inventory
<link>:href=__back_to_product__|Back to __objid__
";

    $defs[13]->{'sel_name'} = "sel_price_gui";

    $defs[14]->{'title'} = "Existing Prices";
    $defs[14]->{'body'} = 
"<row_start>
unitct:display|Unit Count
unitpr|Unit Price
currency|Currency
status|Status
autogen:display|Rule Generated?
<row_end>";
    $defs[14]->{'sel_name'} = "sel_price_exist_gui";


    $defs[15]->{'title'} = "Add Price";
    $defs[15]->{'body'} = 
"<row_start>
unitct:display|Unit Count
unitpr|Unit Price
currency|Currency
status|Status
autogen:display|Rule Generated?
<row_end>";
    $defs[15]->{'sel_name'} = "sel_price_exist_gui";


    $defs[16]->{'title'} = "Inventory";
    $defs[16]->{'body'} = 
"<row_start>
wh:display|Warehouse
lstock:display|In Stock
status|Status
adjust|Adjust
<row_end>
link:link:page=sel_price_gui|Pricing
link:link:href=__back_to_product__|Back to __objid__";
    $defs[16]->{'sel_name'} = "sel_inventory_gui";




    $defs[17]->{'title'} = "Shipping Zones";
    $defs[17]->{'body'} = 
"shipzone|Shipping Zone
shipmeth|Shipping Method
fromzip|From zipcode
fromcntry:display:value=USA|From Country
destcntry:display:value=USA|To Country
destzipmin|Minimum Zipcode in range
destzipmax|Maximum Zipcode in range
status|Status
link:link:href=__shipping_rate__|Shipping Rates";
    $defs[17]->{'sel_name'} = "sel_zonemap_gui";

    $defs[18]->{'title'} = "Shipping Rates";
    $defs[18]->{'body'} = 
"shipmeth|Shipping Method
shipzone|Shipping Zone
shipwt|Max Shipping Weight
shipcost|Cost per item per zone, weight and method
currency|Currency
status|Status
link:link:href=__shipping_rate__|Shipping Zones";
    $defs[18]->{'sel_name'} = "sel_zonerate_gui";


    foreach $hash (@defs) {
	$object_hashref->{'TABLE'}->{'FIELDS'}->{'title'} = $hash->{'title'};
	&insert_gui_def($object_hashref, $hash->{'body'}, $hash->{'sel_name'}, $site, $dbh);
    }
}


sub insert_gui_def {
    my ($insert) = shift;
    my ($body) = shift;
    my ($sel_name) = shift;
    my ($site) = shift;
    my ($dbh) = shift;


    my ($q, $objid, $res, $extra);

    $q = &build_insert($insert, $site, $dbh, 1);
    ($q, $objid) = split /\:\:/, $q;
    $res = &query_execute($q, $site, $dbh);

    $extra->{'statement'} = "INSERT";
    $extra->{'TABLE'}->{'NAME'} = "extraprop";
    $extra->{'TABLE'}->{'FIELDS'}->{'objid'} = $objid;
    $extra->{'TABLE'}->{'FIELDS'}->{'fieldname'} = "encoding";
    $extra->{'TABLE'}->{'FIELDS'}->{'language'} = $site->{'om_render_lang'};
    $extra->{'TABLE'}->{'FIELDS'}->{'body'} = $body;
    $q = &build_insert($extra, $site, $dbh, 1);
    $res = &query_execute($q, $site, $dbh);

    $extra = {};
    $extra->{'statement'} = "INSERT";
    $extra->{'TABLE'}->{'NAME'} = "extraprop";
    $extra->{'TABLE'}->{'FIELDS'}->{'objid'} = $objid;
    $extra->{'TABLE'}->{'FIELDS'}->{'fieldname'} = "sel_name";
    $extra->{'TABLE'}->{'FIELDS'}->{'language'} = $site->{'om_render_lang'};
    $extra->{'TABLE'}->{'FIELDS'}->{'body'} = $sel_name;
    $q = &build_insert($extra, $site, $dbh, 1);
    $res = &query_execute($q, $site, $dbh);

}

######################### INITIALIZATION SUBROUTINES #######################

##############################################################################
=pod

=head2 initscript

initscript - ($site, $dbh) = &initscript();

=over 4

=item DESCRIPTION

Determine the relative path, and connect to the database

=item INPUT

none

=item OUTPUT

$site - A hashref containing information required throughout about the current
        site and session

$dbh - current active database handle

=item NOTES

=back

=cut
###############################################################################
sub initscript {
    my ($s, @temp, @rpath, $rundir, $siteshortname, $u, $scriptname, $relpath);
    my ($k, $dbh, $site);
    
    ## determine path from store (site) root and store db name...
    #
    #  note - this script runs at server root or in cgi-bin/om/admin,
    #    generally. Test these conditions first.
    #  $0 - may not contain a full path, bootstrap with "pwd"
    #
    if ( $0 !~ /^\// ) {  # $0 is not an absolute path
        $s=`pwd`;          # hope pwd on path...
        chomp $s;
        $s.="/$0";
        } else {              # $0 IS an absolute path
        $s=$0;
    } # done determining if $0 is relative or absolute
    @temp=split /\//, $s;
    
    @rpath=@temp;
    
    $scriptname = pop @rpath;
    $scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff
    
    $rundir= join "/", @rpath;
    chdir( $rundir );
    
    $relpath="";
    $siteshortname="";

    ## short circuit if $s does not contain tests
    if ( $s !~ /tests/ ) {
	$siteshortname = pop @rpath;
	$relpath=".";
	@temp=();
    } # done testing for degenerate case
    
    while ( @temp ) {
        $u = pop @temp;
        
        ## skip references to the present directory
        next if ( $u eq '.' );
        next if ( length($u)==0 );        # skip null directory levels
        
        $relpath.="/.." if ( $relpath);
        $relpath.="." if ( ! $relpath );
        
	if ( $u eq "tests" ) {
	    $siteshortname = $temp[$#temp];
	    @temp=();
	} # note - tests is off the site root, so the next up is site root        
    } # done constructing relative path to store root
    
    $relpath .= "/../$siteshortname";
    ($site, $dbh) = &initsite($scriptname, $relpath);
    $site->{'siteshortname'} = $siteshortname;
    
    return ($site, $dbh);
}

##############################################################################
=pod

=head2 initsite

initsite - ($site, $dbh) = &initsite($scriptname, $relpath);

=over 4

=item DESCRIPTION

The init site loads in all required library modules and creates the variables 
that are required throughout the script. 

=item INPUT

$scriptname - The name of the script (inventory.cgi)

$relpath - The relative path to files that must be required

=item OUTPUT

$site - A hashref containing information required throughout about the current
        site and session

$dbh - current active database handle

=item NOTES

To add parameters that need to be passed around to a lot of locations, add them
to the $site hashref.

To change the debug of the script, change $site->{'debug_level'} to one of the 
following values:

    0 - no debug

    1 - errors only

    2 - all SQL statements, warnings & errors

    3 - all of the above

To change the location of the debug log, change the value of $site->{'debug_log'}. 
Be sure to start it will >> to allow appending to the file.  To set the Generate
Page? button to be selected by default, change the $site->{'generate_default'} to
1.  To have it non-selected by default, change the $site->{'generate_default'} 
to 0.

=back

=cut
###############################################################################
sub initsite {
    my ($scriptname) = shift;
    my ($relpath) = shift;
    
    my ($find, $q, $interface, $sts, $h, $x, @temp, $n, $k);
    my ($session_lang, $script, $site, $dbh);
    my ($select_hash, $q2);

    use DBI;
    require "$relpath/conf/site.pm";
    require "$relpath/lib/conversions.pm";
    require "$relpath/lib/filetools.pm";
    require "$relpath/lib/formtools.pm";
    require "$relpath/lib/variant.pm";
    require "$relpath/lib/language.pm";
    require "$relpath/lib/admin_object.pm";
    require "$relpath/lib/localization.pm";
    require "$relpath/lib/objects.pm";
    require "$relpath/lib/permission_layer.pm";    
    require "$relpath/lib/db_layer.pm";
    require "$relpath/lib/language.pm";
    
    # must be the last require statement
    require "$relpath/lib/custom-lib.pm";
    
    ## establish site-specific parameters
    #
    $site=setsite();
    
    ## connect to database
    # system 6 database state, products, and customer tables are collapsed
    #
    $q = "$site->{'db_site_config'}";
    $dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});
    
    $site->{'om_render_lang'} = "";
    $site->{'om_render_lang'}=$site->{'om_locale_lang_def'} if ( ! $site->{'om_render_lang'} );
    $site->{'om_render_lang'}="eng" if ( ! $site->{'om_render_lang'} );
    $interface="html" if ( ! $interface );
    
    ## load messages
    $script=( split /\./, $scriptname )[0];

    # Configure all parameters to pass around in $site hash
    $site->{'selskeletonpath'} = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/html/sel";
    $site->{'skeletonpath'} = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/pages";
    $site->{'scriptpath'} = join "/", ( @temp[0..$n] );
    $site->{'script'} = ( split /\./, $scriptname )[0];
    $site->{'scriptname'} = $scriptname;
    $site->{'relpath'} = $relpath;
    $site->{'debug_level'} = 3;
    $site->{'debug_log'} = ">>/tmp/test_db";
    $site->{'sid'} = $site->{'sid'};
    $site->{'session_lang'} = $session_lang;
    $site->{'scriptinfo'} = "$site->{'scriptpath'}/$site->{'scriptname'}";
    $site->{'targetpath'}="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/transit/export/order";    
    ($site->{'OBJCLASSES'}, $site->{'OBJTYPES'}) = &getClassesAndTypes();
    # Flag, set to 0 to have default for Generate page? as no, and
    # set to 1 to have default as yes
    $site->{'generate_default'} = 0;
    $site->{'languageSensitive'} = "title,brief,keywords,author,descript,encoding";
    $site->{'inherit_from_master'} = "brief";

    &debug("Debuggin inventory.cgi...",3, $site->{'debug_level'}, ">/tmp/inventory");
    return ($site, $dbh);
}





