#/usr/bin/perl

use strict;
use DBI;

&main(@ARGV);

1;

sub main {
    my (@ARGV) = @_;
    
    my ($site, $dbh, $objid, $object_hashref, $key, $where_clause);
    my ($fields, @definitions, $sql, $all_sql, $h, $key, $q);

    my ($hash, @defs, $h, $i);

    ($site, $dbh) = &initscript();
    $site->{'override_permissions'} = "yes";

    $dbh = DBI->connect($site->{'db_site_connect'}, "$site->{'site_dbiuser'}", "$site->{'site_dbipwd'}");
    $i = 0;

    $h = {};
    $h->{'title_inp'} = "Brand";
    $h->{'gui_inp'} = 
"gen|Generate Page
title|Name
brief|Brief
descript|Description
keywords|Keywords
status|Status
visibility|Render
pagestyle|Pagestyle
weight_man|Weight
sku_skel|Sku Code
";
    $h->{'gui_name_inp'} = "47004-A_gui";
    $defs[$i++] = $h;

    $h = {};
    $h->{'title_inp'} = "Product";
    $h->{'gui_inp'} = 
"title|Name
brief|Brief
descript|Description
keywords|Keywords
status|Status
visibility|Render
pagestyle|Pagestyle
weight_man|Weight
behavior|Stock Behavior
axisname|Variational Set
ship_weight|Shipping Weight
sku_series|Brand
msku|SKU
";
    $h->{'gui_name_inp'} = "45000-A_gui";
    $defs[$i++] = $h;

    $h = {};
    $h->{'title_inp'} = "Variant Product";
    $h->{'gui_inp'} = 
"<row_start>
<var_new_gui>
<row_end>
<row_start>
<var_exists_gui>
<row_end>";
    $h->{'gui_name_inp'} = "variant_gui";
    $defs[$i++] = $h;

    $h = {};
    $h->{'title_inp'} = "Existing Variant Products";
    $h->{'gui_inp'} = 
"<row_start>
title_inp:display|Name
status|Status
visibility|Render
weight_man|Weight
ship_weight|Shipping Weight
<row_end>
";

    $h->{'gui_name_inp'} = "var_exists_gui";
    $defs[$i++] = $h;

    $h = {};
    $h->{'title_inp'} = "Add Variant Product";
    $h->{'gui_inp'} = 
"<row_start>
axis1|__title1__
axis2|__title2__
axis3|__title3__
axis4|__title4__
status|Status
visibility|Render
weight_man|Weight
ship_weight|Shipping Weight
<row_end>
";
    $h->{'gui_name_inp'} = "var_new_gui";
    $defs[$i++] = $h;

    $h = {};
    $h->{'title_inp'} = "Variant";
    $h->{'gui_inp'} = 
	"title|Name";
    $h->{'gui_name_inp'} = "181-A_gui";
    $defs[$i++] = $h;

    $h = {};
    $h->{'title_inp'} = "Encoding";
    $h->{'gui_inp'} = 
"title|Name
brief|Brief
encoding|Encoding
sel_name|Select Filename";
    $h->{'gui_name_inp'} = "99003-A_gui";
    $defs[$i++] = $h;

    $h = {};
    $h->{'title_inp'} = "Product Line";
    $h->{'gui_inp'} = 
"gen|Generate Page
title|Name
brief|Brief
descript|Description
keywords|Keywords
status|Status
visibility|Render
pagestyle|Pagestyle
weight_man|Weight
";
    $h->{'gui_name_inp'} = "47005-A_gui";
    $defs[$i++] = $h;

    $h = {};
    $h->{'title_inp'} = "Article";
    $h->{'gui_inp'} = 
"gen|Generate Page
title|Title
brief|Brief
descript|Article
keywords|Keywords
status|Status
visibility|Render
pagestyle|Pagestyle
weight_man|Weight
author|Author
ship_weight|Shipping Weight

";
    $h->{'gui_name_inp'} = "47001-A_gui";
    $defs[$i++] = $h;

    $h = {};
    $h->{'title_inp'} = "Internal Document";
    $h->{'gui_inp'} = 
"title|Title
brief|Brief
descript|Article
keywords|Keywords
status|Status
visibility|Render
pagestyle|Pagesytle
weight_man|Weight
author|Author
";
    $h->{'gui_name_inp'} = "47000-A_gui";
    $defs[$i++] = $h;

    $h = {};
    $h->{'title_inp'} = "Permission Set";
    $h->{'gui_inp'} = 
"title|Title
brief|Brief
uperm|Permissions";
    $h->{'gui_name_inp'} = "147-A_gui";
    $defs[$i++] = $h;


    $h = {};
    $h->{'title_inp'} = "User";
    $h->{'gui_inp'} = 
"uname|User Name
passwd|Password
hint|Hint
uperms|Permission Sets
gen_trigs|Generate Site Pages
uperm|Unique Permissions";
    $h->{'gui_name_inp'} = "39004-A_gui";
    $defs[$i++] = $h;

    $h = {};
    $h->{'title_inp'} = "Attribute";
    $h->{'gui_inp'} = 
"title|Name
brief|Brief
html|HTML String
lang_sens|Language Sensitive
";
    $h->{'gui_name_inp'} = "101-A_gui";
    $defs[$i++] = $h;

    $h = {};
    $h->{'title_inp'} = "Prices";
    $h->{'gui_inp'} = 
"<row_start>
<row_price_new_gui>
<row_end>
<row_start>
<row_price_exist_gui>
<row_end>
<link>:href=__back_to_product__|Back to __objid__
";

    $h->{'gui_name_inp'} = "price_gui";
    $defs[$i++] = $h;

    $h = {};
    $h->{'title_inp'} = "Existing Prices";
    $h->{'gui_inp'} = 
"<row_start>
unitct:display|Unit Count
unitpr|Unit Price
currency|Currency
status|Status
autogen:display|Rule Generated?
<row_end>";
    $h->{'gui_name_inp'} = "price_exist_gui";
    $defs[$i++] = $h;


    $h = {};
    $h->{'title_inp'} = "Add Price";
    $h->{'gui_inp'} = 
"<row_start>
unitct:display|Unit Count
unitpr|Unit Price
currency|Currency
status|Status
autogen:display|Rule Generated?
<row_end>";
    $h->{'gui_name_inp'} = "price_exist_gui";
    $defs[$i++] = $h;

    $h = {};
    $h->{'title_inp'} = "Inventory";
    $h->{'gui_inp'} = 
"<row_start>
wh:display|Warehouse
lstock:display|In Stock
status|Status
adjust|Adjust
<row_end>
<link>:href=__back_to_product__|Back to __objid__";
    $h->{'gui_name_inp'} = "inventory_gui";
    $defs[$i++] = $h;


    $h = {};
    $h->{'title_inp'} = "Shipping Zones";
    $h->{'gui_inp'} = 
"shipzone|Shipping Zone
shipmeth|Shipping Method
fromzip|From zipcode
fromcntry:display:value=USA|From Country
destcntry:display:value=USA|To Country
destzipmin|Minimum Zipcode in range
destzipmax|Maximum Zipcode in range
status|Status
link:link:href=__shipping_rate__|Shipping Rates";
    $h->{'gui_name_inp'} = "zonemap_gui";
    $defs[$i++] = $h;

    $h = {};
    $h->{'title_inp'} = "Shipping Rates";
    $h->{'gui_inp'} = 
"shipmeth|Shipping Method
shipzone|Shipping Zone
shipwt|Max Shipping Weight
shipcost|Cost per item per zone, weight and method
currency|Currency
status|Status
link:link:href=__shipping_rate__|Shipping Zones";
    $h->{'gui_name_inp'} = "zonerate_gui";
    $defs[$i++] = $h;

    $h = {};
    $h->{'title_inp'} = "Object GUI Definition";
    $h->{'gui_inp'} = 
"
title|Name
brief|Brief
gui|GUI
gui_name|GUI Filename
";
    $h->{'gui_name_inp'} = "99002-A_gui";
    $defs[$i++] = $h;


    $h = {};
    $h->{'title_inp'} = "Variational Set GUI";
    $h->{'gui_inp'} = 
"
title|Name
brief|Brief
variant_set|Variational Set
";
    $h->{'gui_name_inp'} = "99004-A_gui";
    $defs[$i++] = $h;

    $h = {};
    $h->{'title_inp'} = "Warehouse";
    $h->{'gui_inp'} = 
"title|Name
brief|Brief
keywords|Keywords
status|Status";
    $h->{'gui_name_inp'} = "74003-A_gui";
    $defs[$i++] = $h;

    my ($error);

    foreach $hash (@defs) {
	$object_hashref = {};
	$object_hashref->{'objclass_inp'} = $site->{'OBJCLASSES'}->{'object'};
	$object_hashref->{'objtype_inp'} = $site->{'OBJTYPES'}->{'object'};
	$object_hashref->{'status_inp'} = "15000-A";
	$object_hashref->{'brief_inp'} = "This is an internal field for AllCommerce.";
	$object_hashref->{'language_inp'} = $site->{'om_render_lang'};
	$object_hashref->{'title_inp'} = $hash->{'title_inp'};
	$object_hashref->{'gui_inp'} = $hash->{'gui_inp'};
	$object_hashref->{'gui_name_inp'} = $hash->{'gui_name_inp'};
	$error = &create_object($object_hashref, $site, $dbh);
    }
}

######################### INITIALIZATION SUBROUTINES #######################

##############################################################################
=pod

=head2 initscript

initscript - ($site, $dbh) = &initscript();

=over 4

=item DESCRIPTION

Determine the relative path, and connect to the database

=item INPUT

none

=item OUTPUT

$site - A hashref containing information required throughout about the current
        site and session

$dbh - current active database handle

=item NOTES

=back

=cut
###############################################################################
sub initscript {
    my ($s, @temp, @rpath, $rundir, $siteshortname, $u, $scriptname, $relpath);
    my ($k, $dbh, $site);
    
    ## determine path from store (site) root and store db name...
    #
    #  note - this script runs at server root or in cgi-bin/om/admin,
    #    generally. Test these conditions first.
    #  $0 - may not contain a full path, bootstrap with "pwd"
    #
    if ( $0 !~ /^\// ) {  # $0 is not an absolute path
        $s=`pwd`;          # hope pwd on path...
        chomp $s;
        $s.="/$0";
        } else {              # $0 IS an absolute path
        $s=$0;
    } # done determining if $0 is relative or absolute
    @temp=split /\//, $s;
    
    @rpath=@temp;
    
    $scriptname = pop @rpath;
    $scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff
    
    $rundir= join "/", @rpath;
    chdir( $rundir );
    
    $relpath="";
    $siteshortname="";

    ## short circuit if $s does not contain tests
    if ( $s !~ /tests/ ) {
	$siteshortname = pop @rpath;
	$relpath=".";
	@temp=();
    } # done testing for degenerate case
    
    while ( @temp ) {
        $u = pop @temp;
        
        ## skip references to the present directory
        next if ( $u eq '.' );
        next if ( length($u)==0 );        # skip null directory levels
        
        $relpath.="/.." if ( $relpath);
        $relpath.="." if ( ! $relpath );
        
	if ( $u eq "tests" ) {
	    $siteshortname = $temp[$#temp];
	    @temp=();
	} # note - tests is off the site root, so the next up is site root        
    } # done constructing relative path to store root
    
    $relpath .= "/../$siteshortname";
    ($site, $dbh) = &initsite($scriptname, $relpath);
    $site->{'siteshortname'} = $siteshortname;
    
    return ($site, $dbh);
}

##############################################################################
=pod

=head2 initsite

initsite - ($site, $dbh) = &initsite($scriptname, $relpath);

=over 4

=item DESCRIPTION

The init site loads in all required library modules and creates the variables 
that are required throughout the script. 

=item INPUT

$scriptname - The name of the script (inventory.cgi)

$relpath - The relative path to files that must be required

=item OUTPUT

$site - A hashref containing information required throughout about the current
        site and session

$dbh - current active database handle

=item NOTES

To add parameters that need to be passed around to a lot of locations, add them
to the $site hashref.

To change the debug of the script, change $site->{'debug_level'} to one of the 
following values:

    0 - no debug

    1 - errors only

    2 - all SQL statements, warnings & errors

    3 - all of the above

To change the location of the debug log, change the value of $site->{'debug_log'}. 
Be sure to start it will >> to allow appending to the file.  To set the Generate
Page? button to be selected by default, change the $site->{'generate_default'} to
1.  To have it non-selected by default, change the $site->{'generate_default'} 
to 0.

=back

=cut
###############################################################################
sub initsite {
    my ($scriptname) = shift;
    my ($relpath) = shift;
    
    my ($find, $q, $interface, $sts, $h, $x, @temp, $n, $k);
    my ($session_lang, $script, $site, $dbh);
    my ($select_hash, $q2);

    use DBI;
    require "$relpath/conf/site.pm";
    require "$relpath/lib/conversions.pm";
    require "$relpath/lib/filetools.pm";
    require "$relpath/lib/formtools.pm";
    require "$relpath/lib/variant.pm";
    require "$relpath/lib/language.pm";
    require "$relpath/lib/admin_object.pm";
    require "$relpath/lib/localization.pm";
    require "$relpath/lib/objects.pm";
    require "$relpath/lib/permission_layer.pm";    
    require "$relpath/lib/db_layer.pm";
    require "$relpath/lib/language.pm";
    require "$relpath/lib/validate.pm";

    # must be the last require statement
    require "$relpath/lib/custom-lib.pm";
    
    ## establish site-specific parameters
    #
    $site=setsite();
    
    ## connect to database
    # system 6 database state, products, and customer tables are collapsed
    #
    $q = "$site->{'db_site_config'}";
    $dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});
    
    $site->{'om_render_lang'} = "";
    $site->{'om_render_lang'}=$site->{'om_locale_lang_def'} if ( ! $site->{'om_render_lang'} );
    $site->{'om_render_lang'}="eng" if ( ! $site->{'om_render_lang'} );
    $interface="html" if ( ! $interface );
    
    ## load messages
    $script=( split /\./, $scriptname )[0];

    # Configure all parameters to pass around in $site hash
    $site->{'selskeletonpath'} = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/html/sel";
    $site->{'skeletonpath'} = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/pages";
    $site->{'scriptpath'} = join "/", ( @temp[0..$n] );
    $site->{'script'} = ( split /\./, $scriptname )[0];
    $site->{'scriptname'} = $scriptname;
    $site->{'relpath'} = $relpath;
    $site->{'debug_level'} = 3;
    $site->{'debug_log'} = ">>/tmp/test_db";
    $site->{'sid'} = $site->{'sid'};
    $site->{'session_lang'} = $session_lang;
    $site->{'scriptinfo'} = "$site->{'scriptpath'}/$site->{'scriptname'}";
    $site->{'targetpath'}="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/transit/export/order";    
    ($site->{'OBJCLASSES'}, $site->{'OBJTYPES'}) = &getClassesAndTypes();
    # Flag, set to 0 to have default for Generate page? as no, and
    # set to 1 to have default as yes
    $site->{'generate_default'} = 0;
    $site->{'languageSensitive'} = "title,brief,keywords,author,descript,encoding";
    $site->{'inherit_from_master'} = "brief";

    &debug("Debuggin inventory.cgi...",3, $site->{'debug_level'}, ">/tmp/inventory");
    return ($site, $dbh);
}





