#/usr/bin/perl

use strict;
use DBI;

&main(@ARGV);

1;

sub main {
    my (@ARGV) = @_;
    
    my ($site, $dbh, $objid, $object_hashref, $key, $where_clause);
    my ($fields, @definitions);

    $objid = $ARGV[0];

    ($site, $dbh) = &initscript();
    &testLoadObjects($site, $dbh);

#    &testLoadObject($objid, $where_clause, $site, $dbh);

#    &testLoadObject($objid, $where_clause, $site, $dbh);
#    &testLoadTemplateDef($site);


}

sub testLoadObjects {
    my ($site) = shift;
    my ($dbh) = shift;

    my ($where, $fields, $tables, $numResults, $field);
    my ($next_start, @where, $row, @results, @p_results, $all_objects);
    my ($extras);

#    $where[0] = &build_where_hash("title", "%ra%", "or");
#    $where[1] = &build_where_hash("brief", "%ra%", "and");
#    $where[2] = &build_where_hash("uname", "%ra%", "and");
#    $where[3] = &build_where_hash("name", "%ra%", "and");

#    $field = "title,uname";
#    $tables = "things, contacts";

#    $field = "title";
#    $tables = "things";

#    $field = "title,uname,name,city";
#    $tables = "things, contacts,addresses";

#    $extras->{'keywords'} = "ra";

    $site->{'om_render_lang'} = "fra";
    ($tables, $fields, @where) = &build_load_objects_queries("ra", $extras, $site);

    $next_start = "go go";
    while ($next_start) {
	if ($next_start eq "go go") {
	    ($numResults, $next_start, @p_results) = &load_objects($tables, $fields, \@where, "", 3, $site, $dbh, 1);
	}
	else {
	    ($numResults, $next_start, @p_results) = &load_objects($tables, $fields, \@where, $next_start, 3, $site, $dbh, 1);
	}
	print "\nNext time start at $next_start\n";

	foreach $row (@p_results) {
	    &printHashref($row);
	    print "\n\n";
	}
	
	print "\n***************************************************\n";
	@p_results = undef @p_results;

    }

}

sub testLoadObject {
    my ($objid) = shift;
    my ($where_clause) = shift;
    my ($site) = shift;
    my ($dbh) = shift;

    my ($filtered_hashref, $object_hashref);;

    $site->{'permissions'} = {};
    $site->{'permissions'}->{'r'}->{'*'} = "*";
    $site->{'permissions'}->{'rc'}->{'102-A'} = "*";
    $site->{'permissions'}->{'rcmd'}->{'134-A'} = "*";    
    $site->{'permissions'}->{'rcmd'}->{'136-A'} = "*";
    $site->{'permissions'}->{'rcmd'}->{'*'} = "title,brief,descript";

    my @where_clause;
    $object_hashref = {};
    $object_hashref = &load_object($objid,  "", "", \@where_clause, $site, $dbh);
    &printHashref($object_hashref);
    print "\n------------------------------------------\n";
    $object_hashref = {};
    $object_hashref = &load_object($objid,  "", "", \@where_clause, $site, $dbh, 1);
    &printHashref($object_hashref);
    print "\n----------------------------------------------------------------------------------\n";

    $site->{'permissions'} = {};
    $site->{'permissions'}->{'rc'}->{'102-A'} = "*";
    $site->{'permissions'}->{'rcmd'}->{'136-A'} = "*";
    $site->{'permissions'}->{'rcmd'}->{'188-A'} = "visibility";
    $site->{'permissions'}->{'rcmd'}->{'*'} = "title,brief,descript";

    
    $where_clause[0] = &build_where_hash("status", "15000-A", "and");
    $object_hashref = {};
    $object_hashref = &load_object($objid, "things,prices", "title, brief, unitpr, objid, currency", \@where_clause, $site, $dbh);
    &printHashref($object_hashref);
    print "\n------------------------------------------\n";
    $object_hashref = {};
    $object_hashref = &load_object($objid, "things,prices", "title, brief, unitpr, objid, currency", \@where_clause, $site, $dbh, 1);
    &printHashref($object_hashref);
    print "\n----------------------------------------------------------------------------------\n";

    $site->{'permissions'} = {};
    $site->{'permissions'}->{'r'}->{'*'} = "*";
    $site->{'permissions'}->{'rc'}->{'102-A'} = "*";
    $site->{'permissions'}->{'rcmd'}->{'134-A'} = "*";    
    $site->{'permissions'}->{'rcmd'}->{'136-A'} = "*";
    $site->{'permissions'}->{'rcmd'}->{'*'} = "title,brief,descript";
    $site->{'permissions'}->{'x'}->{'188-A'} = "brief";

    $object_hashref = {};
    $where_clause[0] = &build_where_hash("status", "15000-A", "and");
    $object_hashref = &load_object($objid, "things,inventory", "lstock, descript, title, brief", \@where_clause, $site, $dbh);
    &printHashref($object_hashref);
    print "\n------------------------------------------\n";
    $object_hashref = {};
    $object_hashref = &load_object($objid, "things,inventory", "lstock, descript, title, brief", \@where_clause, $site, $dbh, 1);
    &printHashref($object_hashref);
    print "\n----------------------------------------------------------------------------------\n";


    $object_hashref = {};
    $object_hashref = &load_object($objid, "things", "title, author", \@where_clause, $site, $dbh);
    &printHashref($object_hashref);
    print "\n------------------------------------------\n";
    $object_hashref = {};
    $object_hashref = &load_object($objid, "things", "title, author", \@where_clause, $site, $dbh, 1);
    &printHashref($object_hashref);
    print "\n----------------------------------------------------------------------------------\n";

    $object_hashref = {};
    $object_hashref = &load_object($objid, "contacts", "uname,passwd,hint", \@where_clause, $site, $dbh);
    &printHashref($object_hashref);
    print "\n------------------------------------------\n";
    $object_hashref = {};
    $object_hashref = &load_object($objid, "contacts", "uname,passwd,hint", \@where_clause, $site, $dbh,1);
    &printHashref($object_hashref);
    print "\n----------------------------------------------------------------------------------\n";
}

sub testLoadTemplateDef {
    my ($site) = shift;

    my ($fields, @definitions);
    &loadObjectTemplateDef("", "45000-A", "", $site, \@definitions);
    foreach $fields (@definitions) {
	&printHashref($fields);
    }

    &loadObjectTemplateDef("", "47004-A", "", $site, \@definitions);
    foreach $fields (@definitions) {
	&printHashref($fields);
    }

}
######################### INITIALIZATION SUBROUTINES #######################

##############################################################################
=pod

=head2 initscript

initscript - ($site, $dbh) = &initscript();

=over 4

=item DESCRIPTION

Determine the relative path, and connect to the database

=item INPUT

none

=item OUTPUT

$site - A hashref containing information required throughout about the current
        site and session

$dbh - current active database handle

=item NOTES

=back

=cut
###############################################################################
sub initscript {
    my ($s, @temp, @rpath, $rundir, $siteshortname, $u, $scriptname, $relpath);
    my ($k, $dbh, $site);
    
    ## determine path from store (site) root and store db name...
    #
    #  note - this script runs at server root or in cgi-bin/om/admin,
    #    generally. Test these conditions first.
    #  $0 - may not contain a full path, bootstrap with "pwd"
    #
    if ( $0 !~ /^\// ) {  # $0 is not an absolute path
        $s=`pwd`;          # hope pwd on path...
        chomp $s;
        $s.="/$0";
        } else {              # $0 IS an absolute path
        $s=$0;
    } # done determining if $0 is relative or absolute
    @temp=split /\//, $s;
    
    @rpath=@temp;
    
    $scriptname = pop @rpath;
    $scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff
    
    $rundir= join "/", @rpath;
    chdir( $rundir );
    
    $relpath="";
    $siteshortname="";

    ## short circuit if $s does not contain tests
    if ( $s !~ /tests/ ) {
	$siteshortname = pop @rpath;
	$relpath=".";
	@temp=();
    } # done testing for degenerate case
    
    while ( @temp ) {
        $u = pop @temp;
        
        ## skip references to the present directory
        next if ( $u eq '.' );
        next if ( length($u)==0 );        # skip null directory levels
        
        $relpath.="/.." if ( $relpath);
        $relpath.="." if ( ! $relpath );
        
	if ( $u eq "tests" ) {
	    $siteshortname = $temp[$#temp];
	    @temp=();
	} # note - tests is off the site root, so the next up is site root        
    } # done constructing relative path to store root
    
    $relpath .= "/../$siteshortname";
    ($site, $dbh) = &initsite($scriptname, $relpath);
    $site->{'siteshortname'} = $siteshortname;
    
    return ($site, $dbh);
}

##############################################################################
=pod

=head2 initsite

initsite - ($site, $dbh) = &initsite($scriptname, $relpath);

=over 4

=item DESCRIPTION

The init site loads in all required library modules and creates the variables 
that are required throughout the script. 

=item INPUT

$scriptname - The name of the script (inventory.cgi)

$relpath - The relative path to files that must be required

=item OUTPUT

$site - A hashref containing information required throughout about the current
        site and session

$dbh - current active database handle

=item NOTES

To add parameters that need to be passed around to a lot of locations, add them
to the $site hashref.

To change the debug of the script, change $site->{'debug_level'} to one of the 
following values:

    0 - no debug

    1 - errors only

    2 - all SQL statements, warnings & errors

    3 - all of the above

To change the location of the debug log, change the value of $site->{'debug_log'}. 
Be sure to start it will >> to allow appending to the file.  To set the Generate
Page? button to be selected by default, change the $site->{'generate_default'} to
1.  To have it non-selected by default, change the $site->{'generate_default'} 
to 0.

=back

=cut
###############################################################################
sub initsite {
    my ($scriptname) = shift;
    my ($relpath) = shift;
    
    my ($find, $q, $interface, $sts, $h, $x, @temp, $n, $k);
    my ($session_lang, $script, $site, $dbh);
    my ($select_hash, $q2);

    use DBI;
    require "$relpath/conf/site.pm";
    require "$relpath/lib/conversions.pm";
    require "$relpath/lib/filetools.pm";
    require "$relpath/lib/formtools.pm";
    require "$relpath/lib/variant.pm";
    require "$relpath/lib/language.pm";
    require "$relpath/lib/admin_object.pm";
    require "$relpath/lib/localization.pm";
    require "$relpath/lib/objects.pm";
    require "$relpath/lib/permission_layer.pm";    
    require "$relpath/lib/db_layer.pm";
    
    # must be the last require statement
    require "$relpath/lib/custom-lib.pm";
    
    ## establish site-specific parameters
    #
    $site=setsite();
    
    ## connect to database
    # system 6 database state, products, and customer tables are collapsed
    #
    $q = "$site->{'db_site_config'}";
    $dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});
    
    $site->{'om_render_lang'} = "";
    $site->{'om_render_lang'}=$site->{'om_locale_lang_def'} if ( ! $site->{'om_render_lang'} );
    $site->{'om_render_lang'}="eng" if ( ! $site->{'om_render_lang'} );
    $interface="html" if ( ! $interface );
    
    ## load messages
    $script=( split /\./, $scriptname )[0];

    # Configure all parameters to pass around in $site hash
    $site->{'selskeletonpath'} = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/html/sel";
    $site->{'skeletonpath'} = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/pages";
    $site->{'scriptpath'} = join "/", ( @temp[0..$n] );
    $site->{'script'} = ( split /\./, $scriptname )[0];
    $site->{'scriptname'} = $scriptname;
    $site->{'relpath'} = $relpath;
    $site->{'debug_level'} = 3;
    $site->{'debug_log'} = ">>/tmp/test_loadobject";
    $site->{'sid'} = $site->{'sid'};
    $site->{'session_lang'} = $session_lang;
    $site->{'scriptinfo'} = "$site->{'scriptpath'}/$site->{'scriptname'}";
    $site->{'targetpath'}="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/transit/export/order";    
    ($site->{'OBJCLASSES'}, $site->{'OBJTYPES'}) = &getClassesAndTypes();
    # Flag, set to 0 to have default for Generate page? as no, and
    # set to 1 to have default as yes
    $site->{'generate_default'} = 0;
    $site->{'languageSensitive'} = "title,brief,keywords,author,descript,encoding";
    $site->{'inherit_from_master'} = "brief";

    &debug("Debuggin inventory.cgi...",3, $site->{'debug_level'}, ">/tmp/inventory");
    return ($site, $dbh);
}










